/* number-picker.c generated by valac 0.42.3, the Vala compiler
 * generated from number-picker.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "libsudoku.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
enum  {
	NUMBER_PICKER_0_PROPERTY,
	NUMBER_PICKER_NUM_PROPERTIES
};
static GParamSpec* number_picker_properties[NUMBER_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block5Data Block5Data;
enum  {
	NUMBER_PICKER_NUMBER_PICKED_SIGNAL,
	NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL,
	NUMBER_PICKER_NUM_SIGNALS
};
static guint number_picker_signals[NUMBER_PICKER_NUM_SIGNALS] = {0};

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _NumberPickerPrivate {
	SudokuBoard* board;
	GtkButton* clear_button;
	gint earmarks_active;
};

struct _Block4Data {
	int _ref_count_;
	NumberPicker* self;
	gint n;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GtkToggleButton* toggle_button;
};


static gint NumberPicker_private_offset;
static gpointer number_picker_parent_class = NULL;

GType number_picker_get_type (void) G_GNUC_CONST;
#define NUMBER_PICKER_EARMARKS_MAX_ALLOWED 5
NumberPicker* number_picker_new (SudokuBoard* * board,
                                 gboolean earmark);
NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard* * board,
                                       gboolean earmark);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _________lambda4_ (Block4Data* _data4_);
static void __________lambda4__gtk_button_clicked (GtkButton* _sender,
                                            gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _________lambda5_ (Block5Data* _data5_);
static void number_picker_set_toggle_sensitive (NumberPicker* self,
                                         gboolean state);
static void __________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                   gpointer self);
static void ___lambda6_ (NumberPicker* self);
static void ____lambda6__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
gboolean number_picker_set_earmark (NumberPicker* self,
                                    gint row,
                                    gint col,
                                    gint index,
                                    gboolean state);
static void g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void number_picker_finalize (GObject * obj);


static inline gpointer
number_picker_get_instance_private (NumberPicker* self)
{
	return G_STRUCT_MEMBER_P (self, NumberPicker_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/number-picker.vala"
	return self ? g_object_ref (self) : NULL;
#line 146 "number-picker.c"
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 43 "../src/number-picker.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 43 "../src/number-picker.vala"
	return _data4_;
#line 157 "number-picker.c"
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 43 "../src/number-picker.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 168 "number-picker.c"
		NumberPicker* self;
#line 43 "../src/number-picker.vala"
		self = _data4_->self;
#line 43 "../src/number-picker.vala"
		_g_object_unref0 (self);
#line 43 "../src/number-picker.vala"
		g_slice_free (Block4Data, _data4_);
#line 176 "number-picker.c"
	}
}


static void
_________lambda4_ (Block4Data* _data4_)
{
	NumberPicker* self;
	gint _tmp0_;
#line 60 "../src/number-picker.vala"
	self = _data4_->self;
#line 61 "../src/number-picker.vala"
	_tmp0_ = _data4_->n;
#line 61 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, _tmp0_);
#line 192 "number-picker.c"
}


static void
__________lambda4__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self)
{
#line 60 "../src/number-picker.vala"
	_________lambda4_ (self);
#line 202 "number-picker.c"
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 59 "../src/number-picker.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 59 "../src/number-picker.vala"
	return _data5_;
#line 213 "number-picker.c"
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 59 "../src/number-picker.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 224 "number-picker.c"
		NumberPicker* self;
#line 59 "../src/number-picker.vala"
		self = _data5_->_data4_->self;
#line 59 "../src/number-picker.vala"
		_g_object_unref0 (_data5_->toggle_button);
#line 59 "../src/number-picker.vala"
		block4_data_unref (_data5_->_data4_);
#line 59 "../src/number-picker.vala"
		_data5_->_data4_ = NULL;
#line 59 "../src/number-picker.vala"
		g_slice_free (Block5Data, _data5_);
#line 236 "number-picker.c"
	}
}


static void
_________lambda5_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	NumberPicker* self;
	gboolean toggle_active = FALSE;
	GtkToggleButton* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	gint _tmp7_;
#line 66 "../src/number-picker.vala"
	_data4_ = _data5_->_data4_;
#line 66 "../src/number-picker.vala"
	self = _data4_->self;
#line 67 "../src/number-picker.vala"
	_tmp0_ = _data5_->toggle_button;
#line 67 "../src/number-picker.vala"
	toggle_active = gtk_toggle_button_get_active (_tmp0_);
#line 68 "../src/number-picker.vala"
	_tmp1_ = _data4_->n;
#line 68 "../src/number-picker.vala"
	_tmp2_ = toggle_active;
#line 68 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL], 0, _tmp1_, _tmp2_);
#line 69 "../src/number-picker.vala"
	_tmp4_ = toggle_active;
#line 69 "../src/number-picker.vala"
	if (_tmp4_) {
#line 271 "number-picker.c"
		gint _tmp5_;
#line 69 "../src/number-picker.vala"
		_tmp5_ = self->priv->earmarks_active;
#line 69 "../src/number-picker.vala"
		_tmp3_ = _tmp5_ + 1;
#line 277 "number-picker.c"
	} else {
		gint _tmp6_;
#line 69 "../src/number-picker.vala"
		_tmp6_ = self->priv->earmarks_active;
#line 69 "../src/number-picker.vala"
		_tmp3_ = _tmp6_ - 1;
#line 284 "number-picker.c"
	}
#line 69 "../src/number-picker.vala"
	self->priv->earmarks_active = _tmp3_;
#line 70 "../src/number-picker.vala"
	_tmp7_ = self->priv->earmarks_active;
#line 70 "../src/number-picker.vala"
	if (_tmp7_ < NUMBER_PICKER_EARMARKS_MAX_ALLOWED) {
#line 71 "../src/number-picker.vala"
		number_picker_set_toggle_sensitive (self, TRUE);
#line 294 "number-picker.c"
	} else {
#line 73 "../src/number-picker.vala"
		number_picker_set_toggle_sensitive (self, FALSE);
#line 298 "number-picker.c"
	}
}


static void
__________lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                              gpointer self)
{
#line 66 "../src/number-picker.vala"
	_________lambda5_ (self);
#line 309 "number-picker.c"
}


static void
___lambda6_ (NumberPicker* self)
{
#line 96 "../src/number-picker.vala"
	g_signal_emit (self, number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL], 0, 0);
#line 318 "number-picker.c"
}


static void
____lambda6__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 95 "../src/number-picker.vala"
	___lambda6_ ((NumberPicker*) self);
#line 328 "number-picker.c"
}


NumberPicker*
number_picker_construct (GType object_type,
                         SudokuBoard* * board,
                         gboolean earmark)
{
	NumberPicker * self = NULL;
	SudokuBoard* _tmp0_;
#line 36 "../src/number-picker.vala"
	g_return_val_if_fail (*board != NULL, NULL);
#line 36 "../src/number-picker.vala"
	self = (NumberPicker*) g_object_new (object_type, NULL);
#line 38 "../src/number-picker.vala"
	_tmp0_ = _g_object_ref0 (*board);
#line 38 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 38 "../src/number-picker.vala"
	self->priv->board = _tmp0_;
#line 39 "../src/number-picker.vala"
	self->priv->earmarks_active = 0;
#line 351 "number-picker.c"
	{
		gint col = 0;
#line 41 "../src/number-picker.vala"
		col = 0;
#line 356 "number-picker.c"
		{
			gboolean _tmp1_ = FALSE;
#line 41 "../src/number-picker.vala"
			_tmp1_ = TRUE;
#line 41 "../src/number-picker.vala"
			while (TRUE) {
#line 363 "number-picker.c"
				gint _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 41 "../src/number-picker.vala"
				if (!_tmp1_) {
#line 369 "number-picker.c"
					gint _tmp2_;
#line 41 "../src/number-picker.vala"
					_tmp2_ = col;
#line 41 "../src/number-picker.vala"
					col = _tmp2_ + 1;
#line 375 "number-picker.c"
				}
#line 41 "../src/number-picker.vala"
				_tmp1_ = FALSE;
#line 41 "../src/number-picker.vala"
				_tmp3_ = col;
#line 41 "../src/number-picker.vala"
				_tmp4_ = sudoku_board_get_block_cols (*board);
#line 41 "../src/number-picker.vala"
				_tmp5_ = _tmp4_;
#line 41 "../src/number-picker.vala"
				if (!(_tmp3_ < _tmp5_)) {
#line 41 "../src/number-picker.vala"
					break;
#line 389 "number-picker.c"
				}
				{
					gint row = 0;
#line 43 "../src/number-picker.vala"
					row = 0;
#line 395 "number-picker.c"
					{
						gboolean _tmp6_ = FALSE;
#line 43 "../src/number-picker.vala"
						_tmp6_ = TRUE;
#line 43 "../src/number-picker.vala"
						while (TRUE) {
#line 402 "number-picker.c"
							Block4Data* _data4_;
							gint _tmp8_;
							gint _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							gint _tmp14_;
							GtkButton* _tmp15_ = NULL;
							GtkButton* button = NULL;
							GtkButton* _tmp18_;
							GtkButton* _tmp19_;
							GtkButton* _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							GtkLabel* label = NULL;
							gint _tmp23_;
							gchar* _tmp24_;
							gchar* _tmp25_;
							GtkLabel* _tmp26_;
							GtkLabel* _tmp27_;
							GtkLabel* _tmp28_;
							GtkLabel* _tmp29_;
							GtkLabel* _tmp30_;
							GtkLabel* _tmp31_;
							GtkButton* _tmp32_;
							GtkLabel* _tmp33_;
							GtkLabel* _tmp34_;
							gint _tmp39_;
							GtkButton* _tmp41_;
#line 43 "../src/number-picker.vala"
							_data4_ = g_slice_new0 (Block4Data);
#line 43 "../src/number-picker.vala"
							_data4_->_ref_count_ = 1;
#line 43 "../src/number-picker.vala"
							_data4_->self = g_object_ref (self);
#line 43 "../src/number-picker.vala"
							if (!_tmp6_) {
#line 441 "number-picker.c"
								gint _tmp7_;
#line 43 "../src/number-picker.vala"
								_tmp7_ = row;
#line 43 "../src/number-picker.vala"
								row = _tmp7_ + 1;
#line 447 "number-picker.c"
							}
#line 43 "../src/number-picker.vala"
							_tmp6_ = FALSE;
#line 43 "../src/number-picker.vala"
							_tmp8_ = row;
#line 43 "../src/number-picker.vala"
							_tmp9_ = sudoku_board_get_block_rows (*board);
#line 43 "../src/number-picker.vala"
							_tmp10_ = _tmp9_;
#line 43 "../src/number-picker.vala"
							if (!(_tmp8_ < _tmp10_)) {
#line 43 "../src/number-picker.vala"
								block4_data_unref (_data4_);
#line 43 "../src/number-picker.vala"
								_data4_ = NULL;
#line 43 "../src/number-picker.vala"
								break;
#line 465 "number-picker.c"
							}
#line 45 "../src/number-picker.vala"
							_tmp11_ = col;
#line 45 "../src/number-picker.vala"
							_tmp12_ = row;
#line 45 "../src/number-picker.vala"
							_tmp13_ = sudoku_board_get_block_cols (*board);
#line 45 "../src/number-picker.vala"
							_tmp14_ = _tmp13_;
#line 45 "../src/number-picker.vala"
							_data4_->n = (_tmp11_ + (_tmp12_ * _tmp14_)) + 1;
#line 47 "../src/number-picker.vala"
							if (earmark) {
#line 479 "number-picker.c"
								GtkToggleButton* _tmp16_;
#line 47 "../src/number-picker.vala"
								_tmp16_ = (GtkToggleButton*) gtk_toggle_button_new ();
#line 47 "../src/number-picker.vala"
								g_object_ref_sink (_tmp16_);
#line 47 "../src/number-picker.vala"
								_g_object_unref0 (_tmp15_);
#line 47 "../src/number-picker.vala"
								_tmp15_ = (GtkButton*) _tmp16_;
#line 489 "number-picker.c"
							} else {
								GtkButton* _tmp17_;
#line 47 "../src/number-picker.vala"
								_tmp17_ = (GtkButton*) gtk_button_new ();
#line 47 "../src/number-picker.vala"
								g_object_ref_sink (_tmp17_);
#line 47 "../src/number-picker.vala"
								_g_object_unref0 (_tmp15_);
#line 47 "../src/number-picker.vala"
								_tmp15_ = _tmp17_;
#line 500 "number-picker.c"
							}
#line 47 "../src/number-picker.vala"
							_tmp18_ = _g_object_ref0 (_tmp15_);
#line 47 "../src/number-picker.vala"
							button = _tmp18_;
#line 48 "../src/number-picker.vala"
							_tmp19_ = button;
#line 48 "../src/number-picker.vala"
							gtk_widget_set_focus_on_click ((GtkWidget*) _tmp19_, FALSE);
#line 49 "../src/number-picker.vala"
							_tmp20_ = button;
#line 49 "../src/number-picker.vala"
							_tmp21_ = col;
#line 49 "../src/number-picker.vala"
							_tmp22_ = row;
#line 49 "../src/number-picker.vala"
							gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp20_, _tmp21_, _tmp22_, 1, 1);
#line 51 "../src/number-picker.vala"
							_tmp23_ = _data4_->n;
#line 51 "../src/number-picker.vala"
							_tmp24_ = g_strdup_printf ("<big>%d</big>", _tmp23_);
#line 51 "../src/number-picker.vala"
							_tmp25_ = _tmp24_;
#line 51 "../src/number-picker.vala"
							_tmp26_ = (GtkLabel*) gtk_label_new (_tmp25_);
#line 51 "../src/number-picker.vala"
							g_object_ref_sink (_tmp26_);
#line 51 "../src/number-picker.vala"
							_tmp27_ = _tmp26_;
#line 51 "../src/number-picker.vala"
							_g_free0 (_tmp25_);
#line 51 "../src/number-picker.vala"
							label = _tmp27_;
#line 52 "../src/number-picker.vala"
							_tmp28_ = label;
#line 52 "../src/number-picker.vala"
							gtk_label_set_use_markup (_tmp28_, TRUE);
#line 53 "../src/number-picker.vala"
							_tmp29_ = label;
#line 53 "../src/number-picker.vala"
							g_object_set ((GtkWidget*) _tmp29_, "margin", 4, NULL);
#line 54 "../src/number-picker.vala"
							_tmp30_ = label;
#line 54 "../src/number-picker.vala"
							gtk_widget_set_margin_start ((GtkWidget*) _tmp30_, 8);
#line 55 "../src/number-picker.vala"
							_tmp31_ = label;
#line 55 "../src/number-picker.vala"
							gtk_widget_set_margin_end ((GtkWidget*) _tmp31_, 8);
#line 56 "../src/number-picker.vala"
							_tmp32_ = button;
#line 56 "../src/number-picker.vala"
							_tmp33_ = label;
#line 56 "../src/number-picker.vala"
							gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
#line 57 "../src/number-picker.vala"
							_tmp34_ = label;
#line 57 "../src/number-picker.vala"
							gtk_widget_show ((GtkWidget*) _tmp34_);
#line 59 "../src/number-picker.vala"
							if (!earmark) {
#line 562 "number-picker.c"
								GtkButton* _tmp35_;
#line 60 "../src/number-picker.vala"
								_tmp35_ = button;
#line 60 "../src/number-picker.vala"
								g_signal_connect_data (_tmp35_, "clicked", (GCallback) __________lambda4__gtk_button_clicked, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 568 "number-picker.c"
							} else {
								Block5Data* _data5_;
								GtkButton* _tmp36_;
								GtkToggleButton* _tmp37_;
								GtkToggleButton* _tmp38_;
#line 59 "../src/number-picker.vala"
								_data5_ = g_slice_new0 (Block5Data);
#line 59 "../src/number-picker.vala"
								_data5_->_ref_count_ = 1;
#line 59 "../src/number-picker.vala"
								_data5_->_data4_ = block4_data_ref (_data4_);
#line 65 "../src/number-picker.vala"
								_tmp36_ = button;
#line 65 "../src/number-picker.vala"
								_tmp37_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 65 "../src/number-picker.vala"
								_data5_->toggle_button = _tmp37_;
#line 66 "../src/number-picker.vala"
								_tmp38_ = _data5_->toggle_button;
#line 66 "../src/number-picker.vala"
								g_signal_connect_data (_tmp38_, "toggled", (GCallback) __________lambda5__gtk_toggle_button_toggled, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 59 "../src/number-picker.vala"
								block5_data_unref (_data5_);
#line 59 "../src/number-picker.vala"
								_data5_ = NULL;
#line 594 "number-picker.c"
							}
#line 77 "../src/number-picker.vala"
							_tmp39_ = _data4_->n;
#line 77 "../src/number-picker.vala"
							if (_tmp39_ == 5) {
#line 600 "number-picker.c"
								GtkButton* _tmp40_;
#line 78 "../src/number-picker.vala"
								_tmp40_ = button;
#line 78 "../src/number-picker.vala"
								gtk_widget_grab_focus ((GtkWidget*) _tmp40_);
#line 606 "number-picker.c"
							}
#line 80 "../src/number-picker.vala"
							_tmp41_ = button;
#line 80 "../src/number-picker.vala"
							gtk_widget_show ((GtkWidget*) _tmp41_);
#line 43 "../src/number-picker.vala"
							_g_object_unref0 (label);
#line 43 "../src/number-picker.vala"
							_g_object_unref0 (button);
#line 43 "../src/number-picker.vala"
							_g_object_unref0 (_tmp15_);
#line 43 "../src/number-picker.vala"
							block4_data_unref (_data4_);
#line 43 "../src/number-picker.vala"
							_data4_ = NULL;
#line 622 "number-picker.c"
						}
					}
				}
			}
		}
	}
#line 84 "../src/number-picker.vala"
	if (!earmark) {
#line 631 "number-picker.c"
		GtkButton* _tmp42_;
		GtkButton* _tmp43_;
		GtkButton* _tmp44_;
		GtkLabel* label = NULL;
		gchar* _tmp45_;
		gchar* _tmp46_;
		GtkLabel* _tmp47_;
		GtkLabel* _tmp48_;
		GtkLabel* _tmp49_;
		GtkButton* _tmp50_;
		GtkLabel* _tmp51_;
		GtkLabel* _tmp52_;
		GtkButton* _tmp53_;
#line 86 "../src/number-picker.vala"
		_tmp42_ = (GtkButton*) gtk_button_new ();
#line 86 "../src/number-picker.vala"
		g_object_ref_sink (_tmp42_);
#line 86 "../src/number-picker.vala"
		_g_object_unref0 (self->priv->clear_button);
#line 86 "../src/number-picker.vala"
		self->priv->clear_button = _tmp42_;
#line 87 "../src/number-picker.vala"
		_tmp43_ = self->priv->clear_button;
#line 87 "../src/number-picker.vala"
		gtk_widget_set_focus_on_click ((GtkWidget*) _tmp43_, FALSE);
#line 88 "../src/number-picker.vala"
		_tmp44_ = self->priv->clear_button;
#line 88 "../src/number-picker.vala"
		gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp44_, 0, 4, 3, 1);
#line 90 "../src/number-picker.vala"
		_tmp45_ = g_strdup_printf ("<big>%s</big>", _ ("Clear"));
#line 90 "../src/number-picker.vala"
		_tmp46_ = _tmp45_;
#line 90 "../src/number-picker.vala"
		_tmp47_ = (GtkLabel*) gtk_label_new (_tmp46_);
#line 90 "../src/number-picker.vala"
		g_object_ref_sink (_tmp47_);
#line 90 "../src/number-picker.vala"
		_tmp48_ = _tmp47_;
#line 90 "../src/number-picker.vala"
		_g_free0 (_tmp46_);
#line 90 "../src/number-picker.vala"
		label = _tmp48_;
#line 91 "../src/number-picker.vala"
		_tmp49_ = label;
#line 91 "../src/number-picker.vala"
		gtk_label_set_use_markup (_tmp49_, TRUE);
#line 92 "../src/number-picker.vala"
		_tmp50_ = self->priv->clear_button;
#line 92 "../src/number-picker.vala"
		_tmp51_ = label;
#line 92 "../src/number-picker.vala"
		gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
#line 93 "../src/number-picker.vala"
		_tmp52_ = label;
#line 93 "../src/number-picker.vala"
		gtk_widget_show ((GtkWidget*) _tmp52_);
#line 95 "../src/number-picker.vala"
		_tmp53_ = self->priv->clear_button;
#line 95 "../src/number-picker.vala"
		g_signal_connect_object (_tmp53_, "clicked", (GCallback) ____lambda6__gtk_button_clicked, self, 0);
#line 84 "../src/number-picker.vala"
		_g_object_unref0 (label);
#line 695 "number-picker.c"
	}
#line 100 "../src/number-picker.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 101 "../src/number-picker.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
#line 102 "../src/number-picker.vala"
	g_object_set ((GtkWidget*) self, "margin", 2, NULL);
#line 103 "../src/number-picker.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 3);
#line 104 "../src/number-picker.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 3);
#line 105 "../src/number-picker.vala"
	gtk_widget_show ((GtkWidget*) self);
#line 36 "../src/number-picker.vala"
	return self;
#line 711 "number-picker.c"
}


NumberPicker*
number_picker_new (SudokuBoard* * board,
                   gboolean earmark)
{
#line 36 "../src/number-picker.vala"
	return number_picker_construct (TYPE_NUMBER_PICKER, board, earmark);
#line 721 "number-picker.c"
}


void
number_picker_set_clear_button_visibility (NumberPicker* self,
                                           gboolean visible)
{
#line 108 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/number-picker.vala"
	if (visible) {
#line 733 "number-picker.c"
		GtkButton* _tmp0_;
#line 111 "../src/number-picker.vala"
		_tmp0_ = self->priv->clear_button;
#line 111 "../src/number-picker.vala"
		gtk_widget_show ((GtkWidget*) _tmp0_);
#line 739 "number-picker.c"
	} else {
		GtkButton* _tmp1_;
#line 113 "../src/number-picker.vala"
		_tmp1_ = self->priv->clear_button;
#line 113 "../src/number-picker.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 746 "number-picker.c"
	}
}


void
number_picker_set_earmarks (NumberPicker* self,
                            gint row,
                            gint col)
{
#line 116 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 758 "number-picker.c"
	{
		gint i = 0;
#line 118 "../src/number-picker.vala"
		i = 0;
#line 763 "number-picker.c"
		{
			gboolean _tmp0_ = FALSE;
#line 118 "../src/number-picker.vala"
			_tmp0_ = TRUE;
#line 118 "../src/number-picker.vala"
			while (TRUE) {
#line 770 "number-picker.c"
				gint _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				SudokuBoard* _tmp7_;
				gint _tmp8_;
#line 118 "../src/number-picker.vala"
				if (!_tmp0_) {
#line 780 "number-picker.c"
					gint _tmp1_;
#line 118 "../src/number-picker.vala"
					_tmp1_ = i;
#line 118 "../src/number-picker.vala"
					i = _tmp1_ + 1;
#line 786 "number-picker.c"
				}
#line 118 "../src/number-picker.vala"
				_tmp0_ = FALSE;
#line 118 "../src/number-picker.vala"
				_tmp2_ = i;
#line 118 "../src/number-picker.vala"
				_tmp3_ = self->priv->board;
#line 118 "../src/number-picker.vala"
				_tmp4_ = sudoku_board_get_max_val (_tmp3_);
#line 118 "../src/number-picker.vala"
				_tmp5_ = _tmp4_;
#line 118 "../src/number-picker.vala"
				if (!(_tmp2_ < _tmp5_)) {
#line 118 "../src/number-picker.vala"
					break;
#line 802 "number-picker.c"
				}
#line 119 "../src/number-picker.vala"
				_tmp6_ = i;
#line 119 "../src/number-picker.vala"
				_tmp7_ = self->priv->board;
#line 119 "../src/number-picker.vala"
				_tmp8_ = i;
#line 119 "../src/number-picker.vala"
				number_picker_set_earmark (self, row, col, _tmp6_, sudoku_board_is_earmark_enabled (_tmp7_, row, col, _tmp8_ + 1));
#line 812 "number-picker.c"
			}
		}
	}
}


gboolean
number_picker_set_earmark (NumberPicker* self,
                           gint row,
                           gint col,
                           gint index,
                           gboolean state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkToggleButton* button = NULL;
	SudokuBoard* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	SudokuBoard* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkWidget* _tmp8_;
	GtkToggleButton* _tmp9_;
	GtkToggleButton* _tmp10_;
#line 122 "../src/number-picker.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 124 "../src/number-picker.vala"
	if (state) {
#line 842 "number-picker.c"
		gint _tmp1_;
#line 124 "../src/number-picker.vala"
		_tmp1_ = self->priv->earmarks_active;
#line 124 "../src/number-picker.vala"
		_tmp0_ = _tmp1_ >= NUMBER_PICKER_EARMARKS_MAX_ALLOWED;
#line 848 "number-picker.c"
	} else {
#line 124 "../src/number-picker.vala"
		_tmp0_ = FALSE;
#line 852 "number-picker.c"
	}
#line 124 "../src/number-picker.vala"
	if (_tmp0_) {
#line 125 "../src/number-picker.vala"
		result = FALSE;
#line 125 "../src/number-picker.vala"
		return result;
#line 860 "number-picker.c"
	}
#line 126 "../src/number-picker.vala"
	_tmp2_ = self->priv->board;
#line 126 "../src/number-picker.vala"
	_tmp3_ = sudoku_board_get_block_cols (_tmp2_);
#line 126 "../src/number-picker.vala"
	_tmp4_ = _tmp3_;
#line 126 "../src/number-picker.vala"
	_tmp5_ = self->priv->board;
#line 126 "../src/number-picker.vala"
	_tmp6_ = sudoku_board_get_block_rows (_tmp5_);
#line 126 "../src/number-picker.vala"
	_tmp7_ = _tmp6_;
#line 126 "../src/number-picker.vala"
	_tmp8_ = gtk_grid_get_child_at ((GtkGrid*) self, index % _tmp4_, index / _tmp7_);
#line 126 "../src/number-picker.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 126 "../src/number-picker.vala"
	button = _tmp9_;
#line 127 "../src/number-picker.vala"
	_tmp10_ = button;
#line 127 "../src/number-picker.vala"
	gtk_toggle_button_set_active (_tmp10_, state);
#line 128 "../src/number-picker.vala"
	result = TRUE;
#line 128 "../src/number-picker.vala"
	_g_object_unref0 (button);
#line 128 "../src/number-picker.vala"
	return result;
#line 890 "number-picker.c"
}


static void
number_picker_set_toggle_sensitive (NumberPicker* self,
                                    gboolean state)
{
#line 131 "../src/number-picker.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/number-picker.vala"
	if (state) {
#line 902 "number-picker.c"
		{
			gint i = 0;
#line 134 "../src/number-picker.vala"
			i = 0;
#line 907 "number-picker.c"
			{
				gboolean _tmp0_ = FALSE;
#line 134 "../src/number-picker.vala"
				_tmp0_ = TRUE;
#line 134 "../src/number-picker.vala"
				while (TRUE) {
#line 914 "number-picker.c"
					gint _tmp2_;
					SudokuBoard* _tmp3_;
					gint _tmp4_;
					gint _tmp5_;
					gint _tmp6_;
					SudokuBoard* _tmp7_;
					gint _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					SudokuBoard* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					GtkWidget* _tmp14_;
#line 134 "../src/number-picker.vala"
					if (!_tmp0_) {
#line 930 "number-picker.c"
						gint _tmp1_;
#line 134 "../src/number-picker.vala"
						_tmp1_ = i;
#line 134 "../src/number-picker.vala"
						i = _tmp1_ + 1;
#line 936 "number-picker.c"
					}
#line 134 "../src/number-picker.vala"
					_tmp0_ = FALSE;
#line 134 "../src/number-picker.vala"
					_tmp2_ = i;
#line 134 "../src/number-picker.vala"
					_tmp3_ = self->priv->board;
#line 134 "../src/number-picker.vala"
					_tmp4_ = sudoku_board_get_max_val (_tmp3_);
#line 134 "../src/number-picker.vala"
					_tmp5_ = _tmp4_;
#line 134 "../src/number-picker.vala"
					if (!(_tmp2_ < _tmp5_)) {
#line 134 "../src/number-picker.vala"
						break;
#line 952 "number-picker.c"
					}
#line 135 "../src/number-picker.vala"
					_tmp6_ = i;
#line 135 "../src/number-picker.vala"
					_tmp7_ = self->priv->board;
#line 135 "../src/number-picker.vala"
					_tmp8_ = sudoku_board_get_block_cols (_tmp7_);
#line 135 "../src/number-picker.vala"
					_tmp9_ = _tmp8_;
#line 135 "../src/number-picker.vala"
					_tmp10_ = i;
#line 135 "../src/number-picker.vala"
					_tmp11_ = self->priv->board;
#line 135 "../src/number-picker.vala"
					_tmp12_ = sudoku_board_get_block_rows (_tmp11_);
#line 135 "../src/number-picker.vala"
					_tmp13_ = _tmp12_;
#line 135 "../src/number-picker.vala"
					_tmp14_ = gtk_grid_get_child_at ((GtkGrid*) self, _tmp6_ % _tmp9_, _tmp10_ / _tmp13_);
#line 135 "../src/number-picker.vala"
					gtk_widget_set_sensitive (_tmp14_, TRUE);
#line 974 "number-picker.c"
				}
			}
		}
	} else {
		{
			gint i = 0;
#line 137 "../src/number-picker.vala"
			i = 0;
#line 983 "number-picker.c"
			{
				gboolean _tmp15_ = FALSE;
#line 137 "../src/number-picker.vala"
				_tmp15_ = TRUE;
#line 137 "../src/number-picker.vala"
				while (TRUE) {
#line 990 "number-picker.c"
					gint _tmp17_;
					SudokuBoard* _tmp18_;
					gint _tmp19_;
					gint _tmp20_;
					GtkToggleButton* button = NULL;
					gint _tmp21_;
					SudokuBoard* _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					gint _tmp25_;
					SudokuBoard* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					GtkWidget* _tmp29_;
					GtkToggleButton* _tmp30_;
					GtkToggleButton* _tmp31_;
					gboolean _tmp32_;
					gboolean _tmp33_;
#line 137 "../src/number-picker.vala"
					if (!_tmp15_) {
#line 1011 "number-picker.c"
						gint _tmp16_;
#line 137 "../src/number-picker.vala"
						_tmp16_ = i;
#line 137 "../src/number-picker.vala"
						i = _tmp16_ + 1;
#line 1017 "number-picker.c"
					}
#line 137 "../src/number-picker.vala"
					_tmp15_ = FALSE;
#line 137 "../src/number-picker.vala"
					_tmp17_ = i;
#line 137 "../src/number-picker.vala"
					_tmp18_ = self->priv->board;
#line 137 "../src/number-picker.vala"
					_tmp19_ = sudoku_board_get_max_val (_tmp18_);
#line 137 "../src/number-picker.vala"
					_tmp20_ = _tmp19_;
#line 137 "../src/number-picker.vala"
					if (!(_tmp17_ < _tmp20_)) {
#line 137 "../src/number-picker.vala"
						break;
#line 1033 "number-picker.c"
					}
#line 139 "../src/number-picker.vala"
					_tmp21_ = i;
#line 139 "../src/number-picker.vala"
					_tmp22_ = self->priv->board;
#line 139 "../src/number-picker.vala"
					_tmp23_ = sudoku_board_get_block_cols (_tmp22_);
#line 139 "../src/number-picker.vala"
					_tmp24_ = _tmp23_;
#line 139 "../src/number-picker.vala"
					_tmp25_ = i;
#line 139 "../src/number-picker.vala"
					_tmp26_ = self->priv->board;
#line 139 "../src/number-picker.vala"
					_tmp27_ = sudoku_board_get_block_rows (_tmp26_);
#line 139 "../src/number-picker.vala"
					_tmp28_ = _tmp27_;
#line 139 "../src/number-picker.vala"
					_tmp29_ = gtk_grid_get_child_at ((GtkGrid*) self, _tmp21_ % _tmp24_, _tmp25_ / _tmp28_);
#line 139 "../src/number-picker.vala"
					_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 139 "../src/number-picker.vala"
					button = _tmp30_;
#line 140 "../src/number-picker.vala"
					_tmp31_ = button;
#line 140 "../src/number-picker.vala"
					_tmp32_ = gtk_toggle_button_get_active (_tmp31_);
#line 140 "../src/number-picker.vala"
					_tmp33_ = _tmp32_;
#line 140 "../src/number-picker.vala"
					if (!_tmp33_) {
#line 1065 "number-picker.c"
						GtkToggleButton* _tmp34_;
#line 141 "../src/number-picker.vala"
						_tmp34_ = button;
#line 141 "../src/number-picker.vala"
						gtk_widget_set_sensitive ((GtkWidget*) _tmp34_, FALSE);
#line 1071 "number-picker.c"
					}
#line 137 "../src/number-picker.vala"
					_g_object_unref0 (button);
#line 1075 "number-picker.c"
				}
			}
		}
	}
}


static void
g_cclosure_user_marshal_VOID__INT_BOOLEAN (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_BOOLEAN) (gpointer data1, gint arg_1, gboolean arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/number-picker.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../src/number-picker.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/number-picker.vala"
		data1 = closure->data;
#line 24 "../src/number-picker.vala"
		data2 = param_values->data[0].v_pointer;
#line 1105 "number-picker.c"
	} else {
#line 24 "../src/number-picker.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/number-picker.vala"
		data2 = closure->data;
#line 1111 "number-picker.c"
	}
#line 24 "../src/number-picker.vala"
	callback = (GMarshalFunc_VOID__INT_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/number-picker.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_boolean (param_values + 2), data2);
#line 1117 "number-picker.c"
}


static void
number_picker_class_init (NumberPickerClass * klass)
{
#line 24 "../src/number-picker.vala"
	number_picker_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/number-picker.vala"
	g_type_class_adjust_private_offset (klass, &NumberPicker_private_offset);
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (klass)->finalize = number_picker_finalize;
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_NUMBER_PICKED_SIGNAL] = g_signal_new ("number-picked", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 24 "../src/number-picker.vala"
	number_picker_signals[NUMBER_PICKER_EARMARK_STATE_CHANGED_SIGNAL] = g_signal_new ("earmark-state-changed", TYPE_NUMBER_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_BOOLEAN, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_BOOLEAN);
#line 1134 "number-picker.c"
}


static void
number_picker_instance_init (NumberPicker * self)
{
#line 24 "../src/number-picker.vala"
	self->priv = number_picker_get_instance_private (self);
#line 1143 "number-picker.c"
}


static void
number_picker_finalize (GObject * obj)
{
	NumberPicker * self;
#line 24 "../src/number-picker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER_PICKER, NumberPicker);
#line 26 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->board);
#line 31 "../src/number-picker.vala"
	_g_object_unref0 (self->priv->clear_button);
#line 24 "../src/number-picker.vala"
	G_OBJECT_CLASS (number_picker_parent_class)->finalize (obj);
#line 1159 "number-picker.c"
}


GType
number_picker_get_type (void)
{
	static volatile gsize number_picker_type_id__volatile = 0;
	if (g_once_init_enter (&number_picker_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NumberPickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NumberPicker), 0, (GInstanceInitFunc) number_picker_instance_init, NULL };
		GType number_picker_type_id;
		number_picker_type_id = g_type_register_static (gtk_grid_get_type (), "NumberPicker", &g_define_type_info, 0);
		NumberPicker_private_offset = g_type_add_instance_private (number_picker_type_id, sizeof (NumberPickerPrivate));
		g_once_init_leave (&number_picker_type_id__volatile, number_picker_type_id);
	}
	return number_picker_type_id__volatile;
}



