/* sudoku-printer.c generated by valac 0.42.3, the Vala compiler
 * generated from sudoku-printer.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include "libsudoku.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_SUDOKU_PRINTER (sudoku_printer_get_type ())
#define SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinter))
#define SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))
#define IS_SUDOKU_PRINTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_PRINTER))
#define IS_SUDOKU_PRINTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_PRINTER))
#define SUDOKU_PRINTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_PRINTER, SudokuPrinterClass))

typedef struct _SudokuPrinter SudokuPrinter;
typedef struct _SudokuPrinterClass SudokuPrinterClass;
typedef struct _SudokuPrinterPrivate SudokuPrinterPrivate;
enum  {
	SUDOKU_PRINTER_0_PROPERTY,
	SUDOKU_PRINTER_NUM_PROPERTIES
};
static GParamSpec* sudoku_printer_properties[SUDOKU_PRINTER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _SudokuPrinter {
	GObject parent_instance;
	SudokuPrinterPrivate * priv;
};

struct _SudokuPrinterClass {
	GObjectClass parent_class;
};

struct _SudokuPrinterPrivate {
	GeeList* boards;
	GtkWindow* window;
	gint margin;
	gint n_sudokus;
	GtkPrintOperation* print_op;
};


static gint SudokuPrinter_private_offset;
static gpointer sudoku_printer_parent_class = NULL;

GType sudoku_printer_get_type (void) G_GNUC_CONST;
#define SUDOKU_PRINTER_SUDOKUS_PER_PAGE 2
GtkPrintOperationResult sudoku_printer_print_sudoku (SudokuPrinter* self);
SudokuPrinter* sudoku_printer_new (GeeList* boards,
                                   GtkWindow* window);
SudokuPrinter* sudoku_printer_construct (GType object_type,
                                         GeeList* boards,
                                         GtkWindow* window);
static void sudoku_printer_begin_print_cb (SudokuPrinter* self,
                                    GtkPrintOperation* operation,
                                    GtkPrintContext* context);
static void _sudoku_printer_begin_print_cb_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                                     GtkPrintContext* context,
                                                                     gpointer self);
static void sudoku_printer_draw_page_cb (SudokuPrinter* self,
                                  GtkPrintOperation* operation,
                                  GtkPrintContext* context,
                                  gint page_nr);
static void _sudoku_printer_draw_page_cb_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                                 GtkPrintContext* context,
                                                                 gint page_nr,
                                                                 gpointer self);
static gdouble sudoku_printer_fit_squares_in_rectangle (SudokuPrinter* self,
                                                 gdouble width,
                                                 gdouble height,
                                                 gint margin);
static void sudoku_printer_draw_sudoku (SudokuPrinter* self,
                                 cairo_t* cr,
                                 SudokuBoard* sudoku_board,
                                 gdouble size,
                                 gdouble offset_x,
                                 gdouble offset_y);
static void sudoku_printer_finalize (GObject * obj);


static inline gpointer
sudoku_printer_get_instance_private (SudokuPrinter* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuPrinter_private_offset);
}


GtkPrintOperationResult
sudoku_printer_print_sudoku (SudokuPrinter* self)
{
	GtkPrintOperationResult result = 0;
	GError * _inner_error_ = NULL;
#line 36 "../src/sudoku-printer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 130 "sudoku-printer.c"
	{
		GtkPrintOperationResult _result_ = 0;
		GtkPrintOperation* _tmp0_;
		GtkWindow* _tmp1_;
#line 40 "../src/sudoku-printer.vala"
		_tmp0_ = self->priv->print_op;
#line 40 "../src/sudoku-printer.vala"
		_tmp1_ = self->priv->window;
#line 40 "../src/sudoku-printer.vala"
		_result_ = gtk_print_operation_run (_tmp0_, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG, _tmp1_, &_inner_error_);
#line 40 "../src/sudoku-printer.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 143 "sudoku-printer.c"
			goto __catch5_g_error;
		}
#line 41 "../src/sudoku-printer.vala"
		result = _result_;
#line 41 "../src/sudoku-printer.vala"
		return result;
#line 150 "sudoku-printer.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GtkWindow* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GtkMessageDialog* _tmp7_;
		GtkMessageDialog* _tmp8_;
#line 38 "../src/sudoku-printer.vala"
		e = _inner_error_;
#line 38 "../src/sudoku-printer.vala"
		_inner_error_ = NULL;
#line 45 "../src/sudoku-printer.vala"
		_tmp2_ = self->priv->window;
#line 45 "../src/sudoku-printer.vala"
		_tmp3_ = e;
#line 45 "../src/sudoku-printer.vala"
		_tmp4_ = _tmp3_->message;
#line 45 "../src/sudoku-printer.vala"
		_tmp5_ = g_strdup_printf ("%s\n%s", _ ("Error printing file:"), _tmp4_);
#line 45 "../src/sudoku-printer.vala"
		_tmp6_ = _tmp5_;
#line 45 "../src/sudoku-printer.vala"
		_tmp7_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp2_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "%s", _tmp6_);
#line 45 "../src/sudoku-printer.vala"
		g_object_ref_sink (_tmp7_);
#line 45 "../src/sudoku-printer.vala"
		_tmp8_ = _tmp7_;
#line 45 "../src/sudoku-printer.vala"
		gtk_dialog_run ((GtkDialog*) _tmp8_);
#line 45 "../src/sudoku-printer.vala"
		_g_object_unref0 (_tmp8_);
#line 45 "../src/sudoku-printer.vala"
		_g_free0 (_tmp6_);
#line 38 "../src/sudoku-printer.vala"
		_g_error_free0 (e);
#line 191 "sudoku-printer.c"
	}
	__finally5:
#line 38 "../src/sudoku-printer.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38 "../src/sudoku-printer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "../src/sudoku-printer.vala"
		g_clear_error (&_inner_error_);
#line 38 "../src/sudoku-printer.vala"
		return 0;
#line 202 "sudoku-printer.c"
	}
#line 51 "../src/sudoku-printer.vala"
	result = GTK_PRINT_OPERATION_RESULT_ERROR;
#line 51 "../src/sudoku-printer.vala"
	return result;
#line 208 "sudoku-printer.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../src/sudoku-printer.vala"
	return self ? g_object_ref (self) : NULL;
#line 217 "sudoku-printer.c"
}


static void
_sudoku_printer_begin_print_cb_gtk_print_operation_begin_print (GtkPrintOperation* _sender,
                                                                GtkPrintContext* context,
                                                                gpointer self)
{
#line 62 "../src/sudoku-printer.vala"
	sudoku_printer_begin_print_cb ((SudokuPrinter*) self, _sender, context);
#line 228 "sudoku-printer.c"
}


static void
_sudoku_printer_draw_page_cb_gtk_print_operation_draw_page (GtkPrintOperation* _sender,
                                                            GtkPrintContext* context,
                                                            gint page_nr,
                                                            gpointer self)
{
#line 63 "../src/sudoku-printer.vala"
	sudoku_printer_draw_page_cb ((SudokuPrinter*) self, _sender, context, page_nr);
#line 240 "sudoku-printer.c"
}


SudokuPrinter*
sudoku_printer_construct (GType object_type,
                          GeeList* boards,
                          GtkWindow* window)
{
	SudokuPrinter * self = NULL;
	GeeList* _tmp0_;
	GtkWindow* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkPrintOperation* _tmp4_;
	GtkPrintOperation* _tmp5_;
	GtkPrintOperation* _tmp6_;
#line 54 "../src/sudoku-printer.vala"
	g_return_val_if_fail (boards != NULL, NULL);
#line 54 "../src/sudoku-printer.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 54 "../src/sudoku-printer.vala"
	self = (SudokuPrinter*) g_object_new (object_type, NULL);
#line 56 "../src/sudoku-printer.vala"
	_tmp0_ = _g_object_ref0 (boards);
#line 56 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->boards);
#line 56 "../src/sudoku-printer.vala"
	self->priv->boards = _tmp0_;
#line 57 "../src/sudoku-printer.vala"
	_tmp1_ = _g_object_ref0 (window);
#line 57 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->window);
#line 57 "../src/sudoku-printer.vala"
	self->priv->window = _tmp1_;
#line 58 "../src/sudoku-printer.vala"
	self->priv->margin = 25;
#line 59 "../src/sudoku-printer.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) boards);
#line 59 "../src/sudoku-printer.vala"
	_tmp3_ = _tmp2_;
#line 59 "../src/sudoku-printer.vala"
	self->priv->n_sudokus = _tmp3_;
#line 61 "../src/sudoku-printer.vala"
	_tmp4_ = gtk_print_operation_new ();
#line 61 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->print_op);
#line 61 "../src/sudoku-printer.vala"
	self->priv->print_op = _tmp4_;
#line 62 "../src/sudoku-printer.vala"
	_tmp5_ = self->priv->print_op;
#line 62 "../src/sudoku-printer.vala"
	g_signal_connect_object (_tmp5_, "begin-print", (GCallback) _sudoku_printer_begin_print_cb_gtk_print_operation_begin_print, self, 0);
#line 63 "../src/sudoku-printer.vala"
	_tmp6_ = self->priv->print_op;
#line 63 "../src/sudoku-printer.vala"
	g_signal_connect_object (_tmp6_, "draw-page", (GCallback) _sudoku_printer_draw_page_cb_gtk_print_operation_draw_page, self, 0);
#line 54 "../src/sudoku-printer.vala"
	return self;
#line 299 "sudoku-printer.c"
}


SudokuPrinter*
sudoku_printer_new (GeeList* boards,
                    GtkWindow* window)
{
#line 54 "../src/sudoku-printer.vala"
	return sudoku_printer_construct (TYPE_SUDOKU_PRINTER, boards, window);
#line 309 "sudoku-printer.c"
}


static void
sudoku_printer_begin_print_cb (SudokuPrinter* self,
                               GtkPrintOperation* operation,
                               GtkPrintContext* context)
{
	gint pages = 0;
	gint _tmp0_;
	gint _tmp4_;
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (operation != NULL);
#line 66 "../src/sudoku-printer.vala"
	g_return_if_fail (context != NULL);
#line 68 "../src/sudoku-printer.vala"
	_tmp0_ = self->priv->n_sudokus;
#line 68 "../src/sudoku-printer.vala"
	pages = _tmp0_ / SUDOKU_PRINTER_SUDOKUS_PER_PAGE;
#line 69 "../src/sudoku-printer.vala"
	while (TRUE) {
#line 333 "sudoku-printer.c"
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 69 "../src/sudoku-printer.vala"
		_tmp1_ = pages;
#line 69 "../src/sudoku-printer.vala"
		_tmp2_ = self->priv->n_sudokus;
#line 69 "../src/sudoku-printer.vala"
		if (!((_tmp1_ * SUDOKU_PRINTER_SUDOKUS_PER_PAGE) < _tmp2_)) {
#line 69 "../src/sudoku-printer.vala"
			break;
#line 345 "sudoku-printer.c"
		}
#line 70 "../src/sudoku-printer.vala"
		_tmp3_ = pages;
#line 70 "../src/sudoku-printer.vala"
		pages = _tmp3_ + 1;
#line 351 "sudoku-printer.c"
	}
#line 72 "../src/sudoku-printer.vala"
	_tmp4_ = pages;
#line 72 "../src/sudoku-printer.vala"
	gtk_print_operation_set_n_pages (operation, _tmp4_);
#line 357 "sudoku-printer.c"
}


static gpointer
_cairo_reference0 (gpointer self)
{
#line 77 "../src/sudoku-printer.vala"
	return self ? cairo_reference (self) : NULL;
#line 366 "sudoku-printer.c"
}


static void
sudoku_printer_draw_page_cb (SudokuPrinter* self,
                             GtkPrintOperation* operation,
                             GtkPrintContext* context,
                             gint page_nr)
{
	cairo_t* cr = NULL;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	gdouble width = 0.0;
	gdouble height = 0.0;
	gdouble best_square_size = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	gint start = 0;
	gint end = 0;
	gint _tmp5_;
	GeeList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GeeList* sudokus_on_page = NULL;
	GeeList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GeeList* _tmp12_;
	gdouble left = 0.0;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble top = 0.0;
	gint _tmp15_;
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (operation != NULL);
#line 75 "../src/sudoku-printer.vala"
	g_return_if_fail (context != NULL);
#line 77 "../src/sudoku-printer.vala"
	_tmp0_ = gtk_print_context_get_cairo_context (context);
#line 77 "../src/sudoku-printer.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 77 "../src/sudoku-printer.vala"
	cr = _tmp1_;
#line 78 "../src/sudoku-printer.vala"
	width = gtk_print_context_get_width (context);
#line 79 "../src/sudoku-printer.vala"
	height = gtk_print_context_get_height (context);
#line 81 "../src/sudoku-printer.vala"
	_tmp2_ = width;
#line 81 "../src/sudoku-printer.vala"
	_tmp3_ = height;
#line 81 "../src/sudoku-printer.vala"
	_tmp4_ = self->priv->margin;
#line 81 "../src/sudoku-printer.vala"
	best_square_size = sudoku_printer_fit_squares_in_rectangle (self, _tmp2_, _tmp3_, _tmp4_);
#line 83 "../src/sudoku-printer.vala"
	start = page_nr * SUDOKU_PRINTER_SUDOKUS_PER_PAGE;
#line 84 "../src/sudoku-printer.vala"
	_tmp5_ = start;
#line 84 "../src/sudoku-printer.vala"
	_tmp6_ = self->priv->boards;
#line 84 "../src/sudoku-printer.vala"
	_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 84 "../src/sudoku-printer.vala"
	_tmp8_ = _tmp7_;
#line 84 "../src/sudoku-printer.vala"
	end = MIN (_tmp5_ + SUDOKU_PRINTER_SUDOKUS_PER_PAGE, _tmp8_);
#line 85 "../src/sudoku-printer.vala"
	_tmp9_ = self->priv->boards;
#line 85 "../src/sudoku-printer.vala"
	_tmp10_ = start;
#line 85 "../src/sudoku-printer.vala"
	_tmp11_ = end;
#line 85 "../src/sudoku-printer.vala"
	_tmp12_ = gee_list_slice (_tmp9_, _tmp10_, _tmp11_);
#line 85 "../src/sudoku-printer.vala"
	sudokus_on_page = _tmp12_;
#line 87 "../src/sudoku-printer.vala"
	_tmp13_ = width;
#line 87 "../src/sudoku-printer.vala"
	_tmp14_ = best_square_size;
#line 87 "../src/sudoku-printer.vala"
	left = (_tmp13_ - _tmp14_) / 2;
#line 88 "../src/sudoku-printer.vala"
	_tmp15_ = self->priv->margin;
#line 88 "../src/sudoku-printer.vala"
	top = (gdouble) _tmp15_;
#line 457 "sudoku-printer.c"
	{
		GeeList* _sudoku_list = NULL;
		GeeList* _tmp16_;
		GeeList* _tmp17_;
		gint _sudoku_size = 0;
		GeeList* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _sudoku_index = 0;
#line 90 "../src/sudoku-printer.vala"
		_tmp16_ = sudokus_on_page;
#line 90 "../src/sudoku-printer.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 90 "../src/sudoku-printer.vala"
		_sudoku_list = _tmp17_;
#line 90 "../src/sudoku-printer.vala"
		_tmp18_ = _sudoku_list;
#line 90 "../src/sudoku-printer.vala"
		_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 90 "../src/sudoku-printer.vala"
		_tmp20_ = _tmp19_;
#line 90 "../src/sudoku-printer.vala"
		_sudoku_size = _tmp20_;
#line 90 "../src/sudoku-printer.vala"
		_sudoku_index = -1;
#line 90 "../src/sudoku-printer.vala"
		while (TRUE) {
#line 485 "sudoku-printer.c"
			gint _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
			SudokuBoard* sudoku = NULL;
			GeeList* _tmp24_;
			gint _tmp25_;
			gpointer _tmp26_;
			gchar* label = NULL;
			SudokuBoard* _tmp27_;
			DifficultyCategory _tmp28_;
			DifficultyCategory _tmp29_;
			gchar* _tmp30_;
			cairo_t* _tmp31_;
			cairo_t* _tmp32_;
			cairo_t* _tmp33_;
			cairo_text_extents_t extents = {0};
			cairo_t* _tmp34_;
			const gchar* _tmp35_;
			cairo_text_extents_t _tmp36_ = {0};
			cairo_t* _tmp37_;
			gdouble _tmp38_;
			cairo_text_extents_t _tmp39_;
			gdouble _tmp40_;
			gdouble _tmp41_;
			cairo_text_extents_t _tmp42_;
			gdouble _tmp43_;
			cairo_t* _tmp44_;
			const gchar* _tmp45_;
			cairo_t* _tmp46_;
			SudokuBoard* _tmp47_;
			gdouble _tmp48_;
			gdouble _tmp49_;
			gdouble _tmp50_;
			gdouble _tmp51_;
			gdouble _tmp52_;
			gint _tmp53_;
#line 90 "../src/sudoku-printer.vala"
			_tmp21_ = _sudoku_index;
#line 90 "../src/sudoku-printer.vala"
			_sudoku_index = _tmp21_ + 1;
#line 90 "../src/sudoku-printer.vala"
			_tmp22_ = _sudoku_index;
#line 90 "../src/sudoku-printer.vala"
			_tmp23_ = _sudoku_size;
#line 90 "../src/sudoku-printer.vala"
			if (!(_tmp22_ < _tmp23_)) {
#line 90 "../src/sudoku-printer.vala"
				break;
#line 534 "sudoku-printer.c"
			}
#line 90 "../src/sudoku-printer.vala"
			_tmp24_ = _sudoku_list;
#line 90 "../src/sudoku-printer.vala"
			_tmp25_ = _sudoku_index;
#line 90 "../src/sudoku-printer.vala"
			_tmp26_ = gee_list_get (_tmp24_, _tmp25_);
#line 90 "../src/sudoku-printer.vala"
			sudoku = (SudokuBoard*) _tmp26_;
#line 92 "../src/sudoku-printer.vala"
			_tmp27_ = sudoku;
#line 92 "../src/sudoku-printer.vala"
			_tmp28_ = sudoku_board_get_difficulty_category (_tmp27_);
#line 92 "../src/sudoku-printer.vala"
			_tmp29_ = _tmp28_;
#line 92 "../src/sudoku-printer.vala"
			_tmp30_ = difficulty_category_to_string (_tmp29_);
#line 92 "../src/sudoku-printer.vala"
			label = _tmp30_;
#line 93 "../src/sudoku-printer.vala"
			_tmp31_ = cr;
#line 93 "../src/sudoku-printer.vala"
			cairo_set_font_size (_tmp31_, (gdouble) 12);
#line 94 "../src/sudoku-printer.vala"
			_tmp32_ = cr;
#line 94 "../src/sudoku-printer.vala"
			cairo_select_font_face (_tmp32_, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 95 "../src/sudoku-printer.vala"
			_tmp33_ = cr;
#line 95 "../src/sudoku-printer.vala"
			cairo_set_source_rgb (_tmp33_, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 97 "../src/sudoku-printer.vala"
			_tmp34_ = cr;
#line 97 "../src/sudoku-printer.vala"
			_tmp35_ = label;
#line 97 "../src/sudoku-printer.vala"
			cairo_text_extents (_tmp34_, _tmp35_, &_tmp36_);
#line 97 "../src/sudoku-printer.vala"
			extents = _tmp36_;
#line 98 "../src/sudoku-printer.vala"
			_tmp37_ = cr;
#line 98 "../src/sudoku-printer.vala"
			_tmp38_ = width;
#line 98 "../src/sudoku-printer.vala"
			_tmp39_ = extents;
#line 98 "../src/sudoku-printer.vala"
			_tmp40_ = _tmp39_.width;
#line 98 "../src/sudoku-printer.vala"
			_tmp41_ = top;
#line 98 "../src/sudoku-printer.vala"
			_tmp42_ = extents;
#line 98 "../src/sudoku-printer.vala"
			_tmp43_ = _tmp42_.height;
#line 98 "../src/sudoku-printer.vala"
			cairo_move_to (_tmp37_, (_tmp38_ - _tmp40_) / 2, _tmp41_ - (_tmp43_ / 2));
#line 99 "../src/sudoku-printer.vala"
			_tmp44_ = cr;
#line 99 "../src/sudoku-printer.vala"
			_tmp45_ = label;
#line 99 "../src/sudoku-printer.vala"
			cairo_show_text (_tmp44_, _tmp45_);
#line 101 "../src/sudoku-printer.vala"
			_tmp46_ = cr;
#line 101 "../src/sudoku-printer.vala"
			_tmp47_ = sudoku;
#line 101 "../src/sudoku-printer.vala"
			_tmp48_ = best_square_size;
#line 101 "../src/sudoku-printer.vala"
			_tmp49_ = left;
#line 101 "../src/sudoku-printer.vala"
			_tmp50_ = top;
#line 101 "../src/sudoku-printer.vala"
			sudoku_printer_draw_sudoku (self, _tmp46_, _tmp47_, _tmp48_, _tmp49_, _tmp50_);
#line 103 "../src/sudoku-printer.vala"
			_tmp51_ = top;
#line 103 "../src/sudoku-printer.vala"
			_tmp52_ = best_square_size;
#line 103 "../src/sudoku-printer.vala"
			_tmp53_ = self->priv->margin;
#line 103 "../src/sudoku-printer.vala"
			top = _tmp51_ + (_tmp52_ + (2 * _tmp53_));
#line 90 "../src/sudoku-printer.vala"
			_g_free0 (label);
#line 90 "../src/sudoku-printer.vala"
			_g_object_unref0 (sudoku);
#line 620 "sudoku-printer.c"
		}
#line 90 "../src/sudoku-printer.vala"
		_g_object_unref0 (_sudoku_list);
#line 624 "sudoku-printer.c"
	}
#line 75 "../src/sudoku-printer.vala"
	_g_object_unref0 (sudokus_on_page);
#line 75 "../src/sudoku-printer.vala"
	_cairo_destroy0 (cr);
#line 630 "sudoku-printer.c"
}


static gdouble
sudoku_printer_fit_squares_in_rectangle (SudokuPrinter* self,
                                         gdouble width,
                                         gdouble height,
                                         gint margin)
{
	gdouble result = 0.0;
	gint n = 0;
	gdouble best_square_size = 0.0;
	gdouble square_size = 0.0;
#line 107 "../src/sudoku-printer.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 109 "../src/sudoku-printer.vala"
	n = SUDOKU_PRINTER_SUDOKUS_PER_PAGE;
#line 110 "../src/sudoku-printer.vala"
	best_square_size = 0.0;
#line 111 "../src/sudoku-printer.vala"
	square_size = 0.0;
#line 652 "sudoku-printer.c"
	{
		gint n_across = 0;
#line 113 "../src/sudoku-printer.vala"
		n_across = 1;
#line 657 "sudoku-printer.c"
		{
			gboolean _tmp0_ = FALSE;
#line 113 "../src/sudoku-printer.vala"
			_tmp0_ = TRUE;
#line 113 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 664 "sudoku-printer.c"
				gint _tmp2_;
				gint _tmp3_;
				gdouble n_down = 0.0;
				gint _tmp4_;
				gint _tmp5_;
				gdouble across_size = 0.0;
				gint _tmp6_;
				gdouble _tmp7_;
				gint _tmp8_;
				gdouble down_size = 0.0;
				gdouble _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				gdouble _tmp12_;
				gdouble _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_;
#line 113 "../src/sudoku-printer.vala"
				if (!_tmp0_) {
#line 684 "sudoku-printer.c"
					gint _tmp1_;
#line 113 "../src/sudoku-printer.vala"
					_tmp1_ = n_across;
#line 113 "../src/sudoku-printer.vala"
					n_across = _tmp1_ + 1;
#line 690 "sudoku-printer.c"
				}
#line 113 "../src/sudoku-printer.vala"
				_tmp0_ = FALSE;
#line 113 "../src/sudoku-printer.vala"
				_tmp2_ = n_across;
#line 113 "../src/sudoku-printer.vala"
				_tmp3_ = n;
#line 113 "../src/sudoku-printer.vala"
				if (!(_tmp2_ <= _tmp3_)) {
#line 113 "../src/sudoku-printer.vala"
					break;
#line 702 "sudoku-printer.c"
				}
#line 115 "../src/sudoku-printer.vala"
				_tmp4_ = n;
#line 115 "../src/sudoku-printer.vala"
				_tmp5_ = n_across;
#line 115 "../src/sudoku-printer.vala"
				n_down = (gdouble) (_tmp4_ / _tmp5_);
#line 116 "../src/sudoku-printer.vala"
				_tmp6_ = n_across;
#line 116 "../src/sudoku-printer.vala"
				across_size = width - ((_tmp6_ + 1) * margin);
#line 117 "../src/sudoku-printer.vala"
				_tmp7_ = across_size;
#line 117 "../src/sudoku-printer.vala"
				_tmp8_ = n_across;
#line 117 "../src/sudoku-printer.vala"
				across_size = _tmp7_ / _tmp8_;
#line 118 "../src/sudoku-printer.vala"
				_tmp9_ = n_down;
#line 118 "../src/sudoku-printer.vala"
				down_size = height - ((_tmp9_ + 1) * margin);
#line 119 "../src/sudoku-printer.vala"
				_tmp10_ = down_size;
#line 119 "../src/sudoku-printer.vala"
				_tmp11_ = n_down;
#line 119 "../src/sudoku-printer.vala"
				down_size = _tmp10_ / _tmp11_;
#line 121 "../src/sudoku-printer.vala"
				_tmp12_ = across_size;
#line 121 "../src/sudoku-printer.vala"
				_tmp13_ = down_size;
#line 121 "../src/sudoku-printer.vala"
				square_size = MIN (_tmp12_, _tmp13_);
#line 122 "../src/sudoku-printer.vala"
				_tmp14_ = square_size;
#line 122 "../src/sudoku-printer.vala"
				_tmp15_ = best_square_size;
#line 122 "../src/sudoku-printer.vala"
				if (_tmp14_ > _tmp15_) {
#line 742 "sudoku-printer.c"
					gdouble _tmp16_;
#line 123 "../src/sudoku-printer.vala"
					_tmp16_ = square_size;
#line 123 "../src/sudoku-printer.vala"
					best_square_size = _tmp16_;
#line 748 "sudoku-printer.c"
				}
			}
		}
	}
#line 126 "../src/sudoku-printer.vala"
	result = best_square_size;
#line 126 "../src/sudoku-printer.vala"
	return result;
#line 757 "sudoku-printer.c"
}


static void
sudoku_printer_draw_sudoku (SudokuPrinter* self,
                            cairo_t* cr,
                            SudokuBoard* sudoku_board,
                            gdouble size,
                            gdouble offset_x,
                            gdouble offset_y)
{
#line 131 "../src/sudoku-printer.vala"
	static const gint SUDOKU_SIZE = 9;
#line 132 "../src/sudoku-printer.vala"
	static const gint N_BOXES = 3;
#line 133 "../src/sudoku-printer.vala"
	static const gdouble PENCIL_GREY[3] = {0.3, 0.3, 0.3};
#line 134 "../src/sudoku-printer.vala"
	static const gdouble BACKGROUND_COLOR[3] = {1.0, 1.0, 1.0};
#line 136 "../src/sudoku-printer.vala"
	static const gdouble BORDER_COLOR[3] = {1.0, 1.0, 1.0};
#line 137 "../src/sudoku-printer.vala"
	static const gdouble LINE_COLOR[3] = {0.0, 0.0, 0.0};
#line 781 "sudoku-printer.c"
	gdouble THIN = 0.0;
	gdouble THICK = 0.0;
	gdouble _tmp0_;
	gdouble BORDER = 0.0;
	gdouble _tmp1_;
	gdouble WHITE_SPACE = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble SQUARE_SIZE = 0.0;
	gdouble _tmp6_;
	gint FONT_SIZE = 0;
	gdouble _tmp7_;
#line 146 "../src/sudoku-printer.vala"
	static const cairo_font_weight_t FONT_WEIGHT = CAIRO_FONT_WEIGHT_NORMAL;
#line 798 "sudoku-printer.c"
	gdouble* outer = NULL;
	gdouble* _tmp8_;
	gint outer_length1;
	gint _outer_size_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	gdouble _tmp10_;
	gdouble* _tmp11_;
	gint _tmp11__length1;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble* _tmp14_;
	gint _tmp14__length1;
	gdouble _tmp15_;
	gdouble _tmp16_;
	gdouble* _tmp17_;
	gint _tmp17__length1;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble* _tmp29_;
	gint _tmp29__length1;
	gdouble _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	gdouble* _tmp33_;
	gint _tmp33__length1;
	gdouble _tmp34_;
	gdouble _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble* pos = NULL;
	gdouble* _tmp44_;
	gint pos_length1;
	gint _pos_size_;
	gdouble position = 0.0;
	gdouble _tmp45_;
	gdouble _tmp46_;
	gdouble* _tmp47_;
	gint _tmp47__length1;
	gdouble _tmp48_;
	gdouble _tmp49_;
	gdouble _tmp50_;
	gdouble last_line = 0.0;
	gint _tmp85_;
	gchar* letter = NULL;
	gchar* _tmp86_;
	cairo_text_extents_t extents = {0};
	gint* sudoku = NULL;
	gint _tmp87_ = 0;
	gint _tmp88_ = 0;
	gint* _tmp89_;
	gint sudoku_length1;
	gint sudoku_length2;
	gboolean invert = FALSE;
#line 129 "../src/sudoku-printer.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/sudoku-printer.vala"
	g_return_if_fail (cr != NULL);
#line 129 "../src/sudoku-printer.vala"
	g_return_if_fail (sudoku_board != NULL);
#line 139 "../src/sudoku-printer.vala"
	THIN = size / 500.0;
#line 140 "../src/sudoku-printer.vala"
	_tmp0_ = THIN;
#line 140 "../src/sudoku-printer.vala"
	THICK = _tmp0_ * 5;
#line 141 "../src/sudoku-printer.vala"
	_tmp1_ = THICK;
#line 141 "../src/sudoku-printer.vala"
	BORDER = _tmp1_;
#line 142 "../src/sudoku-printer.vala"
	_tmp2_ = BORDER;
#line 142 "../src/sudoku-printer.vala"
	_tmp3_ = THICK;
#line 142 "../src/sudoku-printer.vala"
	_tmp4_ = THICK;
#line 142 "../src/sudoku-printer.vala"
	_tmp5_ = THIN;
#line 142 "../src/sudoku-printer.vala"
	WHITE_SPACE = (((size - (2 * _tmp2_)) - (2 * _tmp3_)) - ((N_BOXES - 1) * _tmp4_)) - ((N_BOXES * 2) * _tmp5_);
#line 143 "../src/sudoku-printer.vala"
	_tmp6_ = WHITE_SPACE;
#line 143 "../src/sudoku-printer.vala"
	SQUARE_SIZE = _tmp6_ / SUDOKU_SIZE;
#line 145 "../src/sudoku-printer.vala"
	_tmp7_ = SQUARE_SIZE;
#line 145 "../src/sudoku-printer.vala"
	FONT_SIZE = ((gint) _tmp7_) / 2;
#line 148 "../src/sudoku-printer.vala"
	_tmp8_ = g_new0 (gdouble, 4);
#line 148 "../src/sudoku-printer.vala"
	_tmp8_[0] = offset_x;
#line 148 "../src/sudoku-printer.vala"
	_tmp8_[1] = offset_x + size;
#line 148 "../src/sudoku-printer.vala"
	_tmp8_[2] = offset_y;
#line 148 "../src/sudoku-printer.vala"
	_tmp8_[3] = offset_y + size;
#line 148 "../src/sudoku-printer.vala"
	outer = _tmp8_;
#line 148 "../src/sudoku-printer.vala"
	outer_length1 = 4;
#line 148 "../src/sudoku-printer.vala"
	_outer_size_ = outer_length1;
#line 151 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, 1.0, 1.0, 1.0);
#line 152 "../src/sudoku-printer.vala"
	_tmp9_ = outer;
#line 152 "../src/sudoku-printer.vala"
	_tmp9__length1 = outer_length1;
#line 152 "../src/sudoku-printer.vala"
	_tmp10_ = _tmp9_[0];
#line 152 "../src/sudoku-printer.vala"
	_tmp11_ = outer;
#line 152 "../src/sudoku-printer.vala"
	_tmp11__length1 = outer_length1;
#line 152 "../src/sudoku-printer.vala"
	_tmp12_ = _tmp11_[2];
#line 152 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, _tmp10_, _tmp12_, size, size);
#line 153 "../src/sudoku-printer.vala"
	cairo_fill (cr);
#line 156 "../src/sudoku-printer.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_ROUND);
#line 157 "../src/sudoku-printer.vala"
	_tmp13_ = BORDER;
#line 157 "../src/sudoku-printer.vala"
	cairo_set_line_width (cr, _tmp13_);
#line 158 "../src/sudoku-printer.vala"
	_tmp14_ = outer;
#line 158 "../src/sudoku-printer.vala"
	_tmp14__length1 = outer_length1;
#line 158 "../src/sudoku-printer.vala"
	_tmp15_ = _tmp14_[0];
#line 158 "../src/sudoku-printer.vala"
	_tmp16_ = BORDER;
#line 158 "../src/sudoku-printer.vala"
	_tmp17_ = outer;
#line 158 "../src/sudoku-printer.vala"
	_tmp17__length1 = outer_length1;
#line 158 "../src/sudoku-printer.vala"
	_tmp18_ = _tmp17_[2];
#line 158 "../src/sudoku-printer.vala"
	_tmp19_ = BORDER;
#line 158 "../src/sudoku-printer.vala"
	_tmp20_ = BORDER;
#line 158 "../src/sudoku-printer.vala"
	_tmp21_ = BORDER;
#line 158 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, _tmp15_ + (_tmp16_ / 2.0), _tmp18_ + (_tmp19_ / 2.0), size - _tmp20_, size - _tmp21_);
#line 161 "../src/sudoku-printer.vala"
	_tmp22_ = BACKGROUND_COLOR[0];
#line 161 "../src/sudoku-printer.vala"
	_tmp23_ = BACKGROUND_COLOR[1];
#line 161 "../src/sudoku-printer.vala"
	_tmp24_ = BACKGROUND_COLOR[2];
#line 161 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp22_, _tmp23_, _tmp24_);
#line 162 "../src/sudoku-printer.vala"
	cairo_fill_preserve (cr);
#line 164 "../src/sudoku-printer.vala"
	_tmp25_ = BORDER_COLOR[0];
#line 164 "../src/sudoku-printer.vala"
	_tmp26_ = BORDER_COLOR[1];
#line 164 "../src/sudoku-printer.vala"
	_tmp27_ = BORDER_COLOR[2];
#line 164 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp25_, _tmp26_, _tmp27_);
#line 165 "../src/sudoku-printer.vala"
	cairo_stroke (cr);
#line 168 "../src/sudoku-printer.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_MITER);
#line 169 "../src/sudoku-printer.vala"
	_tmp28_ = THICK;
#line 169 "../src/sudoku-printer.vala"
	cairo_set_line_width (cr, _tmp28_);
#line 170 "../src/sudoku-printer.vala"
	_tmp29_ = outer;
#line 170 "../src/sudoku-printer.vala"
	_tmp29__length1 = outer_length1;
#line 170 "../src/sudoku-printer.vala"
	_tmp30_ = _tmp29_[0];
#line 170 "../src/sudoku-printer.vala"
	_tmp31_ = BORDER;
#line 170 "../src/sudoku-printer.vala"
	_tmp32_ = THICK;
#line 170 "../src/sudoku-printer.vala"
	_tmp33_ = outer;
#line 170 "../src/sudoku-printer.vala"
	_tmp33__length1 = outer_length1;
#line 170 "../src/sudoku-printer.vala"
	_tmp34_ = _tmp33_[2];
#line 170 "../src/sudoku-printer.vala"
	_tmp35_ = BORDER;
#line 170 "../src/sudoku-printer.vala"
	_tmp36_ = THICK;
#line 170 "../src/sudoku-printer.vala"
	_tmp37_ = BORDER;
#line 170 "../src/sudoku-printer.vala"
	_tmp38_ = THICK;
#line 170 "../src/sudoku-printer.vala"
	_tmp39_ = BORDER;
#line 170 "../src/sudoku-printer.vala"
	_tmp40_ = THICK;
#line 170 "../src/sudoku-printer.vala"
	cairo_rectangle (cr, (_tmp30_ + _tmp31_) + (_tmp32_ / 2.0), (_tmp34_ + _tmp35_) + (_tmp36_ / 2.0), (size - (_tmp37_ * 2)) - _tmp38_, (size - (_tmp39_ * 2)) - _tmp40_);
#line 171 "../src/sudoku-printer.vala"
	_tmp41_ = LINE_COLOR[0];
#line 171 "../src/sudoku-printer.vala"
	_tmp42_ = LINE_COLOR[1];
#line 171 "../src/sudoku-printer.vala"
	_tmp43_ = LINE_COLOR[2];
#line 171 "../src/sudoku-printer.vala"
	cairo_set_source_rgb (cr, _tmp41_, _tmp42_, _tmp43_);
#line 172 "../src/sudoku-printer.vala"
	cairo_stroke (cr);
#line 174 "../src/sudoku-printer.vala"
	_tmp44_ = g_new0 (gdouble, SUDOKU_SIZE + 1);
#line 174 "../src/sudoku-printer.vala"
	pos = _tmp44_;
#line 174 "../src/sudoku-printer.vala"
	pos_length1 = SUDOKU_SIZE + 1;
#line 174 "../src/sudoku-printer.vala"
	_pos_size_ = pos_length1;
#line 175 "../src/sudoku-printer.vala"
	_tmp45_ = BORDER;
#line 175 "../src/sudoku-printer.vala"
	_tmp46_ = THICK;
#line 175 "../src/sudoku-printer.vala"
	position = _tmp45_ + _tmp46_;
#line 176 "../src/sudoku-printer.vala"
	_tmp47_ = pos;
#line 176 "../src/sudoku-printer.vala"
	_tmp47__length1 = pos_length1;
#line 176 "../src/sudoku-printer.vala"
	_tmp48_ = position;
#line 176 "../src/sudoku-printer.vala"
	_tmp49_ = SQUARE_SIZE;
#line 176 "../src/sudoku-printer.vala"
	_tmp47_[0] = _tmp48_ + (_tmp49_ / 2.0);
#line 176 "../src/sudoku-printer.vala"
	_tmp50_ = _tmp47_[0];
#line 177 "../src/sudoku-printer.vala"
	last_line = 0.0;
#line 1058 "sudoku-printer.c"
	{
		gint n = 0;
#line 179 "../src/sudoku-printer.vala"
		n = 1;
#line 1063 "sudoku-printer.c"
		{
			gboolean _tmp51_ = FALSE;
#line 179 "../src/sudoku-printer.vala"
			_tmp51_ = TRUE;
#line 179 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 1070 "sudoku-printer.c"
				gint _tmp53_;
				gint _tmp54_;
				gdouble* _tmp67_;
				gint _tmp67__length1;
				gint _tmp68_;
				gdouble _tmp69_;
				gdouble _tmp70_;
				gdouble _tmp71_;
				gdouble _tmp72_;
				gdouble _tmp73_;
				gdouble _tmp74_;
				gdouble _tmp75_;
				gdouble _tmp76_;
				gdouble _tmp77_;
				gdouble _tmp78_;
				gdouble _tmp79_;
				gdouble _tmp80_;
				gdouble _tmp81_;
				gdouble _tmp82_;
				gdouble _tmp83_;
				gdouble _tmp84_;
#line 179 "../src/sudoku-printer.vala"
				if (!_tmp51_) {
#line 1094 "sudoku-printer.c"
					gint _tmp52_;
#line 179 "../src/sudoku-printer.vala"
					_tmp52_ = n;
#line 179 "../src/sudoku-printer.vala"
					n = _tmp52_ + 1;
#line 1100 "sudoku-printer.c"
				}
#line 179 "../src/sudoku-printer.vala"
				_tmp51_ = FALSE;
#line 179 "../src/sudoku-printer.vala"
				_tmp53_ = n;
#line 179 "../src/sudoku-printer.vala"
				if (!(_tmp53_ <= SUDOKU_SIZE)) {
#line 179 "../src/sudoku-printer.vala"
					break;
#line 1110 "sudoku-printer.c"
				}
#line 181 "../src/sudoku-printer.vala"
				_tmp54_ = n;
#line 181 "../src/sudoku-printer.vala"
				if ((_tmp54_ % N_BOXES) == 0) {
#line 1116 "sudoku-printer.c"
					gdouble _tmp55_;
					gdouble _tmp56_;
					gdouble _tmp57_;
					gdouble _tmp58_;
					gdouble _tmp59_;
					gdouble _tmp60_;
#line 183 "../src/sudoku-printer.vala"
					_tmp55_ = THICK;
#line 183 "../src/sudoku-printer.vala"
					cairo_set_line_width (cr, _tmp55_);
#line 184 "../src/sudoku-printer.vala"
					_tmp56_ = position;
#line 184 "../src/sudoku-printer.vala"
					_tmp57_ = SQUARE_SIZE;
#line 184 "../src/sudoku-printer.vala"
					_tmp58_ = last_line;
#line 184 "../src/sudoku-printer.vala"
					_tmp59_ = THICK;
#line 184 "../src/sudoku-printer.vala"
					position = _tmp56_ + ((_tmp57_ + (_tmp58_ / 2.0)) + (_tmp59_ / 2.0));
#line 185 "../src/sudoku-printer.vala"
					_tmp60_ = THICK;
#line 185 "../src/sudoku-printer.vala"
					last_line = _tmp60_;
#line 1141 "sudoku-printer.c"
				} else {
					gdouble _tmp61_;
					gdouble _tmp62_;
					gdouble _tmp63_;
					gdouble _tmp64_;
					gdouble _tmp65_;
					gdouble _tmp66_;
#line 189 "../src/sudoku-printer.vala"
					_tmp61_ = THIN;
#line 189 "../src/sudoku-printer.vala"
					cairo_set_line_width (cr, _tmp61_);
#line 190 "../src/sudoku-printer.vala"
					_tmp62_ = position;
#line 190 "../src/sudoku-printer.vala"
					_tmp63_ = SQUARE_SIZE;
#line 190 "../src/sudoku-printer.vala"
					_tmp64_ = last_line;
#line 190 "../src/sudoku-printer.vala"
					_tmp65_ = THIN;
#line 190 "../src/sudoku-printer.vala"
					position = _tmp62_ + ((_tmp63_ + (_tmp64_ / 2.0)) + (_tmp65_ / 2.0));
#line 191 "../src/sudoku-printer.vala"
					_tmp66_ = THIN;
#line 191 "../src/sudoku-printer.vala"
					last_line = _tmp66_;
#line 1167 "sudoku-printer.c"
				}
#line 194 "../src/sudoku-printer.vala"
				_tmp67_ = pos;
#line 194 "../src/sudoku-printer.vala"
				_tmp67__length1 = pos_length1;
#line 194 "../src/sudoku-printer.vala"
				_tmp68_ = n;
#line 194 "../src/sudoku-printer.vala"
				_tmp69_ = position;
#line 194 "../src/sudoku-printer.vala"
				_tmp70_ = last_line;
#line 194 "../src/sudoku-printer.vala"
				_tmp71_ = SQUARE_SIZE;
#line 194 "../src/sudoku-printer.vala"
				_tmp67_[_tmp68_] = (_tmp69_ + (_tmp70_ / 2.0)) + (_tmp71_ / 2.0);
#line 194 "../src/sudoku-printer.vala"
				_tmp72_ = _tmp67_[_tmp68_];
#line 195 "../src/sudoku-printer.vala"
				_tmp73_ = BORDER;
#line 195 "../src/sudoku-printer.vala"
				_tmp74_ = THICK;
#line 195 "../src/sudoku-printer.vala"
				_tmp75_ = position;
#line 195 "../src/sudoku-printer.vala"
				cairo_move_to (cr, (_tmp73_ + (_tmp74_ / 2.0)) + offset_x, _tmp75_ + offset_y);
#line 196 "../src/sudoku-printer.vala"
				_tmp76_ = BORDER;
#line 196 "../src/sudoku-printer.vala"
				_tmp77_ = THICK;
#line 196 "../src/sudoku-printer.vala"
				_tmp78_ = position;
#line 196 "../src/sudoku-printer.vala"
				cairo_line_to (cr, ((size - _tmp76_) - (_tmp77_ / 2.0)) + offset_x, _tmp78_ + offset_y);
#line 197 "../src/sudoku-printer.vala"
				_tmp79_ = position;
#line 197 "../src/sudoku-printer.vala"
				_tmp80_ = BORDER;
#line 197 "../src/sudoku-printer.vala"
				_tmp81_ = THICK;
#line 197 "../src/sudoku-printer.vala"
				cairo_move_to (cr, _tmp79_ + offset_x, (_tmp80_ + (_tmp81_ / 2.0)) + offset_y);
#line 198 "../src/sudoku-printer.vala"
				_tmp82_ = position;
#line 198 "../src/sudoku-printer.vala"
				_tmp83_ = BORDER;
#line 198 "../src/sudoku-printer.vala"
				_tmp84_ = THICK;
#line 198 "../src/sudoku-printer.vala"
				cairo_line_to (cr, _tmp82_ + offset_x, ((size - _tmp83_) - (_tmp84_ / 2.0)) + offset_y);
#line 199 "../src/sudoku-printer.vala"
				cairo_stroke (cr);
#line 1219 "sudoku-printer.c"
			}
		}
	}
#line 202 "../src/sudoku-printer.vala"
	_tmp85_ = FONT_SIZE;
#line 202 "../src/sudoku-printer.vala"
	cairo_set_font_size (cr, (gdouble) _tmp85_);
#line 203 "../src/sudoku-printer.vala"
	_tmp86_ = g_strdup ("");
#line 203 "../src/sudoku-printer.vala"
	letter = _tmp86_;
#line 205 "../src/sudoku-printer.vala"
	_tmp89_ = sudoku_board_get_cells (sudoku_board, &_tmp87_, &_tmp88_);
#line 205 "../src/sudoku-printer.vala"
	sudoku = _tmp89_;
#line 205 "../src/sudoku-printer.vala"
	sudoku_length1 = _tmp87_;
#line 205 "../src/sudoku-printer.vala"
	sudoku_length2 = _tmp88_;
#line 207 "../src/sudoku-printer.vala"
	invert = gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL;
#line 1241 "sudoku-printer.c"
	{
		gint x = 0;
#line 209 "../src/sudoku-printer.vala"
		x = 0;
#line 1246 "sudoku-printer.c"
		{
			gboolean _tmp90_ = FALSE;
#line 209 "../src/sudoku-printer.vala"
			_tmp90_ = TRUE;
#line 209 "../src/sudoku-printer.vala"
			while (TRUE) {
#line 1253 "sudoku-printer.c"
				gint _tmp92_;
				gint _tmp93_ = 0;
				gboolean _tmp94_;
				gint real_x = 0;
#line 209 "../src/sudoku-printer.vala"
				if (!_tmp90_) {
#line 1260 "sudoku-printer.c"
					gint _tmp91_;
#line 209 "../src/sudoku-printer.vala"
					_tmp91_ = x;
#line 209 "../src/sudoku-printer.vala"
					x = _tmp91_ + 1;
#line 1266 "sudoku-printer.c"
				}
#line 209 "../src/sudoku-printer.vala"
				_tmp90_ = FALSE;
#line 209 "../src/sudoku-printer.vala"
				_tmp92_ = x;
#line 209 "../src/sudoku-printer.vala"
				if (!(_tmp92_ < SUDOKU_SIZE)) {
#line 209 "../src/sudoku-printer.vala"
					break;
#line 1276 "sudoku-printer.c"
				}
#line 211 "../src/sudoku-printer.vala"
				_tmp94_ = invert;
#line 211 "../src/sudoku-printer.vala"
				if (_tmp94_) {
#line 1282 "sudoku-printer.c"
					gint _tmp95_;
#line 211 "../src/sudoku-printer.vala"
					_tmp95_ = x;
#line 211 "../src/sudoku-printer.vala"
					_tmp93_ = (SUDOKU_SIZE - _tmp95_) - 1;
#line 1288 "sudoku-printer.c"
				} else {
					gint _tmp96_;
#line 211 "../src/sudoku-printer.vala"
					_tmp96_ = x;
#line 211 "../src/sudoku-printer.vala"
					_tmp93_ = _tmp96_;
#line 1295 "sudoku-printer.c"
				}
#line 211 "../src/sudoku-printer.vala"
				real_x = _tmp93_;
#line 1299 "sudoku-printer.c"
				{
					gint y = 0;
#line 212 "../src/sudoku-printer.vala"
					y = 0;
#line 1304 "sudoku-printer.c"
					{
						gboolean _tmp97_ = FALSE;
#line 212 "../src/sudoku-printer.vala"
						_tmp97_ = TRUE;
#line 212 "../src/sudoku-printer.vala"
						while (TRUE) {
#line 1311 "sudoku-printer.c"
							gint _tmp99_;
							gdouble* _tmp100_;
							gint _tmp100__length1;
							gint _tmp101_;
							gdouble _tmp102_;
							gdouble* _tmp103_;
							gint _tmp103__length1;
							gint _tmp104_;
							gdouble _tmp105_;
							gchar* _tmp106_;
							gint* _tmp107_;
							gint _tmp107__length1;
							gint _tmp107__length2;
							gint _tmp108_;
							gint _tmp109_;
							gint _tmp110_;
#line 212 "../src/sudoku-printer.vala"
							if (!_tmp97_) {
#line 1330 "sudoku-printer.c"
								gint _tmp98_;
#line 212 "../src/sudoku-printer.vala"
								_tmp98_ = y;
#line 212 "../src/sudoku-printer.vala"
								y = _tmp98_ + 1;
#line 1336 "sudoku-printer.c"
							}
#line 212 "../src/sudoku-printer.vala"
							_tmp97_ = FALSE;
#line 212 "../src/sudoku-printer.vala"
							_tmp99_ = y;
#line 212 "../src/sudoku-printer.vala"
							if (!(_tmp99_ < SUDOKU_SIZE)) {
#line 212 "../src/sudoku-printer.vala"
								break;
#line 1346 "sudoku-printer.c"
							}
#line 214 "../src/sudoku-printer.vala"
							_tmp100_ = pos;
#line 214 "../src/sudoku-printer.vala"
							_tmp100__length1 = pos_length1;
#line 214 "../src/sudoku-printer.vala"
							_tmp101_ = x;
#line 214 "../src/sudoku-printer.vala"
							_tmp102_ = _tmp100_[_tmp101_];
#line 214 "../src/sudoku-printer.vala"
							_tmp103_ = pos;
#line 214 "../src/sudoku-printer.vala"
							_tmp103__length1 = pos_length1;
#line 214 "../src/sudoku-printer.vala"
							_tmp104_ = y;
#line 214 "../src/sudoku-printer.vala"
							_tmp105_ = _tmp103_[_tmp104_];
#line 214 "../src/sudoku-printer.vala"
							cairo_move_to (cr, _tmp102_ + offset_x, _tmp105_ + offset_y);
#line 215 "../src/sudoku-printer.vala"
							_tmp106_ = g_strdup ("");
#line 215 "../src/sudoku-printer.vala"
							_g_free0 (letter);
#line 215 "../src/sudoku-printer.vala"
							letter = _tmp106_;
#line 217 "../src/sudoku-printer.vala"
							_tmp107_ = sudoku;
#line 217 "../src/sudoku-printer.vala"
							_tmp107__length1 = sudoku_length1;
#line 217 "../src/sudoku-printer.vala"
							_tmp107__length2 = sudoku_length2;
#line 217 "../src/sudoku-printer.vala"
							_tmp108_ = y;
#line 217 "../src/sudoku-printer.vala"
							_tmp109_ = real_x;
#line 217 "../src/sudoku-printer.vala"
							_tmp110_ = _tmp107_[(_tmp108_ * _tmp107__length2) + _tmp109_];
#line 217 "../src/sudoku-printer.vala"
							if (_tmp110_ != 0) {
#line 1386 "sudoku-printer.c"
								gint* _tmp111_;
								gint _tmp111__length1;
								gint _tmp111__length2;
								gint _tmp112_;
								gint _tmp113_;
								gint _tmp114_;
								gchar* _tmp115_;
								gboolean* _tmp116_;
								gint _tmp116__length1;
								gint _tmp116__length2;
								gint _tmp117_;
								gint _tmp118_;
								gboolean _tmp119_;
								const gchar* _tmp123_;
								cairo_text_extents_t _tmp124_ = {0};
								gdouble* _tmp125_;
								gint _tmp125__length1;
								gint _tmp126_;
								gdouble _tmp127_;
								cairo_text_extents_t _tmp128_;
								gdouble _tmp129_;
								gdouble* _tmp130_;
								gint _tmp130__length1;
								gint _tmp131_;
								gdouble _tmp132_;
								cairo_text_extents_t _tmp133_;
								gdouble _tmp134_;
								const gchar* _tmp135_;
#line 219 "../src/sudoku-printer.vala"
								_tmp111_ = sudoku;
#line 219 "../src/sudoku-printer.vala"
								_tmp111__length1 = sudoku_length1;
#line 219 "../src/sudoku-printer.vala"
								_tmp111__length2 = sudoku_length2;
#line 219 "../src/sudoku-printer.vala"
								_tmp112_ = y;
#line 219 "../src/sudoku-printer.vala"
								_tmp113_ = real_x;
#line 219 "../src/sudoku-printer.vala"
								_tmp114_ = _tmp111_[(_tmp112_ * _tmp111__length2) + _tmp113_];
#line 219 "../src/sudoku-printer.vala"
								_tmp115_ = g_strdup_printf ("%i", _tmp114_);
#line 219 "../src/sudoku-printer.vala"
								_g_free0 (letter);
#line 219 "../src/sudoku-printer.vala"
								letter = _tmp115_;
#line 221 "../src/sudoku-printer.vala"
								_tmp116_ = sudoku_board->is_fixed;
#line 221 "../src/sudoku-printer.vala"
								_tmp116__length1 = sudoku_board->is_fixed_length1;
#line 221 "../src/sudoku-printer.vala"
								_tmp116__length2 = sudoku_board->is_fixed_length2;
#line 221 "../src/sudoku-printer.vala"
								_tmp117_ = y;
#line 221 "../src/sudoku-printer.vala"
								_tmp118_ = real_x;
#line 221 "../src/sudoku-printer.vala"
								_tmp119_ = _tmp116_[(_tmp117_ * _tmp116__length2) + _tmp118_];
#line 221 "../src/sudoku-printer.vala"
								if (_tmp119_) {
#line 223 "../src/sudoku-printer.vala"
									cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_NORMAL, FONT_WEIGHT);
#line 224 "../src/sudoku-printer.vala"
									cairo_set_source_rgb (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 1451 "sudoku-printer.c"
								} else {
									gdouble _tmp120_;
									gdouble _tmp121_;
									gdouble _tmp122_;
#line 228 "../src/sudoku-printer.vala"
									cairo_select_font_face (cr, "Sans", CAIRO_FONT_SLANT_ITALIC, FONT_WEIGHT);
#line 229 "../src/sudoku-printer.vala"
									_tmp120_ = PENCIL_GREY[0];
#line 229 "../src/sudoku-printer.vala"
									_tmp121_ = PENCIL_GREY[1];
#line 229 "../src/sudoku-printer.vala"
									_tmp122_ = PENCIL_GREY[2];
#line 229 "../src/sudoku-printer.vala"
									cairo_set_source_rgb (cr, _tmp120_, _tmp121_, _tmp122_);
#line 1466 "sudoku-printer.c"
								}
#line 231 "../src/sudoku-printer.vala"
								_tmp123_ = letter;
#line 231 "../src/sudoku-printer.vala"
								cairo_text_extents (cr, _tmp123_, &_tmp124_);
#line 231 "../src/sudoku-printer.vala"
								extents = _tmp124_;
#line 232 "../src/sudoku-printer.vala"
								_tmp125_ = pos;
#line 232 "../src/sudoku-printer.vala"
								_tmp125__length1 = pos_length1;
#line 232 "../src/sudoku-printer.vala"
								_tmp126_ = x;
#line 232 "../src/sudoku-printer.vala"
								_tmp127_ = _tmp125_[_tmp126_];
#line 232 "../src/sudoku-printer.vala"
								_tmp128_ = extents;
#line 232 "../src/sudoku-printer.vala"
								_tmp129_ = _tmp128_.x_advance;
#line 232 "../src/sudoku-printer.vala"
								_tmp130_ = pos;
#line 232 "../src/sudoku-printer.vala"
								_tmp130__length1 = pos_length1;
#line 232 "../src/sudoku-printer.vala"
								_tmp131_ = y;
#line 232 "../src/sudoku-printer.vala"
								_tmp132_ = _tmp130_[_tmp131_];
#line 232 "../src/sudoku-printer.vala"
								_tmp133_ = extents;
#line 232 "../src/sudoku-printer.vala"
								_tmp134_ = _tmp133_.height;
#line 232 "../src/sudoku-printer.vala"
								cairo_move_to (cr, (_tmp127_ + offset_x) - (_tmp129_ / 2.0), (_tmp132_ + offset_y) + (_tmp134_ / 2.0));
#line 233 "../src/sudoku-printer.vala"
								_tmp135_ = letter;
#line 233 "../src/sudoku-printer.vala"
								cairo_show_text (cr, _tmp135_);
#line 1504 "sudoku-printer.c"
							}
						}
					}
				}
			}
		}
	}
#line 129 "../src/sudoku-printer.vala"
	sudoku = (g_free (sudoku), NULL);
#line 129 "../src/sudoku-printer.vala"
	_g_free0 (letter);
#line 129 "../src/sudoku-printer.vala"
	pos = (g_free (pos), NULL);
#line 129 "../src/sudoku-printer.vala"
	outer = (g_free (outer), NULL);
#line 1520 "sudoku-printer.c"
}


static void
sudoku_printer_class_init (SudokuPrinterClass * klass)
{
#line 25 "../src/sudoku-printer.vala"
	sudoku_printer_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/sudoku-printer.vala"
	g_type_class_adjust_private_offset (klass, &SudokuPrinter_private_offset);
#line 25 "../src/sudoku-printer.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_printer_finalize;
#line 1533 "sudoku-printer.c"
}


static void
sudoku_printer_instance_init (SudokuPrinter * self)
{
#line 25 "../src/sudoku-printer.vala"
	self->priv = sudoku_printer_get_instance_private (self);
#line 1542 "sudoku-printer.c"
}


static void
sudoku_printer_finalize (GObject * obj)
{
	SudokuPrinter * self;
#line 25 "../src/sudoku-printer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_PRINTER, SudokuPrinter);
#line 27 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->boards);
#line 28 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->window);
#line 34 "../src/sudoku-printer.vala"
	_g_object_unref0 (self->priv->print_op);
#line 25 "../src/sudoku-printer.vala"
	G_OBJECT_CLASS (sudoku_printer_parent_class)->finalize (obj);
#line 1560 "sudoku-printer.c"
}


GType
sudoku_printer_get_type (void)
{
	static volatile gsize sudoku_printer_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_printer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuPrinterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_printer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuPrinter), 0, (GInstanceInitFunc) sudoku_printer_instance_init, NULL };
		GType sudoku_printer_type_id;
		sudoku_printer_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuPrinter", &g_define_type_info, 0);
		SudokuPrinter_private_offset = g_type_add_instance_private (sudoku_printer_type_id, sizeof (SudokuPrinterPrivate));
		g_once_init_leave (&sudoku_printer_type_id__volatile, sudoku_printer_type_id);
	}
	return sudoku_printer_type_id__volatile;
}



