/* sudoku-view.c generated by valac 0.42.3, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include "libsudoku.h"
#include <gdk/gdk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <pango/pangocairo.h>
#include <glib/gi18n-lib.h>


#define TYPE_SUDOKU_CELL_VIEW (sudoku_cell_view_get_type ())
#define SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellView))
#define SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))
#define IS_SUDOKU_CELL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL_VIEW))
#define IS_SUDOKU_CELL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL_VIEW))
#define SUDOKU_CELL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL_VIEW, SudokuCellViewClass))

typedef struct _SudokuCellView SudokuCellView;
typedef struct _SudokuCellViewClass SudokuCellViewClass;
typedef struct _SudokuCellViewPrivate SudokuCellViewPrivate;

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
enum  {
	SUDOKU_CELL_VIEW_0_PROPERTY,
	SUDOKU_CELL_VIEW_VALUE_PROPERTY,
	SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_VIEW_SELECTED_PROPERTY,
	SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY,
	SUDOKU_CELL_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_view_properties[SUDOKU_CELL_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
typedef struct _Block7Data Block7Data;
typedef struct _Block8Data Block8Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuCellView {
	GtkDrawingArea parent_instance;
	SudokuCellViewPrivate * priv;
};

struct _SudokuCellViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _SudokuCellViewPrivate {
	PangoLayout* layout;
	gdouble size_ratio;
	GtkPopover* popover;
	GtkPopover* earmark_popover;
	SudokuGame* game;
	gint row;
	gint col;
	gboolean _show_possibilities;
	gboolean _show_warnings;
	gboolean _selected;
	GdkRGBA _background_color;
	NumberPicker* number_picker;
	NumberPicker* earmark_picker;
};

struct _SudokuView {
	GtkAspectFrame parent_instance;
	SudokuViewPrivate * priv;
	SudokuGame* game;
};

struct _SudokuViewClass {
	GtkAspectFrameClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuCellView** cells;
	gint cells_length1;
	gint cells_length2;
	gboolean previous_board_broken_state;
	GtkOverlay* overlay;
	GtkDrawingArea* drawing;
	GtkGrid* grid;
	gint selected_row;
	gint selected_col;
	gboolean _show_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
};

struct _Block7Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	gint cell_row;
	gint cell_col;
};


static gint SudokuCellView_private_offset;
static gpointer sudoku_cell_view_parent_class = NULL;
static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

GType sudoku_cell_view_get_type (void) G_GNUC_CONST;
GType number_picker_get_type (void) G_GNUC_CONST;
SudokuCellView* sudoku_cell_view_new (gint row,
                                      gint col,
                                      SudokuGame* * game);
SudokuCellView* sudoku_cell_view_construct (GType object_type,
                                            gint row,
                                            gint col,
                                            SudokuGame* * game);
void sudoku_cell_view_set_value (SudokuCellView* self,
                                 gint value);
gboolean sudoku_cell_view_get_is_fixed (SudokuCellView* self);
static gboolean sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                                        GtkWidget* widget,
                                        GdkEventFocus* event);
static gboolean _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                    GdkEventFocus* event,
                                                                    gpointer self);
void sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                       gint row,
                                       gint col,
                                       gint old_val,
                                       gint new_val);
static void _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                                 gint row,
                                                                 gint col,
                                                                 gint old_val,
                                                                 gint new_val,
                                                                 gpointer self);
static gboolean sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                                   GdkEventButton* event);
static void sudoku_cell_view_hide_both_popovers (SudokuCellView* self);
static void sudoku_cell_view_show_earmark_picker (SudokuCellView* self);
static void sudoku_cell_view_show_number_picker (SudokuCellView* self);
static void sudoku_cell_view_create_earmark_picker (SudokuCellView* self);
NumberPicker* number_picker_new (SudokuBoard* * board,
                                 gboolean earmark);
NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard* * board,
                                       gboolean earmark);
static void __lambda7_ (SudokuCellView* self,
                 gint number,
                 gboolean state);
gint sudoku_cell_view_get_value (SudokuCellView* self);
static void ___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda10_ (SudokuCellView* self,
                  NumberPicker* o,
                  gint number);
static void ___lambda10__number_picker_number_picked (NumberPicker* _sender,
                                               gint number,
                                               gpointer self);
void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
static void __lambda11_ (SudokuCellView* self);
static void sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                       GtkPopover* * popover);
static void ___lambda11__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean __lambda12_ (SudokuCellView* self);
static gboolean ___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                  GdkEventFocus* event,
                                                  gpointer self);
static void __lambda8_ (SudokuCellView* self);
static void ___lambda8__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static gboolean __lambda9_ (SudokuCellView* self);
static gboolean ___lambda9__gtk_widget_focus_out_event (GtkWidget* _sender,
                                                 GdkEventFocus* event,
                                                 gpointer self);
static gint sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                      const gchar* key_name);
static gboolean sudoku_cell_view_real_key_press_event (GtkWidget* base,
                                                GdkEventKey* event);
gboolean number_picker_set_earmark (NumberPicker* self,
                                    gint row,
                                    gint col,
                                    gint index,
                                    gboolean state);
static gboolean sudoku_cell_view_real_draw (GtkWidget* base,
                                     cairo_t* c);
void sudoku_cell_view_set_background_color (SudokuCellView* self,
                                            GdkRGBA * value);
void sudoku_cell_view_clear (SudokuCellView* self);
gboolean sudoku_cell_view_get_show_possibilities (SudokuCellView* self);
void sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                              gboolean value);
gboolean sudoku_cell_view_get_show_warnings (SudokuCellView* self);
void sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                         gboolean value);
gboolean sudoku_cell_view_get_selected (SudokuCellView* self);
void sudoku_cell_view_set_selected (SudokuCellView* self,
                                    gboolean value);
void sudoku_cell_view_get_background_color (SudokuCellView* self,
                                            GdkRGBA * result);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static void sudoku_cell_view_finalize (GObject * obj);
static void _vala_sudoku_cell_view_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_sudoku_cell_view_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
GType sudoku_view_get_type (void) G_GNUC_CONST;
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
SudokuView* sudoku_view_new (SudokuGame* game);
SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean sudoku_view_draw_board (SudokuView* self,
                                 cairo_t* c);
static gboolean _sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                                  cairo_t* cr,
                                                  gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean ________lambda13_ (Block8Data* _data8_);
static gboolean _________lambda13__gtk_widget_focus_in_event (GtkWidget* _sender,
                                                       GdkEventFocus* event,
                                                       gpointer self);
static void ________lambda14_ (Block8Data* _data8_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda14__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
void sudoku_view_clear (SudokuView* self);
gboolean sudoku_view_get_show_warnings (SudokuView* self);
void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
gboolean sudoku_view_get_show_possibilities (SudokuView* self);
void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
gboolean sudoku_view_get_highlighter (SudokuView* self);
void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static void sudoku_view_finalize (GObject * obj);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const GdkRGBA selected_bg_color = {0.7, 0.8, 0.9};
const GdkRGBA fixed_cell_color = {0.8, 0.8, 0.8, (gdouble) 0};
const GdkRGBA free_cell_color = {1.0, 1.0, 1.0, 1.0};
const GdkRGBA highlight_color = {0.93, 0.93, 0.93, (gdouble) 0};

static inline gpointer
sudoku_cell_view_get_instance_private (SudokuCellView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCellView_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 109 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 353 "sudoku-view.c"
}


static gboolean
_sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                           GdkEventFocus* event,
                                                           gpointer self)
{
	gboolean result;
	result = sudoku_cell_view_focus_out_cb ((SudokuCellView*) self, _sender, event);
#line 124 "../src/sudoku-view.vala"
	return result;
#line 366 "sudoku-view.c"
}


static void
_sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self)
{
#line 125 "../src/sudoku-view.vala"
	sudoku_cell_view_cell_changed_cb ((SudokuCellView*) self, row, col, old_val, new_val);
#line 380 "sudoku-view.c"
}


SudokuCellView*
sudoku_cell_view_construct (GType object_type,
                            gint row,
                            gint col,
                            SudokuGame* * game)
{
	SudokuCellView * self = NULL;
	SudokuGame* _tmp0_;
	GtkStyle* _tmp1_;
	GtkStyle* _tmp2_;
	PangoFontDescription* _tmp3_;
	SudokuBoard* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 107 "../src/sudoku-view.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 107 "../src/sudoku-view.vala"
	self = (SudokuCellView*) g_object_new (object_type, NULL);
#line 109 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 109 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 109 "../src/sudoku-view.vala"
	self->priv->game = _tmp0_;
#line 110 "../src/sudoku-view.vala"
	self->priv->row = row;
#line 111 "../src/sudoku-view.vala"
	self->priv->col = col;
#line 113 "../src/sudoku-view.vala"
	_tmp1_ = gtk_widget_get_style ((GtkWidget*) self);
#line 113 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 113 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->font_desc;
#line 113 "../src/sudoku-view.vala"
	pango_font_description_set_size (_tmp3_, PANGO_SCALE * 13);
#line 114 "../src/sudoku-view.vala"
	_tmp4_ = (*game)->board;
#line 114 "../src/sudoku-view.vala"
	sudoku_cell_view_set_value (self, sudoku_board_get (_tmp4_, row, col));
#line 118 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 119 "../src/sudoku-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, ((GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_KEY_PRESS_MASK);
#line 121 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_cell_view_get_is_fixed (self);
#line 121 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 121 "../src/sudoku-view.vala"
	if (_tmp7_) {
#line 435 "sudoku-view.c"
		GameMode _tmp8_;
#line 121 "../src/sudoku-view.vala"
		_tmp8_ = (*game)->mode;
#line 121 "../src/sudoku-view.vala"
		_tmp5_ = _tmp8_ == GAME_MODE_PLAY;
#line 441 "sudoku-view.c"
	} else {
#line 121 "../src/sudoku-view.vala"
		_tmp5_ = FALSE;
#line 445 "sudoku-view.c"
	}
#line 121 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 122 "../src/sudoku-view.vala"
		return self;
#line 451 "sudoku-view.c"
	}
#line 124 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) self, "focus-out-event", (GCallback) _sudoku_cell_view_focus_out_cb_gtk_widget_focus_out_event, self, 0);
#line 125 "../src/sudoku-view.vala"
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_view_cell_changed_cb_sudoku_game_cell_changed, self, 0);
#line 107 "../src/sudoku-view.vala"
	return self;
#line 459 "sudoku-view.c"
}


SudokuCellView*
sudoku_cell_view_new (gint row,
                      gint col,
                      SudokuGame* * game)
{
#line 107 "../src/sudoku-view.vala"
	return sudoku_cell_view_construct (TYPE_SUDOKU_CELL_VIEW, row, col, game);
#line 470 "sudoku-view.c"
}


static gboolean
sudoku_cell_view_real_button_press_event (GtkWidget* base,
                                          GdkEventButton* event)
{
	SudokuCellView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	SudokuGame* _tmp6_;
	GameMode _tmp7_;
	gboolean _tmp14_ = FALSE;
	GtkPopover* _tmp15_;
	guint _tmp17_;
#line 128 "../src/sudoku-view.vala"
	self = (SudokuCellView*) base;
#line 128 "../src/sudoku-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 130 "../src/sudoku-view.vala"
	_tmp1_ = event->button;
#line 130 "../src/sudoku-view.vala"
	if (_tmp1_ != ((guint) 1)) {
#line 498 "sudoku-view.c"
		guint _tmp2_;
#line 130 "../src/sudoku-view.vala"
		_tmp2_ = event->button;
#line 130 "../src/sudoku-view.vala"
		_tmp0_ = _tmp2_ != ((guint) 3);
#line 504 "sudoku-view.c"
	} else {
#line 130 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 508 "sudoku-view.c"
	}
#line 130 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 131 "../src/sudoku-view.vala"
		result = FALSE;
#line 131 "../src/sudoku-view.vala"
		return result;
#line 516 "sudoku-view.c"
	}
#line 133 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) self, "is-focus", &_tmp3_, NULL);
#line 133 "../src/sudoku-view.vala"
	_tmp4_ = _tmp3_;
#line 133 "../src/sudoku-view.vala"
	if (!_tmp4_) {
#line 134 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 526 "sudoku-view.c"
	}
#line 135 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->game;
#line 135 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_->mode;
#line 135 "../src/sudoku-view.vala"
	if (_tmp7_ == GAME_MODE_PLAY) {
#line 534 "sudoku-view.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 135 "../src/sudoku-view.vala"
		_tmp9_ = sudoku_cell_view_get_is_fixed (self);
#line 135 "../src/sudoku-view.vala"
		_tmp10_ = _tmp9_;
#line 135 "../src/sudoku-view.vala"
		if (_tmp10_) {
#line 135 "../src/sudoku-view.vala"
			_tmp8_ = TRUE;
#line 546 "sudoku-view.c"
		} else {
			SudokuGame* _tmp11_;
			gboolean _tmp12_;
			gboolean _tmp13_;
#line 135 "../src/sudoku-view.vala"
			_tmp11_ = self->priv->game;
#line 135 "../src/sudoku-view.vala"
			_tmp12_ = sudoku_game_get_paused (_tmp11_);
#line 135 "../src/sudoku-view.vala"
			_tmp13_ = _tmp12_;
#line 135 "../src/sudoku-view.vala"
			_tmp8_ = _tmp13_;
#line 559 "sudoku-view.c"
		}
#line 135 "../src/sudoku-view.vala"
		_tmp5_ = _tmp8_;
#line 563 "sudoku-view.c"
	} else {
#line 135 "../src/sudoku-view.vala"
		_tmp5_ = FALSE;
#line 567 "sudoku-view.c"
	}
#line 135 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 136 "../src/sudoku-view.vala"
		result = FALSE;
#line 136 "../src/sudoku-view.vala"
		return result;
#line 575 "sudoku-view.c"
	}
#line 138 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->popover;
#line 138 "../src/sudoku-view.vala"
	if (_tmp15_ != NULL) {
#line 138 "../src/sudoku-view.vala"
		_tmp14_ = TRUE;
#line 583 "sudoku-view.c"
	} else {
		GtkPopover* _tmp16_;
#line 138 "../src/sudoku-view.vala"
		_tmp16_ = self->priv->earmark_popover;
#line 138 "../src/sudoku-view.vala"
		_tmp14_ = _tmp16_ != NULL;
#line 590 "sudoku-view.c"
	}
#line 138 "../src/sudoku-view.vala"
	if (_tmp14_) {
#line 140 "../src/sudoku-view.vala"
		sudoku_cell_view_hide_both_popovers (self);
#line 141 "../src/sudoku-view.vala"
		result = FALSE;
#line 141 "../src/sudoku-view.vala"
		return result;
#line 600 "sudoku-view.c"
	}
#line 144 "../src/sudoku-view.vala"
	_tmp17_ = event->button;
#line 144 "../src/sudoku-view.vala"
	if (_tmp17_ == ((guint) 1)) {
#line 606 "sudoku-view.c"
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_;
#line 146 "../src/sudoku-view.vala"
		_tmp20_ = self->priv->_show_possibilities;
#line 146 "../src/sudoku-view.vala"
		if (!_tmp20_) {
#line 614 "sudoku-view.c"
			GdkModifierType _tmp21_;
#line 146 "../src/sudoku-view.vala"
			_tmp21_ = event->state;
#line 146 "../src/sudoku-view.vala"
			_tmp19_ = (_tmp21_ & GDK_CONTROL_MASK) > 0;
#line 620 "sudoku-view.c"
		} else {
#line 146 "../src/sudoku-view.vala"
			_tmp19_ = FALSE;
#line 624 "sudoku-view.c"
		}
#line 146 "../src/sudoku-view.vala"
		if (_tmp19_) {
#line 628 "sudoku-view.c"
			SudokuGame* _tmp22_;
			GameMode _tmp23_;
#line 146 "../src/sudoku-view.vala"
			_tmp22_ = self->priv->game;
#line 146 "../src/sudoku-view.vala"
			_tmp23_ = _tmp22_->mode;
#line 146 "../src/sudoku-view.vala"
			_tmp18_ = _tmp23_ == GAME_MODE_PLAY;
#line 637 "sudoku-view.c"
		} else {
#line 146 "../src/sudoku-view.vala"
			_tmp18_ = FALSE;
#line 641 "sudoku-view.c"
		}
#line 146 "../src/sudoku-view.vala"
		if (_tmp18_) {
#line 147 "../src/sudoku-view.vala"
			sudoku_cell_view_show_earmark_picker (self);
#line 647 "sudoku-view.c"
		} else {
#line 149 "../src/sudoku-view.vala"
			sudoku_cell_view_show_number_picker (self);
#line 651 "sudoku-view.c"
		}
	} else {
		gboolean _tmp24_ = FALSE;
		gboolean _tmp25_ = FALSE;
		gboolean _tmp26_;
#line 151 "../src/sudoku-view.vala"
		_tmp26_ = self->priv->_show_possibilities;
#line 151 "../src/sudoku-view.vala"
		if (!_tmp26_) {
#line 661 "sudoku-view.c"
			guint _tmp27_;
#line 151 "../src/sudoku-view.vala"
			_tmp27_ = event->button;
#line 151 "../src/sudoku-view.vala"
			_tmp25_ = _tmp27_ == ((guint) 3);
#line 667 "sudoku-view.c"
		} else {
#line 151 "../src/sudoku-view.vala"
			_tmp25_ = FALSE;
#line 671 "sudoku-view.c"
		}
#line 151 "../src/sudoku-view.vala"
		if (_tmp25_) {
#line 675 "sudoku-view.c"
			SudokuGame* _tmp28_;
			GameMode _tmp29_;
#line 151 "../src/sudoku-view.vala"
			_tmp28_ = self->priv->game;
#line 151 "../src/sudoku-view.vala"
			_tmp29_ = _tmp28_->mode;
#line 151 "../src/sudoku-view.vala"
			_tmp24_ = _tmp29_ == GAME_MODE_PLAY;
#line 684 "sudoku-view.c"
		} else {
#line 151 "../src/sudoku-view.vala"
			_tmp24_ = FALSE;
#line 688 "sudoku-view.c"
		}
#line 151 "../src/sudoku-view.vala"
		if (_tmp24_) {
#line 152 "../src/sudoku-view.vala"
			sudoku_cell_view_show_earmark_picker (self);
#line 694 "sudoku-view.c"
		}
	}
#line 154 "../src/sudoku-view.vala"
	result = FALSE;
#line 154 "../src/sudoku-view.vala"
	return result;
#line 701 "sudoku-view.c"
}


static void
__lambda7_ (SudokuCellView* self,
            gint number,
            gboolean state)
{
	SudokuGame* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
#line 161 "../src/sudoku-view.vala"
	if (state) {
#line 719 "sudoku-view.c"
		SudokuGame* _tmp0_;
		SudokuBoard* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 162 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->game;
#line 162 "../src/sudoku-view.vala"
		_tmp1_ = _tmp0_->board;
#line 162 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->row;
#line 162 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->col;
#line 162 "../src/sudoku-view.vala"
		sudoku_board_enable_earmark (_tmp1_, _tmp2_, _tmp3_, number);
#line 734 "sudoku-view.c"
	} else {
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 164 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->game;
#line 164 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_->board;
#line 164 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->row;
#line 164 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->col;
#line 164 "../src/sudoku-view.vala"
		sudoku_board_disable_earmark (_tmp5_, _tmp6_, _tmp7_, number);
#line 750 "sudoku-view.c"
	}
#line 165 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->game;
#line 165 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->row;
#line 165 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->col;
#line 165 "../src/sudoku-view.vala"
	_tmp11_ = sudoku_cell_view_get_value (self);
#line 165 "../src/sudoku-view.vala"
	_tmp12_ = _tmp11_;
#line 165 "../src/sudoku-view.vala"
	_tmp13_ = sudoku_cell_view_get_value (self);
#line 165 "../src/sudoku-view.vala"
	_tmp14_ = _tmp13_;
#line 165 "../src/sudoku-view.vala"
	g_signal_emit_by_name (_tmp8_, "cell-changed", _tmp9_, _tmp10_, _tmp12_, _tmp14_);
#line 166 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 770 "sudoku-view.c"
}


static void
___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
#line 160 "../src/sudoku-view.vala"
	__lambda7_ ((SudokuCellView*) self, number, active);
#line 782 "sudoku-view.c"
}


static void
sudoku_cell_view_create_earmark_picker (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	NumberPicker* _tmp2_;
	NumberPicker* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 157 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 159 "../src/sudoku-view.vala"
	_tmp1_ = number_picker_new (&_tmp0_->board, TRUE);
#line 159 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 159 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_picker);
#line 159 "../src/sudoku-view.vala"
	self->priv->earmark_picker = _tmp1_;
#line 160 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->earmark_picker;
#line 160 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp2_, "earmark-state-changed", (GCallback) ___lambda7__number_picker_earmark_state_changed, self, 0);
#line 168 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->earmark_picker;
#line 168 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->row;
#line 168 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->col;
#line 168 "../src/sudoku-view.vala"
	number_picker_set_earmarks (_tmp3_, _tmp4_, _tmp5_);
#line 819 "sudoku-view.c"
}


static void
__lambda10_ (SudokuCellView* self,
             NumberPicker* o,
             gint number)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkPopover* _tmp4_;
#line 177 "../src/sudoku-view.vala"
	g_return_if_fail (o != NULL);
#line 178 "../src/sudoku-view.vala"
	sudoku_cell_view_set_value (self, number);
#line 179 "../src/sudoku-view.vala"
	if (number == 0) {
#line 180 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 841 "sudoku-view.c"
	}
#line 181 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 181 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 181 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->row;
#line 181 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->col;
#line 181 "../src/sudoku-view.vala"
	sudoku_board_disable_all_earmarks (_tmp1_, _tmp2_, _tmp3_);
#line 183 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->popover;
#line 183 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp4_);
#line 857 "sudoku-view.c"
}


static void
___lambda10__number_picker_number_picked (NumberPicker* _sender,
                                          gint number,
                                          gpointer self)
{
#line 177 "../src/sudoku-view.vala"
	__lambda10_ ((SudokuCellView*) self, _sender, number);
#line 868 "sudoku-view.c"
}


static void
__lambda11_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 192 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 192 "../src/sudoku-view.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 192 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 192 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 193 "../src/sudoku-view.vala"
		sudoku_cell_view_destroy_popover (self, &self->priv->popover);
#line 888 "sudoku-view.c"
	}
}


static void
___lambda11__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 191 "../src/sudoku-view.vala"
	__lambda11_ ((SudokuCellView*) self);
#line 900 "sudoku-view.c"
}


static gboolean
__lambda12_ (SudokuCellView* self)
{
	gboolean result = FALSE;
	GtkPopover* _tmp0_;
#line 196 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 196 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 197 "../src/sudoku-view.vala"
	result = TRUE;
#line 197 "../src/sudoku-view.vala"
	return result;
#line 917 "sudoku-view.c"
}


static gboolean
___lambda12__gtk_widget_focus_out_event (GtkWidget* _sender,
                                         GdkEventFocus* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda12_ ((SudokuCellView*) self);
#line 195 "../src/sudoku-view.vala"
	return result;
#line 930 "sudoku-view.c"
}


static void
sudoku_cell_view_show_number_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	SudokuGame* _tmp2_;
	NumberPicker* _tmp3_;
	NumberPicker* _tmp4_;
	NumberPicker* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
	NumberPicker* _tmp10_;
	GtkPopover* _tmp11_;
	GtkPopover* _tmp12_;
	GtkPopover* _tmp13_;
	GtkPopover* _tmp14_;
	GtkPopover* _tmp15_;
#line 171 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 173 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 958 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 174 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->earmark_popover;
#line 174 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 964 "sudoku-view.c"
	}
#line 176 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->game;
#line 176 "../src/sudoku-view.vala"
	_tmp3_ = number_picker_new (&_tmp2_->board, FALSE);
#line 176 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 176 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->number_picker);
#line 176 "../src/sudoku-view.vala"
	self->priv->number_picker = _tmp3_;
#line 177 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->number_picker;
#line 177 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp4_, "number-picked", (GCallback) ___lambda10__number_picker_number_picked, self, 0);
#line 185 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->number_picker;
#line 185 "../src/sudoku-view.vala"
	_tmp6_ = sudoku_cell_view_get_value (self);
#line 185 "../src/sudoku-view.vala"
	_tmp7_ = _tmp6_;
#line 185 "../src/sudoku-view.vala"
	number_picker_set_clear_button_visibility (_tmp5_, _tmp7_ != 0);
#line 187 "../src/sudoku-view.vala"
	_tmp8_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 187 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp8_);
#line 187 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->popover);
#line 187 "../src/sudoku-view.vala"
	self->priv->popover = _tmp8_;
#line 188 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->popover;
#line 188 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->number_picker;
#line 188 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 189 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->popover;
#line 189 "../src/sudoku-view.vala"
	gtk_popover_set_modal (_tmp11_, FALSE);
#line 190 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->popover;
#line 190 "../src/sudoku-view.vala"
	gtk_popover_set_position (_tmp12_, GTK_POS_BOTTOM);
#line 191 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->popover;
#line 191 "../src/sudoku-view.vala"
	g_signal_connect_object ((GObject*) _tmp13_, "notify::visible", (GCallback) ___lambda11__g_object_notify, self, 0);
#line 195 "../src/sudoku-view.vala"
	_tmp14_ = self->priv->popover;
#line 195 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp14_, "focus-out-event", (GCallback) ___lambda12__gtk_widget_focus_out_event, self, 0);
#line 200 "../src/sudoku-view.vala"
	_tmp15_ = self->priv->popover;
#line 200 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp15_);
#line 1022 "sudoku-view.c"
}


static void
__lambda8_ (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 215 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 215 "../src/sudoku-view.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 215 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_;
#line 215 "../src/sudoku-view.vala"
	if (!_tmp2_) {
#line 216 "../src/sudoku-view.vala"
		sudoku_cell_view_destroy_popover (self, &self->priv->earmark_popover);
#line 1042 "sudoku-view.c"
	}
}


static void
___lambda8__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 214 "../src/sudoku-view.vala"
	__lambda8_ ((SudokuCellView*) self);
#line 1054 "sudoku-view.c"
}


static gboolean
__lambda9_ (SudokuCellView* self)
{
	gboolean result = FALSE;
	GtkPopover* _tmp0_;
#line 219 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->earmark_popover;
#line 219 "../src/sudoku-view.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 220 "../src/sudoku-view.vala"
	result = TRUE;
#line 220 "../src/sudoku-view.vala"
	return result;
#line 1071 "sudoku-view.c"
}


static gboolean
___lambda9__gtk_widget_focus_out_event (GtkWidget* _sender,
                                        GdkEventFocus* event,
                                        gpointer self)
{
	gboolean result;
	result = __lambda9_ ((SudokuCellView*) self);
#line 218 "../src/sudoku-view.vala"
	return result;
#line 1084 "sudoku-view.c"
}


static void
sudoku_cell_view_show_earmark_picker (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
	GtkPopover* _tmp3_;
	NumberPicker* _tmp4_;
	GtkPopover* _tmp5_;
	GtkPopover* _tmp6_;
	GtkPopover* _tmp7_;
	GtkPopover* _tmp8_;
	GtkPopover* _tmp9_;
#line 203 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 205 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 205 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 1106 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 206 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->popover;
#line 206 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1112 "sudoku-view.c"
	}
#line 208 "../src/sudoku-view.vala"
	sudoku_cell_view_create_earmark_picker (self);
#line 210 "../src/sudoku-view.vala"
	_tmp2_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) self);
#line 210 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp2_);
#line 210 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_popover);
#line 210 "../src/sudoku-view.vala"
	self->priv->earmark_popover = _tmp2_;
#line 211 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->earmark_popover;
#line 211 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->earmark_picker;
#line 211 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp3_, (GtkWidget*) _tmp4_);
#line 212 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->earmark_popover;
#line 212 "../src/sudoku-view.vala"
	gtk_popover_set_modal (_tmp5_, FALSE);
#line 213 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->earmark_popover;
#line 213 "../src/sudoku-view.vala"
	gtk_popover_set_position (_tmp6_, GTK_POS_BOTTOM);
#line 214 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->earmark_popover;
#line 214 "../src/sudoku-view.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::visible", (GCallback) ___lambda8__g_object_notify, self, 0);
#line 218 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->earmark_popover;
#line 218 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp8_, "focus-out-event", (GCallback) ___lambda9__gtk_widget_focus_out_event, self, 0);
#line 223 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->earmark_popover;
#line 223 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp9_);
#line 1150 "sudoku-view.c"
}


static void
sudoku_cell_view_destroy_popover (SudokuCellView* self,
                                  GtkPopover* * popover)
{
#line 226 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 226 "../src/sudoku-view.vala"
	g_return_if_fail (*popover != NULL);
#line 228 "../src/sudoku-view.vala"
	if ((*popover) != NULL) {
#line 230 "../src/sudoku-view.vala"
		gtk_widget_destroy ((GtkWidget*) (*popover));
#line 231 "../src/sudoku-view.vala"
		_g_object_unref0 (*popover);
#line 231 "../src/sudoku-view.vala"
		*popover = NULL;
#line 1170 "sudoku-view.c"
	}
}


static void
sudoku_cell_view_hide_both_popovers (SudokuCellView* self)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp2_;
#line 235 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 237 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->popover;
#line 237 "../src/sudoku-view.vala"
	if (_tmp0_ != NULL) {
#line 1186 "sudoku-view.c"
		GtkPopover* _tmp1_;
#line 238 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->popover;
#line 238 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1192 "sudoku-view.c"
	}
#line 239 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->earmark_popover;
#line 239 "../src/sudoku-view.vala"
	if (_tmp2_ != NULL) {
#line 1198 "sudoku-view.c"
		GtkPopover* _tmp3_;
#line 240 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->earmark_popover;
#line 240 "../src/sudoku-view.vala"
		gtk_widget_hide ((GtkWidget*) _tmp3_);
#line 1204 "sudoku-view.c"
	}
}


static gboolean
sudoku_cell_view_focus_out_cb (SudokuCellView* self,
                               GtkWidget* widget,
                               GdkEventFocus* event)
{
	gboolean result = FALSE;
#line 243 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 243 "../src/sudoku-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 243 "../src/sudoku-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 245 "../src/sudoku-view.vala"
	sudoku_cell_view_hide_both_popovers (self);
#line 246 "../src/sudoku-view.vala"
	result = FALSE;
#line 246 "../src/sudoku-view.vala"
	return result;
#line 1227 "sudoku-view.c"
}


static gint
sudoku_cell_view_key_map_keypad (SudokuCellView* self,
                                 const gchar* key_name)
{
	gint result = 0;
	gboolean _tmp0_ = FALSE;
#line 250 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 250 "../src/sudoku-view.vala"
	g_return_val_if_fail (key_name != NULL, 0);
#line 253 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_0") == 0) {
#line 253 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 1245 "sudoku-view.c"
	} else {
#line 253 "../src/sudoku-view.vala"
		_tmp0_ = g_strcmp0 (key_name, "0") == 0;
#line 1249 "sudoku-view.c"
	}
#line 253 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 254 "../src/sudoku-view.vala"
		result = 0;
#line 254 "../src/sudoku-view.vala"
		return result;
#line 1257 "sudoku-view.c"
	}
#line 255 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_1") == 0) {
#line 256 "../src/sudoku-view.vala"
		result = 1;
#line 256 "../src/sudoku-view.vala"
		return result;
#line 1265 "sudoku-view.c"
	}
#line 257 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_2") == 0) {
#line 258 "../src/sudoku-view.vala"
		result = 2;
#line 258 "../src/sudoku-view.vala"
		return result;
#line 1273 "sudoku-view.c"
	}
#line 259 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_3") == 0) {
#line 260 "../src/sudoku-view.vala"
		result = 3;
#line 260 "../src/sudoku-view.vala"
		return result;
#line 1281 "sudoku-view.c"
	}
#line 261 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_4") == 0) {
#line 262 "../src/sudoku-view.vala"
		result = 4;
#line 262 "../src/sudoku-view.vala"
		return result;
#line 1289 "sudoku-view.c"
	}
#line 263 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_5") == 0) {
#line 264 "../src/sudoku-view.vala"
		result = 5;
#line 264 "../src/sudoku-view.vala"
		return result;
#line 1297 "sudoku-view.c"
	}
#line 265 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_6") == 0) {
#line 266 "../src/sudoku-view.vala"
		result = 6;
#line 266 "../src/sudoku-view.vala"
		return result;
#line 1305 "sudoku-view.c"
	}
#line 267 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_7") == 0) {
#line 268 "../src/sudoku-view.vala"
		result = 7;
#line 268 "../src/sudoku-view.vala"
		return result;
#line 1313 "sudoku-view.c"
	}
#line 269 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_8") == 0) {
#line 270 "../src/sudoku-view.vala"
		result = 8;
#line 270 "../src/sudoku-view.vala"
		return result;
#line 1321 "sudoku-view.c"
	}
#line 271 "../src/sudoku-view.vala"
	if (g_strcmp0 (key_name, "KP_9") == 0) {
#line 272 "../src/sudoku-view.vala"
		result = 9;
#line 272 "../src/sudoku-view.vala"
		return result;
#line 1329 "sudoku-view.c"
	}
#line 273 "../src/sudoku-view.vala"
	result = -1;
#line 273 "../src/sudoku-view.vala"
	return result;
#line 1335 "sudoku-view.c"
}


static gboolean
sudoku_cell_view_real_key_press_event (GtkWidget* base,
                                       GdkEventKey* event)
{
	SudokuCellView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	GameMode _tmp2_;
	gchar* k_name = NULL;
	guint _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gint k_no = 0;
	const gchar* _tmp12_;
	gint _tmp13_;
	gboolean _tmp15_ = FALSE;
	gint _tmp16_;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	gint _tmp51_;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	const gchar* _tmp56_;
	const gchar* _tmp61_;
#line 276 "../src/sudoku-view.vala"
	self = (SudokuCellView*) base;
#line 276 "../src/sudoku-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 278 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->game;
#line 278 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_->mode;
#line 278 "../src/sudoku-view.vala"
	if (_tmp2_ == GAME_MODE_PLAY) {
#line 1374 "sudoku-view.c"
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 278 "../src/sudoku-view.vala"
		_tmp4_ = sudoku_cell_view_get_is_fixed (self);
#line 278 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_;
#line 278 "../src/sudoku-view.vala"
		if (_tmp5_) {
#line 278 "../src/sudoku-view.vala"
			_tmp3_ = TRUE;
#line 1386 "sudoku-view.c"
		} else {
			SudokuGame* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 278 "../src/sudoku-view.vala"
			_tmp6_ = self->priv->game;
#line 278 "../src/sudoku-view.vala"
			_tmp7_ = sudoku_game_get_paused (_tmp6_);
#line 278 "../src/sudoku-view.vala"
			_tmp8_ = _tmp7_;
#line 278 "../src/sudoku-view.vala"
			_tmp3_ = _tmp8_;
#line 1399 "sudoku-view.c"
		}
#line 278 "../src/sudoku-view.vala"
		_tmp0_ = _tmp3_;
#line 1403 "sudoku-view.c"
	} else {
#line 278 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1407 "sudoku-view.c"
	}
#line 278 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 279 "../src/sudoku-view.vala"
		result = FALSE;
#line 279 "../src/sudoku-view.vala"
		return result;
#line 1415 "sudoku-view.c"
	}
#line 280 "../src/sudoku-view.vala"
	_tmp9_ = event->keyval;
#line 280 "../src/sudoku-view.vala"
	_tmp10_ = gdk_keyval_name (_tmp9_);
#line 280 "../src/sudoku-view.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 280 "../src/sudoku-view.vala"
	k_name = _tmp11_;
#line 281 "../src/sudoku-view.vala"
	_tmp12_ = k_name;
#line 281 "../src/sudoku-view.vala"
	k_no = atoi (_tmp12_);
#line 283 "../src/sudoku-view.vala"
	_tmp13_ = k_no;
#line 283 "../src/sudoku-view.vala"
	if (_tmp13_ == 0) {
#line 1433 "sudoku-view.c"
		const gchar* _tmp14_;
#line 284 "../src/sudoku-view.vala"
		_tmp14_ = k_name;
#line 284 "../src/sudoku-view.vala"
		k_no = sudoku_cell_view_key_map_keypad (self, _tmp14_);
#line 1439 "sudoku-view.c"
	}
#line 285 "../src/sudoku-view.vala"
	_tmp16_ = k_no;
#line 285 "../src/sudoku-view.vala"
	if (_tmp16_ >= 1) {
#line 1445 "sudoku-view.c"
		gint _tmp17_;
#line 285 "../src/sudoku-view.vala"
		_tmp17_ = k_no;
#line 285 "../src/sudoku-view.vala"
		_tmp15_ = _tmp17_ <= 9;
#line 1451 "sudoku-view.c"
	} else {
#line 285 "../src/sudoku-view.vala"
		_tmp15_ = FALSE;
#line 1455 "sudoku-view.c"
	}
#line 285 "../src/sudoku-view.vala"
	if (_tmp15_) {
#line 1459 "sudoku-view.c"
		gboolean _tmp18_ = FALSE;
		GdkModifierType _tmp19_;
#line 287 "../src/sudoku-view.vala"
		_tmp19_ = event->state;
#line 287 "../src/sudoku-view.vala"
		if ((_tmp19_ & GDK_CONTROL_MASK) > 0) {
#line 1466 "sudoku-view.c"
			SudokuGame* _tmp20_;
			GameMode _tmp21_;
#line 287 "../src/sudoku-view.vala"
			_tmp20_ = self->priv->game;
#line 287 "../src/sudoku-view.vala"
			_tmp21_ = _tmp20_->mode;
#line 287 "../src/sudoku-view.vala"
			_tmp18_ = _tmp21_ == GAME_MODE_PLAY;
#line 1475 "sudoku-view.c"
		} else {
#line 287 "../src/sudoku-view.vala"
			_tmp18_ = FALSE;
#line 1479 "sudoku-view.c"
		}
#line 287 "../src/sudoku-view.vala"
		if (_tmp18_) {
#line 1483 "sudoku-view.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp22_;
			SudokuBoard* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			NumberPicker* _tmp27_;
			NumberPicker* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			gboolean _tmp32_;
#line 289 "../src/sudoku-view.vala"
			_tmp22_ = self->priv->game;
#line 289 "../src/sudoku-view.vala"
			_tmp23_ = _tmp22_->board;
#line 289 "../src/sudoku-view.vala"
			_tmp24_ = self->priv->row;
#line 289 "../src/sudoku-view.vala"
			_tmp25_ = self->priv->col;
#line 289 "../src/sudoku-view.vala"
			_tmp26_ = k_no;
#line 289 "../src/sudoku-view.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp23_, _tmp24_, _tmp25_, _tmp26_);
#line 290 "../src/sudoku-view.vala"
			_tmp27_ = self->priv->earmark_picker;
#line 290 "../src/sudoku-view.vala"
			if (_tmp27_ == NULL) {
#line 291 "../src/sudoku-view.vala"
				sudoku_cell_view_create_earmark_picker (self);
#line 1514 "sudoku-view.c"
			}
#line 292 "../src/sudoku-view.vala"
			_tmp28_ = self->priv->earmark_picker;
#line 292 "../src/sudoku-view.vala"
			_tmp29_ = self->priv->row;
#line 292 "../src/sudoku-view.vala"
			_tmp30_ = self->priv->col;
#line 292 "../src/sudoku-view.vala"
			_tmp31_ = k_no;
#line 292 "../src/sudoku-view.vala"
			_tmp32_ = new_state;
#line 292 "../src/sudoku-view.vala"
			if (number_picker_set_earmark (_tmp28_, _tmp29_, _tmp30_, _tmp31_ - 1, _tmp32_)) {
#line 1528 "sudoku-view.c"
				gboolean _tmp33_;
#line 294 "../src/sudoku-view.vala"
				_tmp33_ = new_state;
#line 294 "../src/sudoku-view.vala"
				if (_tmp33_) {
#line 1534 "sudoku-view.c"
					SudokuGame* _tmp34_;
					SudokuBoard* _tmp35_;
					gint _tmp36_;
					gint _tmp37_;
					gint _tmp38_;
#line 295 "../src/sudoku-view.vala"
					_tmp34_ = self->priv->game;
#line 295 "../src/sudoku-view.vala"
					_tmp35_ = _tmp34_->board;
#line 295 "../src/sudoku-view.vala"
					_tmp36_ = self->priv->row;
#line 295 "../src/sudoku-view.vala"
					_tmp37_ = self->priv->col;
#line 295 "../src/sudoku-view.vala"
					_tmp38_ = k_no;
#line 295 "../src/sudoku-view.vala"
					sudoku_board_enable_earmark (_tmp35_, _tmp36_, _tmp37_, _tmp38_);
#line 1552 "sudoku-view.c"
				} else {
					SudokuGame* _tmp39_;
					SudokuBoard* _tmp40_;
					gint _tmp41_;
					gint _tmp42_;
					gint _tmp43_;
#line 297 "../src/sudoku-view.vala"
					_tmp39_ = self->priv->game;
#line 297 "../src/sudoku-view.vala"
					_tmp40_ = _tmp39_->board;
#line 297 "../src/sudoku-view.vala"
					_tmp41_ = self->priv->row;
#line 297 "../src/sudoku-view.vala"
					_tmp42_ = self->priv->col;
#line 297 "../src/sudoku-view.vala"
					_tmp43_ = k_no;
#line 297 "../src/sudoku-view.vala"
					sudoku_board_disable_earmark (_tmp40_, _tmp41_, _tmp42_, _tmp43_);
#line 1571 "sudoku-view.c"
				}
#line 298 "../src/sudoku-view.vala"
				gtk_widget_queue_draw ((GtkWidget*) self);
#line 1575 "sudoku-view.c"
			}
		} else {
			gint _tmp44_;
			SudokuGame* _tmp45_;
			SudokuBoard* _tmp46_;
			gint _tmp47_;
			gint _tmp48_;
#line 303 "../src/sudoku-view.vala"
			_tmp44_ = k_no;
#line 303 "../src/sudoku-view.vala"
			sudoku_cell_view_set_value (self, _tmp44_);
#line 304 "../src/sudoku-view.vala"
			_tmp45_ = self->priv->game;
#line 304 "../src/sudoku-view.vala"
			_tmp46_ = _tmp45_->board;
#line 304 "../src/sudoku-view.vala"
			_tmp47_ = self->priv->row;
#line 304 "../src/sudoku-view.vala"
			_tmp48_ = self->priv->col;
#line 304 "../src/sudoku-view.vala"
			sudoku_board_disable_all_earmarks (_tmp46_, _tmp47_, _tmp48_);
#line 305 "../src/sudoku-view.vala"
			sudoku_cell_view_hide_both_popovers (self);
#line 1599 "sudoku-view.c"
		}
#line 307 "../src/sudoku-view.vala"
		result = TRUE;
#line 307 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 307 "../src/sudoku-view.vala"
		return result;
#line 1607 "sudoku-view.c"
	}
#line 309 "../src/sudoku-view.vala"
	_tmp51_ = k_no;
#line 309 "../src/sudoku-view.vala"
	if (_tmp51_ == 0) {
#line 309 "../src/sudoku-view.vala"
		_tmp50_ = TRUE;
#line 1615 "sudoku-view.c"
	} else {
		const gchar* _tmp52_;
#line 309 "../src/sudoku-view.vala"
		_tmp52_ = k_name;
#line 309 "../src/sudoku-view.vala"
		_tmp50_ = g_strcmp0 (_tmp52_, "BackSpace") == 0;
#line 1622 "sudoku-view.c"
	}
#line 309 "../src/sudoku-view.vala"
	if (_tmp50_) {
#line 309 "../src/sudoku-view.vala"
		_tmp49_ = TRUE;
#line 1628 "sudoku-view.c"
	} else {
		const gchar* _tmp53_;
#line 309 "../src/sudoku-view.vala"
		_tmp53_ = k_name;
#line 309 "../src/sudoku-view.vala"
		_tmp49_ = g_strcmp0 (_tmp53_, "Delete") == 0;
#line 1635 "sudoku-view.c"
	}
#line 309 "../src/sudoku-view.vala"
	if (_tmp49_) {
#line 311 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, 0);
#line 312 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 313 "../src/sudoku-view.vala"
		result = TRUE;
#line 313 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 313 "../src/sudoku-view.vala"
		return result;
#line 1649 "sudoku-view.c"
	}
#line 316 "../src/sudoku-view.vala"
	_tmp56_ = k_name;
#line 316 "../src/sudoku-view.vala"
	if (g_strcmp0 (_tmp56_, "space") == 0) {
#line 316 "../src/sudoku-view.vala"
		_tmp55_ = TRUE;
#line 1657 "sudoku-view.c"
	} else {
		const gchar* _tmp57_;
#line 316 "../src/sudoku-view.vala"
		_tmp57_ = k_name;
#line 316 "../src/sudoku-view.vala"
		_tmp55_ = g_strcmp0 (_tmp57_, "Return") == 0;
#line 1664 "sudoku-view.c"
	}
#line 316 "../src/sudoku-view.vala"
	if (_tmp55_) {
#line 316 "../src/sudoku-view.vala"
		_tmp54_ = TRUE;
#line 1670 "sudoku-view.c"
	} else {
		const gchar* _tmp58_;
#line 316 "../src/sudoku-view.vala"
		_tmp58_ = k_name;
#line 316 "../src/sudoku-view.vala"
		_tmp54_ = g_strcmp0 (_tmp58_, "KP_Enter") == 0;
#line 1677 "sudoku-view.c"
	}
#line 316 "../src/sudoku-view.vala"
	if (_tmp54_) {
#line 1681 "sudoku-view.c"
		GtkPopover* _tmp59_;
#line 318 "../src/sudoku-view.vala"
		_tmp59_ = self->priv->popover;
#line 318 "../src/sudoku-view.vala"
		if (_tmp59_ != NULL) {
#line 1687 "sudoku-view.c"
			GtkPopover* _tmp60_;
#line 320 "../src/sudoku-view.vala"
			_tmp60_ = self->priv->popover;
#line 320 "../src/sudoku-view.vala"
			gtk_widget_hide ((GtkWidget*) _tmp60_);
#line 321 "../src/sudoku-view.vala"
			result = FALSE;
#line 321 "../src/sudoku-view.vala"
			_g_free0 (k_name);
#line 321 "../src/sudoku-view.vala"
			return result;
#line 1699 "sudoku-view.c"
		}
#line 323 "../src/sudoku-view.vala"
		sudoku_cell_view_show_number_picker (self);
#line 324 "../src/sudoku-view.vala"
		result = TRUE;
#line 324 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 324 "../src/sudoku-view.vala"
		return result;
#line 1709 "sudoku-view.c"
	}
#line 327 "../src/sudoku-view.vala"
	_tmp61_ = k_name;
#line 327 "../src/sudoku-view.vala"
	if (g_strcmp0 (_tmp61_, "Escape") == 0) {
#line 329 "../src/sudoku-view.vala"
		sudoku_cell_view_hide_both_popovers (self);
#line 330 "../src/sudoku-view.vala"
		result = TRUE;
#line 330 "../src/sudoku-view.vala"
		_g_free0 (k_name);
#line 330 "../src/sudoku-view.vala"
		return result;
#line 1723 "sudoku-view.c"
	}
#line 333 "../src/sudoku-view.vala"
	result = FALSE;
#line 333 "../src/sudoku-view.vala"
	_g_free0 (k_name);
#line 333 "../src/sudoku-view.vala"
	return result;
#line 1731 "sudoku-view.c"
}


static gboolean
sudoku_cell_view_real_draw (GtkWidget* base,
                            cairo_t* c)
{
	SudokuCellView * self;
	gboolean result = FALSE;
	gint glyph_width = 0;
	gint glyph_height = 0;
	PangoLayout* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_;
	SudokuGame* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp35_;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_;
#line 336 "../src/sudoku-view.vala"
	self = (SudokuCellView*) base;
#line 336 "../src/sudoku-view.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 339 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->layout;
#line 339 "../src/sudoku-view.vala"
	pango_layout_get_pixel_size (_tmp0_, &_tmp1_, &_tmp2_);
#line 339 "../src/sudoku-view.vala"
	glyph_width = _tmp1_;
#line 339 "../src/sudoku-view.vala"
	glyph_height = _tmp2_;
#line 340 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->_show_warnings;
#line 340 "../src/sudoku-view.vala"
	if (_tmp4_) {
#line 1775 "sudoku-view.c"
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		GeeSet* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		Coord _tmp10_ = {0};
#line 340 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->game;
#line 340 "../src/sudoku-view.vala"
		_tmp6_ = _tmp5_->board;
#line 340 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_->broken_coords;
#line 340 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->row;
#line 340 "../src/sudoku-view.vala"
		_tmp9_ = self->priv->col;
#line 340 "../src/sudoku-view.vala"
		coord_init (&_tmp10_, _tmp8_, _tmp9_);
#line 340 "../src/sudoku-view.vala"
		_tmp3_ = gee_collection_contains ((GeeCollection*) _tmp7_, &_tmp10_);
#line 1796 "sudoku-view.c"
	} else {
#line 340 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 1800 "sudoku-view.c"
	}
#line 340 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 341 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 1806 "sudoku-view.c"
	} else {
		gboolean _tmp11_;
#line 342 "../src/sudoku-view.vala"
		_tmp11_ = self->priv->_selected;
#line 342 "../src/sudoku-view.vala"
		if (_tmp11_) {
#line 343 "../src/sudoku-view.vala"
			cairo_set_source_rgb (c, 0.2, 0.2, 0.2);
#line 1815 "sudoku-view.c"
		} else {
#line 345 "../src/sudoku-view.vala"
			cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 1819 "sudoku-view.c"
		}
	}
#line 347 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->game;
#line 347 "../src/sudoku-view.vala"
	_tmp13_ = sudoku_game_get_paused (_tmp12_);
#line 347 "../src/sudoku-view.vala"
	_tmp14_ = _tmp13_;
#line 347 "../src/sudoku-view.vala"
	if (_tmp14_) {
#line 348 "../src/sudoku-view.vala"
		result = FALSE;
#line 348 "../src/sudoku-view.vala"
		return result;
#line 1834 "sudoku-view.c"
	}
#line 350 "../src/sudoku-view.vala"
	_tmp15_ = sudoku_cell_view_get_value (self);
#line 350 "../src/sudoku-view.vala"
	_tmp16_ = _tmp15_;
#line 350 "../src/sudoku-view.vala"
	if (_tmp16_ != 0) {
#line 1842 "sudoku-view.c"
		gint width = 0;
		gint height = 0;
		PangoLayout* _tmp17_;
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
		gint _tmp20_;
		gdouble scale = 0.0;
		gdouble _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		gdouble _tmp24_;
		gint _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
		gdouble _tmp28_;
		PangoLayout* _tmp29_;
#line 353 "../src/sudoku-view.vala"
		_tmp17_ = self->priv->layout;
#line 353 "../src/sudoku-view.vala"
		pango_layout_get_size (_tmp17_, &_tmp18_, &_tmp19_);
#line 353 "../src/sudoku-view.vala"
		width = _tmp18_;
#line 353 "../src/sudoku-view.vala"
		height = _tmp19_;
#line 354 "../src/sudoku-view.vala"
		_tmp20_ = height;
#line 354 "../src/sudoku-view.vala"
		height = _tmp20_ / PANGO_SCALE;
#line 356 "../src/sudoku-view.vala"
		_tmp21_ = self->priv->size_ratio;
#line 356 "../src/sudoku-view.vala"
		_tmp22_ = height;
#line 356 "../src/sudoku-view.vala"
		scale = (((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self)) / _tmp21_) / _tmp22_;
#line 357 "../src/sudoku-view.vala"
		_tmp23_ = glyph_width;
#line 357 "../src/sudoku-view.vala"
		_tmp24_ = scale;
#line 357 "../src/sudoku-view.vala"
		_tmp25_ = glyph_height;
#line 357 "../src/sudoku-view.vala"
		_tmp26_ = scale;
#line 357 "../src/sudoku-view.vala"
		cairo_move_to (c, (gtk_widget_get_allocated_width ((GtkWidget*) self) - (_tmp23_ * _tmp24_)) / 2, (gtk_widget_get_allocated_height ((GtkWidget*) self) - (_tmp25_ * _tmp26_)) / 2);
#line 358 "../src/sudoku-view.vala"
		cairo_save (c);
#line 359 "../src/sudoku-view.vala"
		_tmp27_ = scale;
#line 359 "../src/sudoku-view.vala"
		_tmp28_ = scale;
#line 359 "../src/sudoku-view.vala"
		cairo_scale (c, _tmp27_, _tmp28_);
#line 360 "../src/sudoku-view.vala"
		_tmp29_ = self->priv->layout;
#line 360 "../src/sudoku-view.vala"
		pango_cairo_show_layout (c, _tmp29_);
#line 361 "../src/sudoku-view.vala"
		cairo_restore (c);
#line 1901 "sudoku-view.c"
	}
#line 364 "../src/sudoku-view.vala"
	_tmp31_ = sudoku_cell_view_get_is_fixed (self);
#line 364 "../src/sudoku-view.vala"
	_tmp32_ = _tmp31_;
#line 364 "../src/sudoku-view.vala"
	if (_tmp32_) {
#line 1909 "sudoku-view.c"
		SudokuGame* _tmp33_;
		GameMode _tmp34_;
#line 364 "../src/sudoku-view.vala"
		_tmp33_ = self->priv->game;
#line 364 "../src/sudoku-view.vala"
		_tmp34_ = _tmp33_->mode;
#line 364 "../src/sudoku-view.vala"
		_tmp30_ = _tmp34_ == GAME_MODE_PLAY;
#line 1918 "sudoku-view.c"
	} else {
#line 364 "../src/sudoku-view.vala"
		_tmp30_ = FALSE;
#line 1922 "sudoku-view.c"
	}
#line 364 "../src/sudoku-view.vala"
	if (_tmp30_) {
#line 365 "../src/sudoku-view.vala"
		result = FALSE;
#line 365 "../src/sudoku-view.vala"
		return result;
#line 1930 "sudoku-view.c"
	}
#line 367 "../src/sudoku-view.vala"
	_tmp35_ = self->priv->_show_possibilities;
#line 367 "../src/sudoku-view.vala"
	if (!_tmp35_) {
#line 1936 "sudoku-view.c"
		gdouble earmark_size = 0.0;
		gdouble _tmp36_;
		gdouble _tmp37_;
		gdouble _tmp38_;
		SudokuGame* _tmp39_;
		SudokuBoard* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
#line 370 "../src/sudoku-view.vala"
		_tmp36_ = self->priv->size_ratio;
#line 370 "../src/sudoku-view.vala"
		earmark_size = gtk_widget_get_allocated_height ((GtkWidget*) self) / (_tmp36_ * 2);
#line 371 "../src/sudoku-view.vala"
		_tmp37_ = earmark_size;
#line 371 "../src/sudoku-view.vala"
		cairo_set_font_size (c, _tmp37_);
#line 373 "../src/sudoku-view.vala"
		_tmp38_ = earmark_size;
#line 373 "../src/sudoku-view.vala"
		cairo_move_to (c, (gdouble) 0, _tmp38_);
#line 375 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 376 "../src/sudoku-view.vala"
		_tmp39_ = self->priv->game;
#line 376 "../src/sudoku-view.vala"
		_tmp40_ = _tmp39_->board;
#line 376 "../src/sudoku-view.vala"
		_tmp41_ = self->priv->row;
#line 376 "../src/sudoku-view.vala"
		_tmp42_ = self->priv->col;
#line 376 "../src/sudoku-view.vala"
		_tmp43_ = sudoku_board_get_earmarks_string (_tmp40_, _tmp41_, _tmp42_);
#line 376 "../src/sudoku-view.vala"
		_tmp44_ = _tmp43_;
#line 376 "../src/sudoku-view.vala"
		cairo_show_text (c, _tmp44_);
#line 376 "../src/sudoku-view.vala"
		_g_free0 (_tmp44_);
#line 1977 "sudoku-view.c"
	} else {
		gint _tmp45_;
		gint _tmp46_;
#line 378 "../src/sudoku-view.vala"
		_tmp45_ = sudoku_cell_view_get_value (self);
#line 378 "../src/sudoku-view.vala"
		_tmp46_ = _tmp45_;
#line 378 "../src/sudoku-view.vala"
		if (_tmp46_ == 0) {
#line 1987 "sudoku-view.c"
			gdouble possibility_size = 0.0;
			gdouble _tmp47_;
			gdouble _tmp48_;
			gboolean* possibilities = NULL;
			SudokuGame* _tmp49_;
			SudokuBoard* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
			gint _tmp53_ = 0;
			gboolean* _tmp54_;
			gint possibilities_length1;
			gint _possibilities_size_;
			gint height = 0;
			SudokuGame* _tmp55_;
			SudokuBoard* _tmp56_;
			gint _tmp57_;
			gint _tmp58_;
			gint width = 0;
			SudokuGame* _tmp59_;
			SudokuBoard* _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
			gint num = 0;
#line 380 "../src/sudoku-view.vala"
			_tmp47_ = self->priv->size_ratio;
#line 380 "../src/sudoku-view.vala"
			possibility_size = gtk_widget_get_allocated_height ((GtkWidget*) self) / (_tmp47_ * 2);
#line 381 "../src/sudoku-view.vala"
			_tmp48_ = possibility_size;
#line 381 "../src/sudoku-view.vala"
			cairo_set_font_size (c, _tmp48_);
#line 382 "../src/sudoku-view.vala"
			cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 384 "../src/sudoku-view.vala"
			_tmp49_ = self->priv->game;
#line 384 "../src/sudoku-view.vala"
			_tmp50_ = _tmp49_->board;
#line 384 "../src/sudoku-view.vala"
			_tmp51_ = self->priv->row;
#line 384 "../src/sudoku-view.vala"
			_tmp52_ = self->priv->col;
#line 384 "../src/sudoku-view.vala"
			_tmp54_ = sudoku_board_get_possibilities_as_bool_array (_tmp50_, _tmp51_, _tmp52_, &_tmp53_);
#line 384 "../src/sudoku-view.vala"
			possibilities = _tmp54_;
#line 384 "../src/sudoku-view.vala"
			possibilities_length1 = _tmp53_;
#line 384 "../src/sudoku-view.vala"
			_possibilities_size_ = possibilities_length1;
#line 386 "../src/sudoku-view.vala"
			_tmp55_ = self->priv->game;
#line 386 "../src/sudoku-view.vala"
			_tmp56_ = _tmp55_->board;
#line 386 "../src/sudoku-view.vala"
			_tmp57_ = sudoku_board_get_block_cols (_tmp56_);
#line 386 "../src/sudoku-view.vala"
			_tmp58_ = _tmp57_;
#line 386 "../src/sudoku-view.vala"
			height = gtk_widget_get_allocated_height ((GtkWidget*) self) / _tmp58_;
#line 387 "../src/sudoku-view.vala"
			_tmp59_ = self->priv->game;
#line 387 "../src/sudoku-view.vala"
			_tmp60_ = _tmp59_->board;
#line 387 "../src/sudoku-view.vala"
			_tmp61_ = sudoku_board_get_block_rows (_tmp60_);
#line 387 "../src/sudoku-view.vala"
			_tmp62_ = _tmp61_;
#line 387 "../src/sudoku-view.vala"
			width = gtk_widget_get_allocated_height ((GtkWidget*) self) / _tmp62_;
#line 389 "../src/sudoku-view.vala"
			num = 0;
#line 2059 "sudoku-view.c"
			{
				gint row_tmp = 0;
#line 390 "../src/sudoku-view.vala"
				row_tmp = 0;
#line 2064 "sudoku-view.c"
				{
					gboolean _tmp63_ = FALSE;
#line 390 "../src/sudoku-view.vala"
					_tmp63_ = TRUE;
#line 390 "../src/sudoku-view.vala"
					while (TRUE) {
#line 2071 "sudoku-view.c"
						gint _tmp65_;
						SudokuGame* _tmp66_;
						SudokuBoard* _tmp67_;
						gint _tmp68_;
						gint _tmp69_;
#line 390 "../src/sudoku-view.vala"
						if (!_tmp63_) {
#line 2079 "sudoku-view.c"
							gint _tmp64_;
#line 390 "../src/sudoku-view.vala"
							_tmp64_ = row_tmp;
#line 390 "../src/sudoku-view.vala"
							row_tmp = _tmp64_ + 1;
#line 2085 "sudoku-view.c"
						}
#line 390 "../src/sudoku-view.vala"
						_tmp63_ = FALSE;
#line 390 "../src/sudoku-view.vala"
						_tmp65_ = row_tmp;
#line 390 "../src/sudoku-view.vala"
						_tmp66_ = self->priv->game;
#line 390 "../src/sudoku-view.vala"
						_tmp67_ = _tmp66_->board;
#line 390 "../src/sudoku-view.vala"
						_tmp68_ = sudoku_board_get_block_rows (_tmp67_);
#line 390 "../src/sudoku-view.vala"
						_tmp69_ = _tmp68_;
#line 390 "../src/sudoku-view.vala"
						if (!(_tmp65_ < _tmp69_)) {
#line 390 "../src/sudoku-view.vala"
							break;
#line 2103 "sudoku-view.c"
						}
						{
							gint col_tmp = 0;
#line 392 "../src/sudoku-view.vala"
							col_tmp = 0;
#line 2109 "sudoku-view.c"
							{
								gboolean _tmp70_ = FALSE;
#line 392 "../src/sudoku-view.vala"
								_tmp70_ = TRUE;
#line 392 "../src/sudoku-view.vala"
								while (TRUE) {
#line 2116 "sudoku-view.c"
									gint _tmp72_;
									SudokuGame* _tmp73_;
									SudokuBoard* _tmp74_;
									gint _tmp75_;
									gint _tmp76_;
									gint _tmp77_;
									gboolean* _tmp78_;
									gint _tmp78__length1;
									gint _tmp79_;
									gboolean _tmp80_;
#line 392 "../src/sudoku-view.vala"
									if (!_tmp70_) {
#line 2129 "sudoku-view.c"
										gint _tmp71_;
#line 392 "../src/sudoku-view.vala"
										_tmp71_ = col_tmp;
#line 392 "../src/sudoku-view.vala"
										col_tmp = _tmp71_ + 1;
#line 2135 "sudoku-view.c"
									}
#line 392 "../src/sudoku-view.vala"
									_tmp70_ = FALSE;
#line 392 "../src/sudoku-view.vala"
									_tmp72_ = col_tmp;
#line 392 "../src/sudoku-view.vala"
									_tmp73_ = self->priv->game;
#line 392 "../src/sudoku-view.vala"
									_tmp74_ = _tmp73_->board;
#line 392 "../src/sudoku-view.vala"
									_tmp75_ = sudoku_board_get_block_cols (_tmp74_);
#line 392 "../src/sudoku-view.vala"
									_tmp76_ = _tmp75_;
#line 392 "../src/sudoku-view.vala"
									if (!(_tmp72_ < _tmp76_)) {
#line 392 "../src/sudoku-view.vala"
										break;
#line 2153 "sudoku-view.c"
									}
#line 394 "../src/sudoku-view.vala"
									_tmp77_ = num;
#line 394 "../src/sudoku-view.vala"
									num = _tmp77_ + 1;
#line 396 "../src/sudoku-view.vala"
									_tmp78_ = possibilities;
#line 396 "../src/sudoku-view.vala"
									_tmp78__length1 = possibilities_length1;
#line 396 "../src/sudoku-view.vala"
									_tmp79_ = num;
#line 396 "../src/sudoku-view.vala"
									_tmp80_ = _tmp78_[_tmp79_ - 1];
#line 396 "../src/sudoku-view.vala"
									if (_tmp80_) {
#line 2169 "sudoku-view.c"
										gint _tmp81_;
										gint _tmp82_;
										gint _tmp83_;
										gint _tmp84_;
										gdouble _tmp85_;
										gint _tmp86_;
										gchar* _tmp87_;
										gchar* _tmp88_;
#line 398 "../src/sudoku-view.vala"
										_tmp81_ = col_tmp;
#line 398 "../src/sudoku-view.vala"
										_tmp82_ = width;
#line 398 "../src/sudoku-view.vala"
										_tmp83_ = row_tmp;
#line 398 "../src/sudoku-view.vala"
										_tmp84_ = height;
#line 398 "../src/sudoku-view.vala"
										_tmp85_ = possibility_size;
#line 398 "../src/sudoku-view.vala"
										cairo_move_to (c, (gdouble) (_tmp81_ * _tmp82_), (_tmp83_ * _tmp84_) + _tmp85_);
#line 399 "../src/sudoku-view.vala"
										_tmp86_ = num;
#line 399 "../src/sudoku-view.vala"
										_tmp87_ = g_strdup_printf ("%d", _tmp86_);
#line 399 "../src/sudoku-view.vala"
										_tmp88_ = _tmp87_;
#line 399 "../src/sudoku-view.vala"
										cairo_show_text (c, _tmp88_);
#line 399 "../src/sudoku-view.vala"
										_g_free0 (_tmp88_);
#line 2200 "sudoku-view.c"
									}
								}
							}
						}
					}
				}
			}
#line 378 "../src/sudoku-view.vala"
			possibilities = (g_free (possibilities), NULL);
#line 2210 "sudoku-view.c"
		}
	}
#line 405 "../src/sudoku-view.vala"
	_tmp90_ = self->priv->_show_warnings;
#line 405 "../src/sudoku-view.vala"
	if (_tmp90_) {
#line 2217 "sudoku-view.c"
		gboolean _tmp91_ = FALSE;
		gint _tmp92_;
		gint _tmp93_;
#line 405 "../src/sudoku-view.vala"
		_tmp92_ = sudoku_cell_view_get_value (self);
#line 405 "../src/sudoku-view.vala"
		_tmp93_ = _tmp92_;
#line 405 "../src/sudoku-view.vala"
		if (_tmp93_ == 0) {
#line 2227 "sudoku-view.c"
			SudokuGame* _tmp94_;
			SudokuBoard* _tmp95_;
			gint _tmp96_;
			gint _tmp97_;
#line 405 "../src/sudoku-view.vala"
			_tmp94_ = self->priv->game;
#line 405 "../src/sudoku-view.vala"
			_tmp95_ = _tmp94_->board;
#line 405 "../src/sudoku-view.vala"
			_tmp96_ = self->priv->row;
#line 405 "../src/sudoku-view.vala"
			_tmp97_ = self->priv->col;
#line 405 "../src/sudoku-view.vala"
			_tmp91_ = sudoku_board_count_possibilities (_tmp95_, _tmp96_, _tmp97_) == 0;
#line 2242 "sudoku-view.c"
		} else {
#line 405 "../src/sudoku-view.vala"
			_tmp91_ = FALSE;
#line 2246 "sudoku-view.c"
		}
#line 405 "../src/sudoku-view.vala"
		_tmp89_ = _tmp91_;
#line 2250 "sudoku-view.c"
	} else {
#line 405 "../src/sudoku-view.vala"
		_tmp89_ = FALSE;
#line 2254 "sudoku-view.c"
	}
#line 405 "../src/sudoku-view.vala"
	if (_tmp89_) {
#line 2258 "sudoku-view.c"
		gchar* warning = NULL;
		gchar* _tmp98_;
		cairo_text_extents_t extents = {0};
		const gchar* _tmp99_;
		cairo_text_extents_t _tmp100_ = {0};
		cairo_text_extents_t _tmp101_;
		gdouble _tmp102_;
		cairo_text_extents_t _tmp103_;
		gdouble _tmp104_;
		const gchar* _tmp105_;
#line 407 "../src/sudoku-view.vala"
		_tmp98_ = g_strdup ("X");
#line 407 "../src/sudoku-view.vala"
		warning = _tmp98_;
#line 409 "../src/sudoku-view.vala"
		cairo_set_font_size (c, (gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) / 2));
#line 410 "../src/sudoku-view.vala"
		_tmp99_ = warning;
#line 410 "../src/sudoku-view.vala"
		cairo_text_extents (c, _tmp99_, &_tmp100_);
#line 410 "../src/sudoku-view.vala"
		extents = _tmp100_;
#line 411 "../src/sudoku-view.vala"
		_tmp101_ = extents;
#line 411 "../src/sudoku-view.vala"
		_tmp102_ = _tmp101_.width;
#line 411 "../src/sudoku-view.vala"
		_tmp103_ = extents;
#line 411 "../src/sudoku-view.vala"
		_tmp104_ = _tmp103_.height;
#line 411 "../src/sudoku-view.vala"
		cairo_move_to (c, ((gtk_widget_get_allocated_width ((GtkWidget*) self) - _tmp102_) / 2) - 1, ((gtk_widget_get_allocated_height ((GtkWidget*) self) + _tmp104_) / 2) + 1);
#line 412 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, 1.0, 0.0, 0.0);
#line 413 "../src/sudoku-view.vala"
		_tmp105_ = warning;
#line 413 "../src/sudoku-view.vala"
		cairo_show_text (c, _tmp105_);
#line 405 "../src/sudoku-view.vala"
		_g_free0 (warning);
#line 2299 "sudoku-view.c"
	}
#line 416 "../src/sudoku-view.vala"
	result = FALSE;
#line 416 "../src/sudoku-view.vala"
	return result;
#line 2305 "sudoku-view.c"
}


void
sudoku_cell_view_cell_changed_cb (SudokuCellView* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
#line 419 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 421 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->row;
#line 421 "../src/sudoku-view.vala"
	if (row == _tmp1_) {
#line 2324 "sudoku-view.c"
		gint _tmp2_;
#line 421 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->col;
#line 421 "../src/sudoku-view.vala"
		_tmp0_ = col == _tmp2_;
#line 2330 "sudoku-view.c"
	} else {
#line 421 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 2334 "sudoku-view.c"
	}
#line 421 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 2338 "sudoku-view.c"
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
#line 423 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, new_val);
#line 425 "../src/sudoku-view.vala"
		_tmp3_ = self->priv->game;
#line 425 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_->mode;
#line 425 "../src/sudoku-view.vala"
		if (_tmp4_ == GAME_MODE_CREATE) {
#line 2349 "sudoku-view.c"
			gboolean _tmp5_;
#line 427 "../src/sudoku-view.vala"
			_tmp5_ = self->priv->_selected;
#line 427 "../src/sudoku-view.vala"
			if (_tmp5_) {
#line 428 "../src/sudoku-view.vala"
				sudoku_cell_view_set_background_color (self, &selected_bg_color);
#line 2357 "sudoku-view.c"
			} else {
				GdkRGBA _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 430 "../src/sudoku-view.vala"
				_tmp7_ = sudoku_cell_view_get_is_fixed (self);
#line 430 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_;
#line 430 "../src/sudoku-view.vala"
				if (_tmp8_) {
#line 430 "../src/sudoku-view.vala"
					_tmp6_ = fixed_cell_color;
#line 2370 "sudoku-view.c"
				} else {
#line 430 "../src/sudoku-view.vala"
					_tmp6_ = free_cell_color;
#line 2374 "sudoku-view.c"
				}
#line 430 "../src/sudoku-view.vala"
				sudoku_cell_view_set_background_color (self, &_tmp6_);
#line 2378 "sudoku-view.c"
			}
		}
#line 433 "../src/sudoku-view.vala"
		g_object_notify ((GObject*) self, "value");
#line 2383 "sudoku-view.c"
	}
}


void
sudoku_cell_view_clear (SudokuCellView* self)
{
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 437 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 439 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 439 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 439 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->row;
#line 439 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->col;
#line 439 "../src/sudoku-view.vala"
	sudoku_board_disable_all_earmarks (_tmp1_, _tmp2_, _tmp3_);
#line 2407 "sudoku-view.c"
}


gint
sudoku_cell_view_get_value (SudokuCellView* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 41 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 41 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 41 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->row;
#line 41 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->col;
#line 41 "../src/sudoku-view.vala"
	result = sudoku_board_get (_tmp1_, _tmp2_, _tmp3_);
#line 41 "../src/sudoku-view.vala"
	return result;
#line 2433 "sudoku-view.c"
}


void
sudoku_cell_view_set_value (SudokuCellView* self,
                            gint value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuGame* _tmp31_;
	SudokuBoard* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
	PangoLayout* _tmp42_;
	SudokuGame* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
#line 42 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_cell_view_get_is_fixed (self);
#line 44 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 44 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 2459 "sudoku-view.c"
		gchar* text = NULL;
		SudokuGame* _tmp2_;
		SudokuBoard* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		PangoLayout* _tmp8_;
		PangoLayout* _tmp9_;
		GtkStyle* _tmp10_;
		GtkStyle* _tmp11_;
		PangoFontDescription* _tmp12_;
		SudokuGame* _tmp13_;
		GameMode _tmp14_;
#line 46 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->game;
#line 46 "../src/sudoku-view.vala"
		_tmp3_ = _tmp2_->board;
#line 46 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->row;
#line 46 "../src/sudoku-view.vala"
		_tmp5_ = self->priv->col;
#line 46 "../src/sudoku-view.vala"
		_tmp6_ = g_strdup_printf ("%d", sudoku_board_get (_tmp3_, _tmp4_, _tmp5_));
#line 46 "../src/sudoku-view.vala"
		text = _tmp6_;
#line 47 "../src/sudoku-view.vala"
		_tmp7_ = text;
#line 47 "../src/sudoku-view.vala"
		_tmp8_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp7_);
#line 47 "../src/sudoku-view.vala"
		_g_object_unref0 (self->priv->layout);
#line 47 "../src/sudoku-view.vala"
		self->priv->layout = _tmp8_;
#line 48 "../src/sudoku-view.vala"
		_tmp9_ = self->priv->layout;
#line 48 "../src/sudoku-view.vala"
		_tmp10_ = gtk_widget_get_style ((GtkWidget*) self);
#line 48 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_;
#line 48 "../src/sudoku-view.vala"
		_tmp12_ = _tmp11_->font_desc;
#line 48 "../src/sudoku-view.vala"
		pango_layout_set_font_description (_tmp9_, _tmp12_);
#line 49 "../src/sudoku-view.vala"
		_tmp13_ = self->priv->game;
#line 49 "../src/sudoku-view.vala"
		_tmp14_ = _tmp13_->mode;
#line 49 "../src/sudoku-view.vala"
		if (_tmp14_ == GAME_MODE_PLAY) {
#line 50 "../src/sudoku-view.vala"
			_g_free0 (text);
#line 50 "../src/sudoku-view.vala"
			return;
#line 2514 "sudoku-view.c"
		}
#line 44 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 2518 "sudoku-view.c"
	}
#line 52 "../src/sudoku-view.vala"
	if (value == 0) {
#line 2522 "sudoku-view.c"
		gchar* text = NULL;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		PangoLayout* _tmp17_;
		PangoLayout* _tmp18_;
		GtkStyle* _tmp19_;
		GtkStyle* _tmp20_;
		PangoFontDescription* _tmp21_;
		SudokuGame* _tmp22_;
		SudokuBoard* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		SudokuGame* _tmp29_;
		GameMode _tmp30_;
#line 54 "../src/sudoku-view.vala"
		_tmp15_ = g_strdup ("");
#line 54 "../src/sudoku-view.vala"
		text = _tmp15_;
#line 55 "../src/sudoku-view.vala"
		_tmp16_ = text;
#line 55 "../src/sudoku-view.vala"
		_tmp17_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp16_);
#line 55 "../src/sudoku-view.vala"
		_g_object_unref0 (self->priv->layout);
#line 55 "../src/sudoku-view.vala"
		self->priv->layout = _tmp17_;
#line 56 "../src/sudoku-view.vala"
		_tmp18_ = self->priv->layout;
#line 56 "../src/sudoku-view.vala"
		_tmp19_ = gtk_widget_get_style ((GtkWidget*) self);
#line 56 "../src/sudoku-view.vala"
		_tmp20_ = _tmp19_;
#line 56 "../src/sudoku-view.vala"
		_tmp21_ = _tmp20_->font_desc;
#line 56 "../src/sudoku-view.vala"
		pango_layout_set_font_description (_tmp18_, _tmp21_);
#line 57 "../src/sudoku-view.vala"
		_tmp22_ = self->priv->game;
#line 57 "../src/sudoku-view.vala"
		_tmp23_ = _tmp22_->board;
#line 57 "../src/sudoku-view.vala"
		_tmp24_ = self->priv->row;
#line 57 "../src/sudoku-view.vala"
		_tmp25_ = self->priv->col;
#line 57 "../src/sudoku-view.vala"
		if (sudoku_board_get (_tmp23_, _tmp24_, _tmp25_) != 0) {
#line 2569 "sudoku-view.c"
			SudokuGame* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
#line 58 "../src/sudoku-view.vala"
			_tmp26_ = self->priv->game;
#line 58 "../src/sudoku-view.vala"
			_tmp27_ = self->priv->row;
#line 58 "../src/sudoku-view.vala"
			_tmp28_ = self->priv->col;
#line 58 "../src/sudoku-view.vala"
			sudoku_game_remove (_tmp26_, _tmp27_, _tmp28_);
#line 2581 "sudoku-view.c"
		}
#line 59 "../src/sudoku-view.vala"
		_tmp29_ = self->priv->game;
#line 59 "../src/sudoku-view.vala"
		_tmp30_ = _tmp29_->mode;
#line 59 "../src/sudoku-view.vala"
		if (_tmp30_ == GAME_MODE_PLAY) {
#line 60 "../src/sudoku-view.vala"
			_g_free0 (text);
#line 60 "../src/sudoku-view.vala"
			return;
#line 2593 "sudoku-view.c"
		}
#line 52 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 2597 "sudoku-view.c"
	}
#line 62 "../src/sudoku-view.vala"
	_tmp31_ = self->priv->game;
#line 62 "../src/sudoku-view.vala"
	_tmp32_ = _tmp31_->board;
#line 62 "../src/sudoku-view.vala"
	_tmp33_ = self->priv->row;
#line 62 "../src/sudoku-view.vala"
	_tmp34_ = self->priv->col;
#line 62 "../src/sudoku-view.vala"
	if (value == sudoku_board_get (_tmp32_, _tmp33_, _tmp34_)) {
#line 2609 "sudoku-view.c"
		gchar* text = NULL;
		gchar* _tmp35_;
		const gchar* _tmp36_;
		PangoLayout* _tmp37_;
		PangoLayout* _tmp38_;
		GtkStyle* _tmp39_;
		GtkStyle* _tmp40_;
		PangoFontDescription* _tmp41_;
#line 64 "../src/sudoku-view.vala"
		_tmp35_ = g_strdup_printf ("%d", value);
#line 64 "../src/sudoku-view.vala"
		text = _tmp35_;
#line 65 "../src/sudoku-view.vala"
		_tmp36_ = text;
#line 65 "../src/sudoku-view.vala"
		_tmp37_ = gtk_widget_create_pango_layout ((GtkWidget*) self, _tmp36_);
#line 65 "../src/sudoku-view.vala"
		_g_object_unref0 (self->priv->layout);
#line 65 "../src/sudoku-view.vala"
		self->priv->layout = _tmp37_;
#line 66 "../src/sudoku-view.vala"
		_tmp38_ = self->priv->layout;
#line 66 "../src/sudoku-view.vala"
		_tmp39_ = gtk_widget_get_style ((GtkWidget*) self);
#line 66 "../src/sudoku-view.vala"
		_tmp40_ = _tmp39_;
#line 66 "../src/sudoku-view.vala"
		_tmp41_ = _tmp40_->font_desc;
#line 66 "../src/sudoku-view.vala"
		pango_layout_set_font_description (_tmp38_, _tmp41_);
#line 67 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 67 "../src/sudoku-view.vala"
		return;
#line 2644 "sudoku-view.c"
	}
#line 69 "../src/sudoku-view.vala"
	_tmp42_ = self->priv->layout;
#line 69 "../src/sudoku-view.vala"
	_vala_assert (_tmp42_ != NULL, "layout != null");
#line 70 "../src/sudoku-view.vala"
	_tmp43_ = self->priv->game;
#line 70 "../src/sudoku-view.vala"
	_tmp44_ = self->priv->row;
#line 70 "../src/sudoku-view.vala"
	_tmp45_ = self->priv->col;
#line 70 "../src/sudoku-view.vala"
	sudoku_game_insert (_tmp43_, _tmp44_, _tmp45_, value);
#line 42 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY]);
#line 2660 "sudoku-view.c"
}


gboolean
sudoku_cell_view_get_is_fixed (SudokuCellView* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 76 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 76 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->game;
#line 76 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_->board;
#line 76 "../src/sudoku-view.vala"
	_tmp2_ = _tmp1_->is_fixed;
#line 76 "../src/sudoku-view.vala"
	_tmp2__length1 = _tmp1_->is_fixed_length1;
#line 76 "../src/sudoku-view.vala"
	_tmp2__length2 = _tmp1_->is_fixed_length2;
#line 76 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->row;
#line 76 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->col;
#line 76 "../src/sudoku-view.vala"
	_tmp5_ = _tmp2_[(_tmp3_ * _tmp2__length2) + _tmp4_];
#line 76 "../src/sudoku-view.vala"
	result = _tmp5_;
#line 76 "../src/sudoku-view.vala"
	return result;
#line 2698 "sudoku-view.c"
}


gboolean
sudoku_cell_view_get_show_possibilities (SudokuCellView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 82 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 82 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_show_possibilities;
#line 82 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 82 "../src/sudoku-view.vala"
	return result;
#line 2715 "sudoku-view.c"
}


void
sudoku_cell_view_set_show_possibilities (SudokuCellView* self,
                                         gboolean value)
{
#line 83 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 85 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 86 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 83 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 2731 "sudoku-view.c"
}


gboolean
sudoku_cell_view_get_show_warnings (SudokuCellView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 93 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 93 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_show_warnings;
#line 93 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 93 "../src/sudoku-view.vala"
	return result;
#line 2748 "sudoku-view.c"
}


void
sudoku_cell_view_set_show_warnings (SudokuCellView* self,
                                    gboolean value)
{
#line 94 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 97 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 94 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 2764 "sudoku-view.c"
}


gboolean
sudoku_cell_view_get_selected (SudokuCellView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 101 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 101 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_selected;
#line 101 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 101 "../src/sudoku-view.vala"
	return result;
#line 2781 "sudoku-view.c"
}


void
sudoku_cell_view_set_selected (SudokuCellView* self,
                               gboolean value)
{
#line 101 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/sudoku-view.vala"
	if (sudoku_cell_view_get_selected (self) != value) {
#line 101 "../src/sudoku-view.vala"
		self->priv->_selected = value;
#line 101 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY]);
#line 2797 "sudoku-view.c"
	}
}


void
sudoku_cell_view_get_background_color (SudokuCellView* self,
                                       GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 102 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_background_color;
#line 102 "../src/sudoku-view.vala"
	*result = _tmp0_;
#line 102 "../src/sudoku-view.vala"
	return;
#line 2815 "sudoku-view.c"
}


static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 102 "../src/sudoku-view.vala"
	if (s1 == s2) {
#line 102 "../src/sudoku-view.vala"
		return TRUE;
#line 2827 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	if (s1 == NULL) {
#line 102 "../src/sudoku-view.vala"
		return FALSE;
#line 2833 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	if (s2 == NULL) {
#line 102 "../src/sudoku-view.vala"
		return FALSE;
#line 2839 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	if (s1->red != s2->red) {
#line 102 "../src/sudoku-view.vala"
		return FALSE;
#line 2845 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	if (s1->green != s2->green) {
#line 102 "../src/sudoku-view.vala"
		return FALSE;
#line 2851 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	if (s1->blue != s2->blue) {
#line 102 "../src/sudoku-view.vala"
		return FALSE;
#line 2857 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	if (s1->alpha != s2->alpha) {
#line 102 "../src/sudoku-view.vala"
		return FALSE;
#line 2863 "sudoku-view.c"
	}
#line 102 "../src/sudoku-view.vala"
	return TRUE;
#line 2867 "sudoku-view.c"
}


void
sudoku_cell_view_set_background_color (SudokuCellView* self,
                                       GdkRGBA * value)
{
	GdkRGBA old_value;
#line 102 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/sudoku-view.vala"
	if (_gdk_rgba_equal (value, (sudoku_cell_view_get_background_color (self, &old_value), &old_value)) != TRUE) {
#line 2880 "sudoku-view.c"
		GdkRGBA _tmp0_;
#line 102 "../src/sudoku-view.vala"
		_tmp0_ = *value;
#line 102 "../src/sudoku-view.vala"
		self->priv->_background_color = _tmp0_;
#line 102 "../src/sudoku-view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY]);
#line 2888 "sudoku-view.c"
	}
}


static void
sudoku_cell_view_class_init (SudokuCellViewClass * klass)
{
#line 25 "../src/sudoku-view.vala"
	sudoku_cell_view_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCellView_private_offset);
#line 25 "../src/sudoku-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget *, GdkEventButton*)) sudoku_cell_view_real_button_press_event;
#line 25 "../src/sudoku-view.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget *, GdkEventKey*)) sudoku_cell_view_real_key_press_event;
#line 25 "../src/sudoku-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) sudoku_cell_view_real_draw;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_view_get_property;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_view_set_property;
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_view_finalize;
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_VALUE_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_SELECTED_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 25 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY, sudoku_cell_view_properties[SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY] = g_param_spec_boxed ("background-color", "background-color", "background-color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2924 "sudoku-view.c"
}


static void
sudoku_cell_view_instance_init (SudokuCellView * self)
{
#line 25 "../src/sudoku-view.vala"
	self->priv = sudoku_cell_view_get_instance_private (self);
#line 29 "../src/sudoku-view.vala"
	self->priv->size_ratio = (gdouble) 2;
#line 90 "../src/sudoku-view.vala"
	self->priv->_show_warnings = TRUE;
#line 2937 "sudoku-view.c"
}


static void
sudoku_cell_view_finalize (GObject * obj)
{
	SudokuCellView * self;
#line 25 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 27 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->layout);
#line 31 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->popover);
#line 32 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_popover);
#line 34 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->game);
#line 104 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->number_picker);
#line 105 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->earmark_picker);
#line 25 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_cell_view_parent_class)->finalize (obj);
#line 2961 "sudoku-view.c"
}


GType
sudoku_cell_view_get_type (void)
{
	static volatile gsize sudoku_cell_view_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_cell_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuCellViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCellView), 0, (GInstanceInitFunc) sudoku_cell_view_instance_init, NULL };
		GType sudoku_cell_view_type_id;
		sudoku_cell_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "SudokuCellView", &g_define_type_info, 0);
		SudokuCellView_private_offset = g_type_add_instance_private (sudoku_cell_view_type_id, sizeof (SudokuCellViewPrivate));
		g_once_init_leave (&sudoku_cell_view_type_id__volatile, sudoku_cell_view_type_id);
	}
	return sudoku_cell_view_type_id__volatile;
}


static void
_vala_sudoku_cell_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 25 "../src/sudoku-view.vala"
	switch (property_id) {
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_int (value, sudoku_cell_view_get_value (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_IS_FIXED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_is_fixed (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_show_possibilities (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_show_warnings (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_cell_view_get_selected (self));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY:
#line 3022 "sudoku-view.c"
		{
			GdkRGBA boxed;
#line 25 "../src/sudoku-view.vala"
			sudoku_cell_view_get_background_color (self, &boxed);
#line 25 "../src/sudoku-view.vala"
			g_value_set_boxed (value, &boxed);
#line 3029 "sudoku-view.c"
		}
#line 25 "../src/sudoku-view.vala"
		break;
#line 3033 "sudoku-view.c"
		default:
#line 25 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/sudoku-view.vala"
		break;
#line 3039 "sudoku-view.c"
	}
}


static void
_vala_sudoku_cell_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	SudokuCellView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL_VIEW, SudokuCellView);
#line 25 "../src/sudoku-view.vala"
	switch (property_id) {
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_VALUE_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_value (self, g_value_get_int (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SHOW_WARNINGS_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_show_warnings (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_SELECTED_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_selected (self, g_value_get_boolean (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 25 "../src/sudoku-view.vala"
		case SUDOKU_CELL_VIEW_BACKGROUND_COLOR_PROPERTY:
#line 25 "../src/sudoku-view.vala"
		sudoku_cell_view_set_background_color (self, g_value_get_boxed (value));
#line 25 "../src/sudoku-view.vala"
		break;
#line 3084 "sudoku-view.c"
		default:
#line 25 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../src/sudoku-view.vala"
		break;
#line 3090 "sudoku-view.c"
	}
}


static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}


static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	SudokuCellView** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCellView* _tmp3_;
	SudokuCellView** _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint _tmp6_;
	SudokuCellView* _tmp7_;
	SudokuCellView** _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gint _tmp9_;
	gint _tmp10_;
	SudokuCellView* _tmp11_;
#line 461 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->cells;
#line 463 "../src/sudoku-view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 463 "../src/sudoku-view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 463 "../src/sudoku-view.vala"
	_tmp1_ = self->priv->selected_row;
#line 463 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->selected_col;
#line 463 "../src/sudoku-view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 463 "../src/sudoku-view.vala"
	sudoku_cell_view_set_selected (_tmp3_, FALSE);
#line 464 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->cells;
#line 464 "../src/sudoku-view.vala"
	_tmp4__length1 = self->priv->cells_length1;
#line 464 "../src/sudoku-view.vala"
	_tmp4__length2 = self->priv->cells_length2;
#line 464 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->selected_row;
#line 464 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->selected_col;
#line 464 "../src/sudoku-view.vala"
	_tmp7_ = _tmp4_[(_tmp5_ * _tmp4__length2) + _tmp6_];
#line 464 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp7_);
#line 465 "../src/sudoku-view.vala"
	self->priv->selected_row = cell_row;
#line 466 "../src/sudoku-view.vala"
	self->priv->selected_col = cell_col;
#line 467 "../src/sudoku-view.vala"
	_tmp8_ = self->priv->cells;
#line 467 "../src/sudoku-view.vala"
	_tmp8__length1 = self->priv->cells_length1;
#line 467 "../src/sudoku-view.vala"
	_tmp8__length2 = self->priv->cells_length2;
#line 467 "../src/sudoku-view.vala"
	_tmp9_ = self->priv->selected_row;
#line 467 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->selected_col;
#line 467 "../src/sudoku-view.vala"
	_tmp11_ = _tmp8_[(_tmp9_ * _tmp8__length2) + _tmp10_];
#line 467 "../src/sudoku-view.vala"
	sudoku_cell_view_set_selected (_tmp11_, TRUE);
#line 3173 "sudoku-view.c"
}


static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 470 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 470 "../src/sudoku-view.vala"
	return _data7_;
#line 3184 "sudoku-view.c"
}


static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 470 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 3195 "sudoku-view.c"
		SudokuView* self;
#line 470 "../src/sudoku-view.vala"
		self = _data7_->self;
#line 470 "../src/sudoku-view.vala"
		_g_object_unref0 (_data7_->game);
#line 470 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 470 "../src/sudoku-view.vala"
		g_slice_free (Block7Data, _data7_);
#line 3205 "sudoku-view.c"
	}
}


static gboolean
_sudoku_view_draw_board_gtk_widget_draw (GtkWidget* _sender,
                                         cairo_t* cr,
                                         gpointer self)
{
	gboolean result;
	result = sudoku_view_draw_board ((SudokuView*) self, cr);
#line 480 "../src/sudoku-view.vala"
	return result;
#line 3219 "sudoku-view.c"
}


static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 496 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 496 "../src/sudoku-view.vala"
	return _data8_;
#line 3230 "sudoku-view.c"
}


static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 496 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 3241 "sudoku-view.c"
		SudokuView* self;
#line 496 "../src/sudoku-view.vala"
		self = _data8_->_data7_->self;
#line 496 "../src/sudoku-view.vala"
		block7_data_unref (_data8_->_data7_);
#line 496 "../src/sudoku-view.vala"
		_data8_->_data7_ = NULL;
#line 496 "../src/sudoku-view.vala"
		g_slice_free (Block8Data, _data8_);
#line 3251 "sudoku-view.c"
	}
}


static gboolean
________lambda13_ (Block8Data* _data8_)
{
	Block7Data* _data7_;
	SudokuView* self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	SudokuCellView** _tmp106_;
	gint _tmp106__length1;
	gint _tmp106__length2;
	gint _tmp107_;
	gint _tmp108_;
	SudokuCellView* _tmp109_;
#line 504 "../src/sudoku-view.vala"
	_data7_ = _data8_->_data7_;
#line 504 "../src/sudoku-view.vala"
	self = _data7_->self;
#line 505 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data7_->game);
#line 505 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 505 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 506 "../src/sudoku-view.vala"
		result = FALSE;
#line 506 "../src/sudoku-view.vala"
		return result;
#line 3286 "sudoku-view.c"
	}
#line 508 "../src/sudoku-view.vala"
	_tmp2_ = _data8_->cell_row;
#line 508 "../src/sudoku-view.vala"
	_tmp3_ = _data8_->cell_col;
#line 508 "../src/sudoku-view.vala"
	sudoku_view_set_selected (self, _tmp2_, _tmp3_);
#line 3294 "sudoku-view.c"
	{
		gint col_tmp = 0;
#line 510 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 3299 "sudoku-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 510 "../src/sudoku-view.vala"
			_tmp4_ = TRUE;
#line 510 "../src/sudoku-view.vala"
			while (TRUE) {
#line 3306 "sudoku-view.c"
				gint _tmp6_;
				SudokuBoard* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				GdkRGBA _tmp10_ = {0};
				gboolean _tmp11_ = FALSE;
				gint _tmp12_;
				gint _tmp13_;
				GdkRGBA color = {0};
#line 510 "../src/sudoku-view.vala"
				if (!_tmp4_) {
#line 3318 "sudoku-view.c"
					gint _tmp5_;
#line 510 "../src/sudoku-view.vala"
					_tmp5_ = col_tmp;
#line 510 "../src/sudoku-view.vala"
					col_tmp = _tmp5_ + 1;
#line 3324 "sudoku-view.c"
				}
#line 510 "../src/sudoku-view.vala"
				_tmp4_ = FALSE;
#line 510 "../src/sudoku-view.vala"
				_tmp6_ = col_tmp;
#line 510 "../src/sudoku-view.vala"
				_tmp7_ = _data7_->game->board;
#line 510 "../src/sudoku-view.vala"
				_tmp8_ = sudoku_board_get_cols (_tmp7_);
#line 510 "../src/sudoku-view.vala"
				_tmp9_ = _tmp8_;
#line 510 "../src/sudoku-view.vala"
				if (!(_tmp6_ < _tmp9_)) {
#line 510 "../src/sudoku-view.vala"
					break;
#line 3340 "sudoku-view.c"
				}
#line 512 "../src/sudoku-view.vala"
				_tmp12_ = col_tmp;
#line 512 "../src/sudoku-view.vala"
				_tmp13_ = _data8_->cell_col;
#line 512 "../src/sudoku-view.vala"
				if (_tmp12_ == _tmp13_) {
#line 3348 "sudoku-view.c"
					gboolean _tmp14_;
#line 512 "../src/sudoku-view.vala"
					_tmp14_ = self->priv->_highlighter;
#line 512 "../src/sudoku-view.vala"
					_tmp11_ = _tmp14_;
#line 3354 "sudoku-view.c"
				} else {
#line 512 "../src/sudoku-view.vala"
					_tmp11_ = FALSE;
#line 3358 "sudoku-view.c"
				}
#line 512 "../src/sudoku-view.vala"
				if (_tmp11_) {
#line 512 "../src/sudoku-view.vala"
					_tmp10_ = highlight_color;
#line 3364 "sudoku-view.c"
				} else {
#line 512 "../src/sudoku-view.vala"
					_tmp10_ = free_cell_color;
#line 3368 "sudoku-view.c"
				}
#line 512 "../src/sudoku-view.vala"
				color = _tmp10_;
#line 3372 "sudoku-view.c"
				{
					gint row_tmp = 0;
#line 513 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 3377 "sudoku-view.c"
					{
						gboolean _tmp15_ = FALSE;
#line 513 "../src/sudoku-view.vala"
						_tmp15_ = TRUE;
#line 513 "../src/sudoku-view.vala"
						while (TRUE) {
#line 3384 "sudoku-view.c"
							gint _tmp17_;
							SudokuBoard* _tmp18_;
							gint _tmp19_;
							gint _tmp20_;
							GdkRGBA _tmp21_ = {0};
							SudokuCellView** _tmp22_;
							gint _tmp22__length1;
							gint _tmp22__length2;
							gint _tmp23_;
							gint _tmp24_;
							SudokuCellView* _tmp25_;
							gboolean _tmp26_;
							gboolean _tmp27_;
							SudokuCellView** _tmp29_;
							gint _tmp29__length1;
							gint _tmp29__length2;
							gint _tmp30_;
							gint _tmp31_;
							SudokuCellView* _tmp32_;
#line 513 "../src/sudoku-view.vala"
							if (!_tmp15_) {
#line 3406 "sudoku-view.c"
								gint _tmp16_;
#line 513 "../src/sudoku-view.vala"
								_tmp16_ = row_tmp;
#line 513 "../src/sudoku-view.vala"
								row_tmp = _tmp16_ + 1;
#line 3412 "sudoku-view.c"
							}
#line 513 "../src/sudoku-view.vala"
							_tmp15_ = FALSE;
#line 513 "../src/sudoku-view.vala"
							_tmp17_ = row_tmp;
#line 513 "../src/sudoku-view.vala"
							_tmp18_ = _data7_->game->board;
#line 513 "../src/sudoku-view.vala"
							_tmp19_ = sudoku_board_get_rows (_tmp18_);
#line 513 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_;
#line 513 "../src/sudoku-view.vala"
							if (!(_tmp17_ < _tmp20_)) {
#line 513 "../src/sudoku-view.vala"
								break;
#line 3428 "sudoku-view.c"
							}
#line 514 "../src/sudoku-view.vala"
							_tmp22_ = self->priv->cells;
#line 514 "../src/sudoku-view.vala"
							_tmp22__length1 = self->priv->cells_length1;
#line 514 "../src/sudoku-view.vala"
							_tmp22__length2 = self->priv->cells_length2;
#line 514 "../src/sudoku-view.vala"
							_tmp23_ = row_tmp;
#line 514 "../src/sudoku-view.vala"
							_tmp24_ = col_tmp;
#line 514 "../src/sudoku-view.vala"
							_tmp25_ = _tmp22_[(_tmp23_ * _tmp22__length2) + _tmp24_];
#line 514 "../src/sudoku-view.vala"
							_tmp26_ = sudoku_cell_view_get_is_fixed (_tmp25_);
#line 514 "../src/sudoku-view.vala"
							_tmp27_ = _tmp26_;
#line 514 "../src/sudoku-view.vala"
							if (_tmp27_) {
#line 514 "../src/sudoku-view.vala"
								_tmp21_ = fixed_cell_color;
#line 3450 "sudoku-view.c"
							} else {
								GdkRGBA _tmp28_;
#line 514 "../src/sudoku-view.vala"
								_tmp28_ = color;
#line 514 "../src/sudoku-view.vala"
								_tmp21_ = _tmp28_;
#line 3457 "sudoku-view.c"
							}
#line 514 "../src/sudoku-view.vala"
							_tmp29_ = self->priv->cells;
#line 514 "../src/sudoku-view.vala"
							_tmp29__length1 = self->priv->cells_length1;
#line 514 "../src/sudoku-view.vala"
							_tmp29__length2 = self->priv->cells_length2;
#line 514 "../src/sudoku-view.vala"
							_tmp30_ = row_tmp;
#line 514 "../src/sudoku-view.vala"
							_tmp31_ = col_tmp;
#line 514 "../src/sudoku-view.vala"
							_tmp32_ = _tmp29_[(_tmp30_ * _tmp29__length2) + _tmp31_];
#line 514 "../src/sudoku-view.vala"
							sudoku_cell_view_set_background_color (_tmp32_, &_tmp21_);
#line 3473 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
	{
		gint col_tmp = 0;
#line 516 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 3484 "sudoku-view.c"
		{
			gboolean _tmp33_ = FALSE;
#line 516 "../src/sudoku-view.vala"
			_tmp33_ = TRUE;
#line 516 "../src/sudoku-view.vala"
			while (TRUE) {
#line 3491 "sudoku-view.c"
				gint _tmp35_;
				SudokuBoard* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				SudokuCellView** _tmp39_;
				gint _tmp39__length1;
				gint _tmp39__length2;
				gint _tmp40_;
				gint _tmp41_;
				SudokuCellView* _tmp42_;
				gboolean _tmp43_;
				gboolean _tmp44_;
#line 516 "../src/sudoku-view.vala"
				if (!_tmp33_) {
#line 3506 "sudoku-view.c"
					gint _tmp34_;
#line 516 "../src/sudoku-view.vala"
					_tmp34_ = col_tmp;
#line 516 "../src/sudoku-view.vala"
					col_tmp = _tmp34_ + 1;
#line 3512 "sudoku-view.c"
				}
#line 516 "../src/sudoku-view.vala"
				_tmp33_ = FALSE;
#line 516 "../src/sudoku-view.vala"
				_tmp35_ = col_tmp;
#line 516 "../src/sudoku-view.vala"
				_tmp36_ = _data7_->game->board;
#line 516 "../src/sudoku-view.vala"
				_tmp37_ = sudoku_board_get_cols (_tmp36_);
#line 516 "../src/sudoku-view.vala"
				_tmp38_ = _tmp37_;
#line 516 "../src/sudoku-view.vala"
				if (!(_tmp35_ < _tmp38_)) {
#line 516 "../src/sudoku-view.vala"
					break;
#line 3528 "sudoku-view.c"
				}
#line 518 "../src/sudoku-view.vala"
				_tmp39_ = self->priv->cells;
#line 518 "../src/sudoku-view.vala"
				_tmp39__length1 = self->priv->cells_length1;
#line 518 "../src/sudoku-view.vala"
				_tmp39__length2 = self->priv->cells_length2;
#line 518 "../src/sudoku-view.vala"
				_tmp40_ = _data8_->cell_row;
#line 518 "../src/sudoku-view.vala"
				_tmp41_ = col_tmp;
#line 518 "../src/sudoku-view.vala"
				_tmp42_ = _tmp39_[(_tmp40_ * _tmp39__length2) + _tmp41_];
#line 518 "../src/sudoku-view.vala"
				_tmp43_ = sudoku_cell_view_get_is_fixed (_tmp42_);
#line 518 "../src/sudoku-view.vala"
				_tmp44_ = _tmp43_;
#line 518 "../src/sudoku-view.vala"
				if (_tmp44_) {
#line 3548 "sudoku-view.c"
					SudokuCellView** _tmp45_;
					gint _tmp45__length1;
					gint _tmp45__length2;
					gint _tmp46_;
					gint _tmp47_;
					SudokuCellView* _tmp48_;
#line 519 "../src/sudoku-view.vala"
					_tmp45_ = self->priv->cells;
#line 519 "../src/sudoku-view.vala"
					_tmp45__length1 = self->priv->cells_length1;
#line 519 "../src/sudoku-view.vala"
					_tmp45__length2 = self->priv->cells_length2;
#line 519 "../src/sudoku-view.vala"
					_tmp46_ = _data8_->cell_row;
#line 519 "../src/sudoku-view.vala"
					_tmp47_ = col_tmp;
#line 519 "../src/sudoku-view.vala"
					_tmp48_ = _tmp45_[(_tmp46_ * _tmp45__length2) + _tmp47_];
#line 519 "../src/sudoku-view.vala"
					sudoku_cell_view_set_background_color (_tmp48_, &fixed_cell_color);
#line 3569 "sudoku-view.c"
				} else {
					gboolean _tmp49_;
#line 520 "../src/sudoku-view.vala"
					_tmp49_ = self->priv->_highlighter;
#line 520 "../src/sudoku-view.vala"
					if (_tmp49_) {
#line 3576 "sudoku-view.c"
						SudokuCellView** _tmp50_;
						gint _tmp50__length1;
						gint _tmp50__length2;
						gint _tmp51_;
						gint _tmp52_;
						SudokuCellView* _tmp53_;
#line 521 "../src/sudoku-view.vala"
						_tmp50_ = self->priv->cells;
#line 521 "../src/sudoku-view.vala"
						_tmp50__length1 = self->priv->cells_length1;
#line 521 "../src/sudoku-view.vala"
						_tmp50__length2 = self->priv->cells_length2;
#line 521 "../src/sudoku-view.vala"
						_tmp51_ = _data8_->cell_row;
#line 521 "../src/sudoku-view.vala"
						_tmp52_ = col_tmp;
#line 521 "../src/sudoku-view.vala"
						_tmp53_ = _tmp50_[(_tmp51_ * _tmp50__length2) + _tmp52_];
#line 521 "../src/sudoku-view.vala"
						sudoku_cell_view_set_background_color (_tmp53_, &highlight_color);
#line 3597 "sudoku-view.c"
					} else {
						SudokuCellView** _tmp54_;
						gint _tmp54__length1;
						gint _tmp54__length2;
						gint _tmp55_;
						gint _tmp56_;
						SudokuCellView* _tmp57_;
#line 523 "../src/sudoku-view.vala"
						_tmp54_ = self->priv->cells;
#line 523 "../src/sudoku-view.vala"
						_tmp54__length1 = self->priv->cells_length1;
#line 523 "../src/sudoku-view.vala"
						_tmp54__length2 = self->priv->cells_length2;
#line 523 "../src/sudoku-view.vala"
						_tmp55_ = _data8_->cell_row;
#line 523 "../src/sudoku-view.vala"
						_tmp56_ = col_tmp;
#line 523 "../src/sudoku-view.vala"
						_tmp57_ = _tmp54_[(_tmp55_ * _tmp54__length2) + _tmp56_];
#line 523 "../src/sudoku-view.vala"
						sudoku_cell_view_set_background_color (_tmp57_, &free_cell_color);
#line 3619 "sudoku-view.c"
					}
				}
			}
		}
	}
	{
		GeeList* _coord_list = NULL;
		SudokuBoard* _tmp58_;
		GeeMap* _tmp59_;
		gint _tmp60_;
		SudokuBoard* _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
		gint _tmp64_;
		SudokuBoard* _tmp65_;
		gint _tmp66_;
		gint _tmp67_;
		Coord _tmp68_ = {0};
		gpointer _tmp69_;
		gint _coord_size = 0;
		GeeList* _tmp70_;
		gint _tmp71_;
		gint _tmp72_;
		gint _coord_index = 0;
#line 526 "../src/sudoku-view.vala"
		_tmp58_ = _data7_->game->board;
#line 526 "../src/sudoku-view.vala"
		_tmp59_ = _tmp58_->coords_for_block;
#line 526 "../src/sudoku-view.vala"
		_tmp60_ = _data8_->cell_row;
#line 526 "../src/sudoku-view.vala"
		_tmp61_ = _data7_->game->board;
#line 526 "../src/sudoku-view.vala"
		_tmp62_ = sudoku_board_get_block_rows (_tmp61_);
#line 526 "../src/sudoku-view.vala"
		_tmp63_ = _tmp62_;
#line 526 "../src/sudoku-view.vala"
		_tmp64_ = _data8_->cell_col;
#line 526 "../src/sudoku-view.vala"
		_tmp65_ = _data7_->game->board;
#line 526 "../src/sudoku-view.vala"
		_tmp66_ = sudoku_board_get_block_cols (_tmp65_);
#line 526 "../src/sudoku-view.vala"
		_tmp67_ = _tmp66_;
#line 526 "../src/sudoku-view.vala"
		coord_init (&_tmp68_, _tmp60_ / _tmp63_, _tmp64_ / _tmp67_);
#line 526 "../src/sudoku-view.vala"
		_tmp69_ = gee_map_get (_tmp59_, &_tmp68_);
#line 526 "../src/sudoku-view.vala"
		_coord_list = (GeeList*) _tmp69_;
#line 526 "../src/sudoku-view.vala"
		_tmp70_ = _coord_list;
#line 526 "../src/sudoku-view.vala"
		_tmp71_ = gee_collection_get_size ((GeeCollection*) _tmp70_);
#line 526 "../src/sudoku-view.vala"
		_tmp72_ = _tmp71_;
#line 526 "../src/sudoku-view.vala"
		_coord_size = _tmp72_;
#line 526 "../src/sudoku-view.vala"
		_coord_index = -1;
#line 526 "../src/sudoku-view.vala"
		while (TRUE) {
#line 3682 "sudoku-view.c"
			gint _tmp73_;
			gint _tmp74_;
			gint _tmp75_;
			Coord* coord = NULL;
			GeeList* _tmp76_;
			gint _tmp77_;
			gpointer _tmp78_;
			SudokuCellView** _tmp79_;
			gint _tmp79__length1;
			gint _tmp79__length2;
			Coord* _tmp80_;
			gint _tmp81_;
			Coord* _tmp82_;
			gint _tmp83_;
			SudokuCellView* _tmp84_;
			gboolean _tmp85_;
			gboolean _tmp86_;
#line 526 "../src/sudoku-view.vala"
			_tmp73_ = _coord_index;
#line 526 "../src/sudoku-view.vala"
			_coord_index = _tmp73_ + 1;
#line 526 "../src/sudoku-view.vala"
			_tmp74_ = _coord_index;
#line 526 "../src/sudoku-view.vala"
			_tmp75_ = _coord_size;
#line 526 "../src/sudoku-view.vala"
			if (!(_tmp74_ < _tmp75_)) {
#line 526 "../src/sudoku-view.vala"
				break;
#line 3712 "sudoku-view.c"
			}
#line 526 "../src/sudoku-view.vala"
			_tmp76_ = _coord_list;
#line 526 "../src/sudoku-view.vala"
			_tmp77_ = _coord_index;
#line 526 "../src/sudoku-view.vala"
			_tmp78_ = gee_list_get (_tmp76_, _tmp77_);
#line 526 "../src/sudoku-view.vala"
			coord = (Coord*) _tmp78_;
#line 528 "../src/sudoku-view.vala"
			_tmp79_ = self->priv->cells;
#line 528 "../src/sudoku-view.vala"
			_tmp79__length1 = self->priv->cells_length1;
#line 528 "../src/sudoku-view.vala"
			_tmp79__length2 = self->priv->cells_length2;
#line 528 "../src/sudoku-view.vala"
			_tmp80_ = coord;
#line 528 "../src/sudoku-view.vala"
			_tmp81_ = (*_tmp80_).row;
#line 528 "../src/sudoku-view.vala"
			_tmp82_ = coord;
#line 528 "../src/sudoku-view.vala"
			_tmp83_ = (*_tmp82_).col;
#line 528 "../src/sudoku-view.vala"
			_tmp84_ = _tmp79_[(_tmp81_ * _tmp79__length2) + _tmp83_];
#line 528 "../src/sudoku-view.vala"
			_tmp85_ = sudoku_cell_view_get_is_fixed (_tmp84_);
#line 528 "../src/sudoku-view.vala"
			_tmp86_ = _tmp85_;
#line 528 "../src/sudoku-view.vala"
			if (_tmp86_) {
#line 3744 "sudoku-view.c"
				SudokuCellView** _tmp87_;
				gint _tmp87__length1;
				gint _tmp87__length2;
				Coord* _tmp88_;
				gint _tmp89_;
				Coord* _tmp90_;
				gint _tmp91_;
				SudokuCellView* _tmp92_;
#line 529 "../src/sudoku-view.vala"
				_tmp87_ = self->priv->cells;
#line 529 "../src/sudoku-view.vala"
				_tmp87__length1 = self->priv->cells_length1;
#line 529 "../src/sudoku-view.vala"
				_tmp87__length2 = self->priv->cells_length2;
#line 529 "../src/sudoku-view.vala"
				_tmp88_ = coord;
#line 529 "../src/sudoku-view.vala"
				_tmp89_ = (*_tmp88_).row;
#line 529 "../src/sudoku-view.vala"
				_tmp90_ = coord;
#line 529 "../src/sudoku-view.vala"
				_tmp91_ = (*_tmp90_).col;
#line 529 "../src/sudoku-view.vala"
				_tmp92_ = _tmp87_[(_tmp89_ * _tmp87__length2) + _tmp91_];
#line 529 "../src/sudoku-view.vala"
				sudoku_cell_view_set_background_color (_tmp92_, &fixed_cell_color);
#line 3771 "sudoku-view.c"
			} else {
				gboolean _tmp93_;
#line 530 "../src/sudoku-view.vala"
				_tmp93_ = self->priv->_highlighter;
#line 530 "../src/sudoku-view.vala"
				if (_tmp93_) {
#line 3778 "sudoku-view.c"
					SudokuCellView** _tmp94_;
					gint _tmp94__length1;
					gint _tmp94__length2;
					Coord* _tmp95_;
					gint _tmp96_;
					Coord* _tmp97_;
					gint _tmp98_;
					SudokuCellView* _tmp99_;
#line 531 "../src/sudoku-view.vala"
					_tmp94_ = self->priv->cells;
#line 531 "../src/sudoku-view.vala"
					_tmp94__length1 = self->priv->cells_length1;
#line 531 "../src/sudoku-view.vala"
					_tmp94__length2 = self->priv->cells_length2;
#line 531 "../src/sudoku-view.vala"
					_tmp95_ = coord;
#line 531 "../src/sudoku-view.vala"
					_tmp96_ = (*_tmp95_).row;
#line 531 "../src/sudoku-view.vala"
					_tmp97_ = coord;
#line 531 "../src/sudoku-view.vala"
					_tmp98_ = (*_tmp97_).col;
#line 531 "../src/sudoku-view.vala"
					_tmp99_ = _tmp94_[(_tmp96_ * _tmp94__length2) + _tmp98_];
#line 531 "../src/sudoku-view.vala"
					sudoku_cell_view_set_background_color (_tmp99_, &highlight_color);
#line 3805 "sudoku-view.c"
				} else {
					SudokuCellView** _tmp100_;
					gint _tmp100__length1;
					gint _tmp100__length2;
					Coord* _tmp101_;
					gint _tmp102_;
					Coord* _tmp103_;
					gint _tmp104_;
					SudokuCellView* _tmp105_;
#line 533 "../src/sudoku-view.vala"
					_tmp100_ = self->priv->cells;
#line 533 "../src/sudoku-view.vala"
					_tmp100__length1 = self->priv->cells_length1;
#line 533 "../src/sudoku-view.vala"
					_tmp100__length2 = self->priv->cells_length2;
#line 533 "../src/sudoku-view.vala"
					_tmp101_ = coord;
#line 533 "../src/sudoku-view.vala"
					_tmp102_ = (*_tmp101_).row;
#line 533 "../src/sudoku-view.vala"
					_tmp103_ = coord;
#line 533 "../src/sudoku-view.vala"
					_tmp104_ = (*_tmp103_).col;
#line 533 "../src/sudoku-view.vala"
					_tmp105_ = _tmp100_[(_tmp102_ * _tmp100__length2) + _tmp104_];
#line 533 "../src/sudoku-view.vala"
					sudoku_cell_view_set_background_color (_tmp105_, &free_cell_color);
#line 3833 "sudoku-view.c"
				}
			}
#line 526 "../src/sudoku-view.vala"
			_g_free0 (coord);
#line 3838 "sudoku-view.c"
		}
#line 526 "../src/sudoku-view.vala"
		_g_object_unref0 (_coord_list);
#line 3842 "sudoku-view.c"
	}
#line 536 "../src/sudoku-view.vala"
	_tmp106_ = self->priv->cells;
#line 536 "../src/sudoku-view.vala"
	_tmp106__length1 = self->priv->cells_length1;
#line 536 "../src/sudoku-view.vala"
	_tmp106__length2 = self->priv->cells_length2;
#line 536 "../src/sudoku-view.vala"
	_tmp107_ = _data8_->cell_row;
#line 536 "../src/sudoku-view.vala"
	_tmp108_ = _data8_->cell_col;
#line 536 "../src/sudoku-view.vala"
	_tmp109_ = _tmp106_[(_tmp107_ * _tmp106__length2) + _tmp108_];
#line 536 "../src/sudoku-view.vala"
	sudoku_cell_view_set_background_color (_tmp109_, &selected_bg_color);
#line 538 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 540 "../src/sudoku-view.vala"
	result = FALSE;
#line 540 "../src/sudoku-view.vala"
	return result;
#line 3864 "sudoku-view.c"
}


static gboolean
_________lambda13__gtk_widget_focus_in_event (GtkWidget* _sender,
                                              GdkEventFocus* event,
                                              gpointer self)
{
	gboolean result;
	result = ________lambda13_ (self);
#line 504 "../src/sudoku-view.vala"
	return result;
#line 3877 "sudoku-view.c"
}


static void
________lambda14_ (Block8Data* _data8_,
                   GObject* s,
                   GParamSpec* p)
{
	Block7Data* _data7_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
#line 543 "../src/sudoku-view.vala"
	_data7_ = _data8_->_data7_;
#line 543 "../src/sudoku-view.vala"
	self = _data7_->self;
#line 543 "../src/sudoku-view.vala"
	g_return_if_fail (s != NULL);
#line 543 "../src/sudoku-view.vala"
	g_return_if_fail (p != NULL);
#line 544 "../src/sudoku-view.vala"
	_tmp3_ = self->priv->_show_possibilities;
#line 544 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 544 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 3906 "sudoku-view.c"
	} else {
		gboolean _tmp4_;
#line 544 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->_show_warnings;
#line 544 "../src/sudoku-view.vala"
		_tmp2_ = _tmp4_;
#line 3913 "sudoku-view.c"
	}
#line 544 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 544 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 3919 "sudoku-view.c"
	} else {
		SudokuBoard* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 544 "../src/sudoku-view.vala"
		_tmp5_ = _data7_->game->board;
#line 544 "../src/sudoku-view.vala"
		_tmp6_ = sudoku_board_get_broken (_tmp5_);
#line 544 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_;
#line 544 "../src/sudoku-view.vala"
		_tmp1_ = _tmp7_;
#line 3932 "sudoku-view.c"
	}
#line 544 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 544 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 3938 "sudoku-view.c"
	} else {
		gboolean _tmp8_;
#line 544 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->previous_board_broken_state;
#line 544 "../src/sudoku-view.vala"
		_tmp0_ = _tmp8_;
#line 3945 "sudoku-view.c"
	}
#line 544 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 3949 "sudoku-view.c"
		SudokuBoard* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 545 "../src/sudoku-view.vala"
		_tmp9_ = _data7_->game->board;
#line 545 "../src/sudoku-view.vala"
		_tmp10_ = sudoku_board_get_broken (_tmp9_);
#line 545 "../src/sudoku-view.vala"
		_tmp11_ = _tmp10_;
#line 545 "../src/sudoku-view.vala"
		self->priv->previous_board_broken_state = _tmp11_;
#line 3961 "sudoku-view.c"
	}
#line 548 "../src/sudoku-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 3965 "sudoku-view.c"
}


static void
_________lambda14__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 543 "../src/sudoku-view.vala"
	________lambda14_ (self, _sender, pspec);
#line 3976 "sudoku-view.c"
}


SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block7Data* _data7_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	GtkOverlay* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkDrawingArea* _tmp4_;
	GtkGrid* _tmp5_;
	SudokuGame* _tmp8_;
	GtkGrid* _tmp9_;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	SudokuBoard* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	SudokuBoard* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	SudokuCellView** _tmp20_;
	GtkOverlay* _tmp55_;
	GtkDrawingArea* _tmp56_;
	GtkOverlay* _tmp57_;
	GtkGrid* _tmp58_;
	GtkDrawingArea* _tmp59_;
	GtkGrid* _tmp60_;
	GtkOverlay* _tmp61_;
#line 470 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 470 "../src/sudoku-view.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 470 "../src/sudoku-view.vala"
	_data7_->_ref_count_ = 1;
#line 470 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 470 "../src/sudoku-view.vala"
	_g_object_unref0 (_data7_->game);
#line 470 "../src/sudoku-view.vala"
	_data7_->game = _tmp0_;
#line 470 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 470 "../src/sudoku-view.vala"
	_data7_->self = g_object_ref (self);
#line 472 "../src/sudoku-view.vala"
	gtk_frame_set_shadow_type ((GtkFrame*) self, GTK_SHADOW_NONE);
#line 473 "../src/sudoku-view.vala"
	g_object_set ((GtkAspectFrame*) self, "obey-child", FALSE, NULL);
#line 474 "../src/sudoku-view.vala"
	g_object_set ((GtkAspectFrame*) self, "ratio", (gfloat) 1, NULL);
#line 476 "../src/sudoku-view.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 476 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 476 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 476 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp1_;
#line 477 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->overlay;
#line 477 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 479 "../src/sudoku-view.vala"
	_tmp3_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 479 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 479 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->drawing);
#line 479 "../src/sudoku-view.vala"
	self->priv->drawing = _tmp3_;
#line 480 "../src/sudoku-view.vala"
	_tmp4_ = self->priv->drawing;
#line 480 "../src/sudoku-view.vala"
	g_signal_connect_object ((GtkWidget*) _tmp4_, "draw", (GCallback) _sudoku_view_draw_board_gtk_widget_draw, self, 0);
#line 482 "../src/sudoku-view.vala"
	_tmp5_ = self->priv->grid;
#line 482 "../src/sudoku-view.vala"
	if (_tmp5_ != NULL) {
#line 4062 "sudoku-view.c"
		GtkOverlay* _tmp6_;
		GtkGrid* _tmp7_;
#line 483 "../src/sudoku-view.vala"
		_tmp6_ = self->priv->overlay;
#line 483 "../src/sudoku-view.vala"
		_tmp7_ = self->priv->grid;
#line 483 "../src/sudoku-view.vala"
		gtk_container_remove ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
#line 4071 "sudoku-view.c"
	}
#line 485 "../src/sudoku-view.vala"
	_tmp8_ = _g_object_ref0 (_data7_->game);
#line 485 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 485 "../src/sudoku-view.vala"
	self->game = _tmp8_;
#line 487 "../src/sudoku-view.vala"
	_tmp9_ = (GtkGrid*) gtk_grid_new ();
#line 487 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp9_);
#line 487 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 487 "../src/sudoku-view.vala"
	self->priv->grid = _tmp9_;
#line 488 "../src/sudoku-view.vala"
	_tmp10_ = self->priv->grid;
#line 488 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp10_, 1);
#line 489 "../src/sudoku-view.vala"
	_tmp11_ = self->priv->grid;
#line 489 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp11_, 1);
#line 490 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->grid;
#line 490 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp12_, TRUE);
#line 491 "../src/sudoku-view.vala"
	_tmp13_ = self->priv->grid;
#line 491 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp13_, TRUE);
#line 493 "../src/sudoku-view.vala"
	_tmp14_ = _data7_->game->board;
#line 493 "../src/sudoku-view.vala"
	_tmp15_ = sudoku_board_get_rows (_tmp14_);
#line 493 "../src/sudoku-view.vala"
	_tmp16_ = _tmp15_;
#line 493 "../src/sudoku-view.vala"
	_tmp17_ = _data7_->game->board;
#line 493 "../src/sudoku-view.vala"
	_tmp18_ = sudoku_board_get_cols (_tmp17_);
#line 493 "../src/sudoku-view.vala"
	_tmp19_ = _tmp18_;
#line 493 "../src/sudoku-view.vala"
	_tmp20_ = g_new0 (SudokuCellView*, (_tmp16_ * _tmp19_) + 1);
#line 493 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 493 "../src/sudoku-view.vala"
	self->priv->cells = _tmp20_;
#line 493 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp16_;
#line 493 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp19_;
#line 4125 "sudoku-view.c"
	{
		gint row = 0;
#line 494 "../src/sudoku-view.vala"
		row = 0;
#line 4130 "sudoku-view.c"
		{
			gboolean _tmp21_ = FALSE;
#line 494 "../src/sudoku-view.vala"
			_tmp21_ = TRUE;
#line 494 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4137 "sudoku-view.c"
				gint _tmp23_;
				SudokuBoard* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
#line 494 "../src/sudoku-view.vala"
				if (!_tmp21_) {
#line 4144 "sudoku-view.c"
					gint _tmp22_;
#line 494 "../src/sudoku-view.vala"
					_tmp22_ = row;
#line 494 "../src/sudoku-view.vala"
					row = _tmp22_ + 1;
#line 4150 "sudoku-view.c"
				}
#line 494 "../src/sudoku-view.vala"
				_tmp21_ = FALSE;
#line 494 "../src/sudoku-view.vala"
				_tmp23_ = row;
#line 494 "../src/sudoku-view.vala"
				_tmp24_ = _data7_->game->board;
#line 494 "../src/sudoku-view.vala"
				_tmp25_ = sudoku_board_get_rows (_tmp24_);
#line 494 "../src/sudoku-view.vala"
				_tmp26_ = _tmp25_;
#line 494 "../src/sudoku-view.vala"
				if (!(_tmp23_ < _tmp26_)) {
#line 494 "../src/sudoku-view.vala"
					break;
#line 4166 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 496 "../src/sudoku-view.vala"
					col = 0;
#line 4172 "sudoku-view.c"
					{
						gboolean _tmp27_ = FALSE;
#line 496 "../src/sudoku-view.vala"
						_tmp27_ = TRUE;
#line 496 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4179 "sudoku-view.c"
							Block8Data* _data8_;
							gint _tmp29_;
							SudokuBoard* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							SudokuCellView* cell = NULL;
							gint _tmp33_;
							gint _tmp34_;
							SudokuCellView* _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
							GdkRGBA _tmp38_ = {0};
							SudokuCellView* _tmp39_;
							gboolean _tmp40_;
							gboolean _tmp41_;
							SudokuCellView* _tmp42_;
							SudokuCellView* _tmp43_;
							SudokuCellView* _tmp44_;
							SudokuCellView** _tmp45_;
							gint _tmp45__length1;
							gint _tmp45__length2;
							gint _tmp46_;
							gint _tmp47_;
							SudokuCellView* _tmp48_;
							SudokuCellView* _tmp49_;
							SudokuCellView* _tmp50_;
							GtkGrid* _tmp51_;
							SudokuCellView* _tmp52_;
							gint _tmp53_;
							gint _tmp54_;
#line 496 "../src/sudoku-view.vala"
							_data8_ = g_slice_new0 (Block8Data);
#line 496 "../src/sudoku-view.vala"
							_data8_->_ref_count_ = 1;
#line 496 "../src/sudoku-view.vala"
							_data8_->_data7_ = block7_data_ref (_data7_);
#line 496 "../src/sudoku-view.vala"
							if (!_tmp27_) {
#line 4218 "sudoku-view.c"
								gint _tmp28_;
#line 496 "../src/sudoku-view.vala"
								_tmp28_ = col;
#line 496 "../src/sudoku-view.vala"
								col = _tmp28_ + 1;
#line 4224 "sudoku-view.c"
							}
#line 496 "../src/sudoku-view.vala"
							_tmp27_ = FALSE;
#line 496 "../src/sudoku-view.vala"
							_tmp29_ = col;
#line 496 "../src/sudoku-view.vala"
							_tmp30_ = _data7_->game->board;
#line 496 "../src/sudoku-view.vala"
							_tmp31_ = sudoku_board_get_cols (_tmp30_);
#line 496 "../src/sudoku-view.vala"
							_tmp32_ = _tmp31_;
#line 496 "../src/sudoku-view.vala"
							if (!(_tmp29_ < _tmp32_)) {
#line 496 "../src/sudoku-view.vala"
								block8_data_unref (_data8_);
#line 496 "../src/sudoku-view.vala"
								_data8_ = NULL;
#line 496 "../src/sudoku-view.vala"
								break;
#line 4244 "sudoku-view.c"
							}
#line 498 "../src/sudoku-view.vala"
							_tmp33_ = row;
#line 498 "../src/sudoku-view.vala"
							_tmp34_ = col;
#line 498 "../src/sudoku-view.vala"
							_tmp35_ = sudoku_cell_view_new (_tmp33_, _tmp34_, &self->game);
#line 498 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp35_);
#line 498 "../src/sudoku-view.vala"
							cell = _tmp35_;
#line 499 "../src/sudoku-view.vala"
							_tmp36_ = row;
#line 499 "../src/sudoku-view.vala"
							_data8_->cell_row = _tmp36_;
#line 500 "../src/sudoku-view.vala"
							_tmp37_ = col;
#line 500 "../src/sudoku-view.vala"
							_data8_->cell_col = _tmp37_;
#line 502 "../src/sudoku-view.vala"
							_tmp39_ = cell;
#line 502 "../src/sudoku-view.vala"
							_tmp40_ = sudoku_cell_view_get_is_fixed (_tmp39_);
#line 502 "../src/sudoku-view.vala"
							_tmp41_ = _tmp40_;
#line 502 "../src/sudoku-view.vala"
							if (_tmp41_) {
#line 502 "../src/sudoku-view.vala"
								_tmp38_ = fixed_cell_color;
#line 4274 "sudoku-view.c"
							} else {
#line 502 "../src/sudoku-view.vala"
								_tmp38_ = free_cell_color;
#line 4278 "sudoku-view.c"
							}
#line 502 "../src/sudoku-view.vala"
							_tmp42_ = cell;
#line 502 "../src/sudoku-view.vala"
							sudoku_cell_view_set_background_color (_tmp42_, &_tmp38_);
#line 504 "../src/sudoku-view.vala"
							_tmp43_ = cell;
#line 504 "../src/sudoku-view.vala"
							g_signal_connect_data ((GtkWidget*) _tmp43_, "focus-in-event", (GCallback) _________lambda13__gtk_widget_focus_in_event, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 543 "../src/sudoku-view.vala"
							_tmp44_ = cell;
#line 543 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp44_, "notify::value", (GCallback) _________lambda14__g_object_notify, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 551 "../src/sudoku-view.vala"
							_tmp45_ = self->priv->cells;
#line 551 "../src/sudoku-view.vala"
							_tmp45__length1 = self->priv->cells_length1;
#line 551 "../src/sudoku-view.vala"
							_tmp45__length2 = self->priv->cells_length2;
#line 551 "../src/sudoku-view.vala"
							_tmp46_ = row;
#line 551 "../src/sudoku-view.vala"
							_tmp47_ = col;
#line 551 "../src/sudoku-view.vala"
							_tmp48_ = cell;
#line 551 "../src/sudoku-view.vala"
							_tmp49_ = _g_object_ref0 (_tmp48_);
#line 551 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp45_[(_tmp46_ * _tmp45__length2) + _tmp47_]);
#line 551 "../src/sudoku-view.vala"
							_tmp45_[(_tmp46_ * _tmp45__length2) + _tmp47_] = _tmp49_;
#line 551 "../src/sudoku-view.vala"
							_tmp50_ = _tmp45_[(_tmp46_ * _tmp45__length2) + _tmp47_];
#line 552 "../src/sudoku-view.vala"
							_tmp51_ = self->priv->grid;
#line 552 "../src/sudoku-view.vala"
							_tmp52_ = cell;
#line 552 "../src/sudoku-view.vala"
							_tmp53_ = col;
#line 552 "../src/sudoku-view.vala"
							_tmp54_ = row;
#line 552 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp51_, (GtkWidget*) _tmp52_, _tmp53_, _tmp54_, 1, 1);
#line 496 "../src/sudoku-view.vala"
							_g_object_unref0 (cell);
#line 496 "../src/sudoku-view.vala"
							block8_data_unref (_data8_);
#line 496 "../src/sudoku-view.vala"
							_data8_ = NULL;
#line 4328 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 556 "../src/sudoku-view.vala"
	_tmp55_ = self->priv->overlay;
#line 556 "../src/sudoku-view.vala"
	_tmp56_ = self->priv->drawing;
#line 556 "../src/sudoku-view.vala"
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 557 "../src/sudoku-view.vala"
	_tmp57_ = self->priv->overlay;
#line 557 "../src/sudoku-view.vala"
	_tmp58_ = self->priv->grid;
#line 557 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp57_, (GtkWidget*) _tmp58_);
#line 558 "../src/sudoku-view.vala"
	_tmp59_ = self->priv->drawing;
#line 558 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp59_);
#line 559 "../src/sudoku-view.vala"
	_tmp60_ = self->priv->grid;
#line 559 "../src/sudoku-view.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp60_);
#line 560 "../src/sudoku-view.vala"
	_tmp61_ = self->priv->overlay;
#line 560 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp61_);
#line 470 "../src/sudoku-view.vala"
	block7_data_unref (_data7_);
#line 470 "../src/sudoku-view.vala"
	_data7_ = NULL;
#line 470 "../src/sudoku-view.vala"
	return self;
#line 4365 "sudoku-view.c"
}


SudokuView*
sudoku_view_new (SudokuGame* game)
{
#line 470 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game);
#line 4374 "sudoku-view.c"
}


static gboolean
sudoku_view_draw_board (SudokuView* self,
                        cairo_t* c)
{
	gboolean result = FALSE;
	gint board_length = 0;
	GtkGrid* _tmp0_;
	gdouble tile_length = 0.0;
	gint _tmp1_;
	SudokuGame* _tmp2_;
	SudokuBoard* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	SudokuGame* _tmp107_;
	gboolean _tmp108_;
	gboolean _tmp109_;
#line 563 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 563 "../src/sudoku-view.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 565 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->grid;
#line 565 "../src/sudoku-view.vala"
	board_length = gtk_widget_get_allocated_width ((GtkWidget*) _tmp0_);
#line 567 "../src/sudoku-view.vala"
	_tmp1_ = board_length;
#line 567 "../src/sudoku-view.vala"
	_tmp2_ = self->game;
#line 567 "../src/sudoku-view.vala"
	_tmp3_ = _tmp2_->board;
#line 567 "../src/sudoku-view.vala"
	_tmp4_ = sudoku_board_get_cols (_tmp3_);
#line 567 "../src/sudoku-view.vala"
	_tmp5_ = _tmp4_;
#line 567 "../src/sudoku-view.vala"
	tile_length = ((gdouble) (_tmp1_ - 1)) / _tmp5_;
#line 569 "../src/sudoku-view.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 4416 "sudoku-view.c"
		gint _tmp6_;
#line 571 "../src/sudoku-view.vala"
		_tmp6_ = board_length;
#line 571 "../src/sudoku-view.vala"
		cairo_translate (c, (gdouble) _tmp6_, (gdouble) 0);
#line 572 "../src/sudoku-view.vala"
		cairo_scale (c, (gdouble) -1, (gdouble) 1);
#line 4424 "sudoku-view.c"
	}
	{
		gint i = 0;
#line 576 "../src/sudoku-view.vala"
		i = 0;
#line 4430 "sudoku-view.c"
		{
			gboolean _tmp7_ = FALSE;
#line 576 "../src/sudoku-view.vala"
			_tmp7_ = TRUE;
#line 576 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4437 "sudoku-view.c"
				gint _tmp9_;
				SudokuGame* _tmp10_;
				SudokuBoard* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
#line 576 "../src/sudoku-view.vala"
				if (!_tmp7_) {
#line 4445 "sudoku-view.c"
					gint _tmp8_;
#line 576 "../src/sudoku-view.vala"
					_tmp8_ = i;
#line 576 "../src/sudoku-view.vala"
					i = _tmp8_ + 1;
#line 4451 "sudoku-view.c"
				}
#line 576 "../src/sudoku-view.vala"
				_tmp7_ = FALSE;
#line 576 "../src/sudoku-view.vala"
				_tmp9_ = i;
#line 576 "../src/sudoku-view.vala"
				_tmp10_ = self->game;
#line 576 "../src/sudoku-view.vala"
				_tmp11_ = _tmp10_->board;
#line 576 "../src/sudoku-view.vala"
				_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 576 "../src/sudoku-view.vala"
				_tmp13_ = _tmp12_;
#line 576 "../src/sudoku-view.vala"
				if (!(_tmp9_ < _tmp13_)) {
#line 576 "../src/sudoku-view.vala"
					break;
#line 4469 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 578 "../src/sudoku-view.vala"
					j = 0;
#line 4475 "sudoku-view.c"
					{
						gboolean _tmp14_ = FALSE;
#line 578 "../src/sudoku-view.vala"
						_tmp14_ = TRUE;
#line 578 "../src/sudoku-view.vala"
						while (TRUE) {
#line 4482 "sudoku-view.c"
							gint _tmp16_;
							SudokuGame* _tmp17_;
							SudokuBoard* _tmp18_;
							gint _tmp19_;
							gint _tmp20_;
							GdkRGBA background_color = {0};
							SudokuCellView** _tmp21_;
							gint _tmp21__length1;
							gint _tmp21__length2;
							gint _tmp22_;
							gint _tmp23_;
							SudokuCellView* _tmp24_;
							GdkRGBA _tmp25_ = {0};
							GdkRGBA _tmp26_;
							GdkRGBA _tmp27_;
							gdouble _tmp28_;
							GdkRGBA _tmp29_;
							gdouble _tmp30_;
							GdkRGBA _tmp31_;
							gdouble _tmp32_;
							gint _tmp33_;
							gdouble _tmp34_;
							gint _tmp35_;
							gdouble _tmp36_;
							gint _tmp37_;
							gdouble _tmp38_;
							gint _tmp39_;
							gdouble _tmp40_;
#line 578 "../src/sudoku-view.vala"
							if (!_tmp14_) {
#line 4513 "sudoku-view.c"
								gint _tmp15_;
#line 578 "../src/sudoku-view.vala"
								_tmp15_ = j;
#line 578 "../src/sudoku-view.vala"
								j = _tmp15_ + 1;
#line 4519 "sudoku-view.c"
							}
#line 578 "../src/sudoku-view.vala"
							_tmp14_ = FALSE;
#line 578 "../src/sudoku-view.vala"
							_tmp16_ = j;
#line 578 "../src/sudoku-view.vala"
							_tmp17_ = self->game;
#line 578 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_->board;
#line 578 "../src/sudoku-view.vala"
							_tmp19_ = sudoku_board_get_cols (_tmp18_);
#line 578 "../src/sudoku-view.vala"
							_tmp20_ = _tmp19_;
#line 578 "../src/sudoku-view.vala"
							if (!(_tmp16_ < _tmp20_)) {
#line 578 "../src/sudoku-view.vala"
								break;
#line 4537 "sudoku-view.c"
							}
#line 580 "../src/sudoku-view.vala"
							_tmp21_ = self->priv->cells;
#line 580 "../src/sudoku-view.vala"
							_tmp21__length1 = self->priv->cells_length1;
#line 580 "../src/sudoku-view.vala"
							_tmp21__length2 = self->priv->cells_length2;
#line 580 "../src/sudoku-view.vala"
							_tmp22_ = i;
#line 580 "../src/sudoku-view.vala"
							_tmp23_ = j;
#line 580 "../src/sudoku-view.vala"
							_tmp24_ = _tmp21_[(_tmp22_ * _tmp21__length2) + _tmp23_];
#line 580 "../src/sudoku-view.vala"
							sudoku_cell_view_get_background_color (_tmp24_, &_tmp25_);
#line 580 "../src/sudoku-view.vala"
							_tmp26_ = _tmp25_;
#line 580 "../src/sudoku-view.vala"
							background_color = _tmp26_;
#line 581 "../src/sudoku-view.vala"
							_tmp27_ = background_color;
#line 581 "../src/sudoku-view.vala"
							_tmp28_ = _tmp27_.red;
#line 581 "../src/sudoku-view.vala"
							_tmp29_ = background_color;
#line 581 "../src/sudoku-view.vala"
							_tmp30_ = _tmp29_.green;
#line 581 "../src/sudoku-view.vala"
							_tmp31_ = background_color;
#line 581 "../src/sudoku-view.vala"
							_tmp32_ = _tmp31_.blue;
#line 581 "../src/sudoku-view.vala"
							cairo_set_source_rgb (c, _tmp28_, _tmp30_, _tmp32_);
#line 583 "../src/sudoku-view.vala"
							_tmp33_ = j;
#line 583 "../src/sudoku-view.vala"
							_tmp34_ = tile_length;
#line 583 "../src/sudoku-view.vala"
							_tmp35_ = i;
#line 583 "../src/sudoku-view.vala"
							_tmp36_ = tile_length;
#line 583 "../src/sudoku-view.vala"
							_tmp37_ = j;
#line 583 "../src/sudoku-view.vala"
							_tmp38_ = tile_length;
#line 583 "../src/sudoku-view.vala"
							_tmp39_ = i;
#line 583 "../src/sudoku-view.vala"
							_tmp40_ = tile_length;
#line 583 "../src/sudoku-view.vala"
							cairo_rectangle (c, ((gint) (_tmp33_ * _tmp34_)) + 0.5, ((gint) (_tmp35_ * _tmp36_)) + 0.5, ((gint) ((_tmp37_ + 1) * _tmp38_)) + 0.5, ((gint) ((_tmp39_ + 1) * _tmp40_)) + 0.5);
#line 584 "../src/sudoku-view.vala"
							cairo_fill (c);
#line 4591 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 588 "../src/sudoku-view.vala"
	cairo_set_line_width (c, (gdouble) 1);
#line 589 "../src/sudoku-view.vala"
	cairo_set_source_rgb (c, 0.6, 0.6, 0.6);
#line 4602 "sudoku-view.c"
	{
		gint i = 0;
#line 590 "../src/sudoku-view.vala"
		i = 1;
#line 4607 "sudoku-view.c"
		{
			gboolean _tmp41_ = FALSE;
#line 590 "../src/sudoku-view.vala"
			_tmp41_ = TRUE;
#line 590 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4614 "sudoku-view.c"
				gint _tmp43_;
				SudokuGame* _tmp44_;
				SudokuBoard* _tmp45_;
				gint _tmp46_;
				gint _tmp47_;
				gint _tmp48_;
				SudokuGame* _tmp49_;
				SudokuBoard* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
				gint _tmp53_;
				gdouble _tmp54_;
				gint _tmp55_;
				gdouble _tmp56_;
				gint _tmp57_;
#line 590 "../src/sudoku-view.vala"
				if (!_tmp41_) {
#line 4632 "sudoku-view.c"
					gint _tmp42_;
#line 590 "../src/sudoku-view.vala"
					_tmp42_ = i;
#line 590 "../src/sudoku-view.vala"
					i = _tmp42_ + 1;
#line 4638 "sudoku-view.c"
				}
#line 590 "../src/sudoku-view.vala"
				_tmp41_ = FALSE;
#line 590 "../src/sudoku-view.vala"
				_tmp43_ = i;
#line 590 "../src/sudoku-view.vala"
				_tmp44_ = self->game;
#line 590 "../src/sudoku-view.vala"
				_tmp45_ = _tmp44_->board;
#line 590 "../src/sudoku-view.vala"
				_tmp46_ = sudoku_board_get_cols (_tmp45_);
#line 590 "../src/sudoku-view.vala"
				_tmp47_ = _tmp46_;
#line 590 "../src/sudoku-view.vala"
				if (!(_tmp43_ < _tmp47_)) {
#line 590 "../src/sudoku-view.vala"
					break;
#line 4656 "sudoku-view.c"
				}
#line 592 "../src/sudoku-view.vala"
				_tmp48_ = i;
#line 592 "../src/sudoku-view.vala"
				_tmp49_ = self->game;
#line 592 "../src/sudoku-view.vala"
				_tmp50_ = _tmp49_->board;
#line 592 "../src/sudoku-view.vala"
				_tmp51_ = sudoku_board_get_block_cols (_tmp50_);
#line 592 "../src/sudoku-view.vala"
				_tmp52_ = _tmp51_;
#line 592 "../src/sudoku-view.vala"
				if ((_tmp48_ % _tmp52_) == 0) {
#line 593 "../src/sudoku-view.vala"
					continue;
#line 4672 "sudoku-view.c"
				}
#line 595 "../src/sudoku-view.vala"
				_tmp53_ = i;
#line 595 "../src/sudoku-view.vala"
				_tmp54_ = tile_length;
#line 595 "../src/sudoku-view.vala"
				cairo_move_to (c, ((gint) (_tmp53_ * _tmp54_)) + 0.5, (gdouble) 1);
#line 596 "../src/sudoku-view.vala"
				_tmp55_ = i;
#line 596 "../src/sudoku-view.vala"
				_tmp56_ = tile_length;
#line 596 "../src/sudoku-view.vala"
				_tmp57_ = board_length;
#line 596 "../src/sudoku-view.vala"
				cairo_line_to (c, ((gint) (_tmp55_ * _tmp56_)) + 0.5, (gdouble) _tmp57_);
#line 4688 "sudoku-view.c"
			}
		}
	}
	{
		gint i = 0;
#line 598 "../src/sudoku-view.vala"
		i = 1;
#line 4696 "sudoku-view.c"
		{
			gboolean _tmp58_ = FALSE;
#line 598 "../src/sudoku-view.vala"
			_tmp58_ = TRUE;
#line 598 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4703 "sudoku-view.c"
				gint _tmp60_;
				SudokuGame* _tmp61_;
				SudokuBoard* _tmp62_;
				gint _tmp63_;
				gint _tmp64_;
				gint _tmp65_;
				SudokuGame* _tmp66_;
				SudokuBoard* _tmp67_;
				gint _tmp68_;
				gint _tmp69_;
				gint _tmp70_;
				gdouble _tmp71_;
				gint _tmp72_;
				gint _tmp73_;
				gdouble _tmp74_;
#line 598 "../src/sudoku-view.vala"
				if (!_tmp58_) {
#line 4721 "sudoku-view.c"
					gint _tmp59_;
#line 598 "../src/sudoku-view.vala"
					_tmp59_ = i;
#line 598 "../src/sudoku-view.vala"
					i = _tmp59_ + 1;
#line 4727 "sudoku-view.c"
				}
#line 598 "../src/sudoku-view.vala"
				_tmp58_ = FALSE;
#line 598 "../src/sudoku-view.vala"
				_tmp60_ = i;
#line 598 "../src/sudoku-view.vala"
				_tmp61_ = self->game;
#line 598 "../src/sudoku-view.vala"
				_tmp62_ = _tmp61_->board;
#line 598 "../src/sudoku-view.vala"
				_tmp63_ = sudoku_board_get_cols (_tmp62_);
#line 598 "../src/sudoku-view.vala"
				_tmp64_ = _tmp63_;
#line 598 "../src/sudoku-view.vala"
				if (!(_tmp60_ < _tmp64_)) {
#line 598 "../src/sudoku-view.vala"
					break;
#line 4745 "sudoku-view.c"
				}
#line 600 "../src/sudoku-view.vala"
				_tmp65_ = i;
#line 600 "../src/sudoku-view.vala"
				_tmp66_ = self->game;
#line 600 "../src/sudoku-view.vala"
				_tmp67_ = _tmp66_->board;
#line 600 "../src/sudoku-view.vala"
				_tmp68_ = sudoku_board_get_block_rows (_tmp67_);
#line 600 "../src/sudoku-view.vala"
				_tmp69_ = _tmp68_;
#line 600 "../src/sudoku-view.vala"
				if ((_tmp65_ % _tmp69_) == 0) {
#line 601 "../src/sudoku-view.vala"
					continue;
#line 4761 "sudoku-view.c"
				}
#line 603 "../src/sudoku-view.vala"
				_tmp70_ = i;
#line 603 "../src/sudoku-view.vala"
				_tmp71_ = tile_length;
#line 603 "../src/sudoku-view.vala"
				cairo_move_to (c, (gdouble) 1, ((gint) (_tmp70_ * _tmp71_)) + 0.5);
#line 604 "../src/sudoku-view.vala"
				_tmp72_ = board_length;
#line 604 "../src/sudoku-view.vala"
				_tmp73_ = i;
#line 604 "../src/sudoku-view.vala"
				_tmp74_ = tile_length;
#line 604 "../src/sudoku-view.vala"
				cairo_line_to (c, (gdouble) _tmp72_, ((gint) (_tmp73_ * _tmp74_)) + 0.5);
#line 4777 "sudoku-view.c"
			}
		}
	}
#line 606 "../src/sudoku-view.vala"
	cairo_stroke (c);
#line 608 "../src/sudoku-view.vala"
	cairo_set_line_width (c, (gdouble) 2);
#line 609 "../src/sudoku-view.vala"
	cairo_set_source_rgb (c, 0.0, 0.0, 0.0);
#line 4787 "sudoku-view.c"
	{
		gint i = 0;
#line 610 "../src/sudoku-view.vala"
		i = 0;
#line 4792 "sudoku-view.c"
		{
			gboolean _tmp75_ = FALSE;
#line 610 "../src/sudoku-view.vala"
			_tmp75_ = TRUE;
#line 610 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4799 "sudoku-view.c"
				gint _tmp81_;
				SudokuGame* _tmp82_;
				SudokuBoard* _tmp83_;
				gint _tmp84_;
				gint _tmp85_;
				gint _tmp86_;
				gdouble _tmp87_;
				gint _tmp88_;
				gdouble _tmp89_;
				gint _tmp90_;
#line 610 "../src/sudoku-view.vala"
				if (!_tmp75_) {
#line 4812 "sudoku-view.c"
					gint _tmp76_;
					SudokuGame* _tmp77_;
					SudokuBoard* _tmp78_;
					gint _tmp79_;
					gint _tmp80_;
#line 610 "../src/sudoku-view.vala"
					_tmp76_ = i;
#line 610 "../src/sudoku-view.vala"
					_tmp77_ = self->game;
#line 610 "../src/sudoku-view.vala"
					_tmp78_ = _tmp77_->board;
#line 610 "../src/sudoku-view.vala"
					_tmp79_ = sudoku_board_get_block_cols (_tmp78_);
#line 610 "../src/sudoku-view.vala"
					_tmp80_ = _tmp79_;
#line 610 "../src/sudoku-view.vala"
					i = _tmp76_ + _tmp80_;
#line 4830 "sudoku-view.c"
				}
#line 610 "../src/sudoku-view.vala"
				_tmp75_ = FALSE;
#line 610 "../src/sudoku-view.vala"
				_tmp81_ = i;
#line 610 "../src/sudoku-view.vala"
				_tmp82_ = self->game;
#line 610 "../src/sudoku-view.vala"
				_tmp83_ = _tmp82_->board;
#line 610 "../src/sudoku-view.vala"
				_tmp84_ = sudoku_board_get_cols (_tmp83_);
#line 610 "../src/sudoku-view.vala"
				_tmp85_ = _tmp84_;
#line 610 "../src/sudoku-view.vala"
				if (!(_tmp81_ <= _tmp85_)) {
#line 610 "../src/sudoku-view.vala"
					break;
#line 4848 "sudoku-view.c"
				}
#line 612 "../src/sudoku-view.vala"
				_tmp86_ = i;
#line 612 "../src/sudoku-view.vala"
				_tmp87_ = tile_length;
#line 612 "../src/sudoku-view.vala"
				cairo_move_to (c, ((gint) (_tmp86_ * _tmp87_)) + 0.5, (gdouble) 0);
#line 613 "../src/sudoku-view.vala"
				_tmp88_ = i;
#line 613 "../src/sudoku-view.vala"
				_tmp89_ = tile_length;
#line 613 "../src/sudoku-view.vala"
				_tmp90_ = board_length;
#line 613 "../src/sudoku-view.vala"
				cairo_line_to (c, ((gint) (_tmp88_ * _tmp89_)) + 0.5, (gdouble) _tmp90_);
#line 4864 "sudoku-view.c"
			}
		}
	}
	{
		gint i = 0;
#line 615 "../src/sudoku-view.vala"
		i = 0;
#line 4872 "sudoku-view.c"
		{
			gboolean _tmp91_ = FALSE;
#line 615 "../src/sudoku-view.vala"
			_tmp91_ = TRUE;
#line 615 "../src/sudoku-view.vala"
			while (TRUE) {
#line 4879 "sudoku-view.c"
				gint _tmp97_;
				SudokuGame* _tmp98_;
				SudokuBoard* _tmp99_;
				gint _tmp100_;
				gint _tmp101_;
				gint _tmp102_;
				gdouble _tmp103_;
				gint _tmp104_;
				gint _tmp105_;
				gdouble _tmp106_;
#line 615 "../src/sudoku-view.vala"
				if (!_tmp91_) {
#line 4892 "sudoku-view.c"
					gint _tmp92_;
					SudokuGame* _tmp93_;
					SudokuBoard* _tmp94_;
					gint _tmp95_;
					gint _tmp96_;
#line 615 "../src/sudoku-view.vala"
					_tmp92_ = i;
#line 615 "../src/sudoku-view.vala"
					_tmp93_ = self->game;
#line 615 "../src/sudoku-view.vala"
					_tmp94_ = _tmp93_->board;
#line 615 "../src/sudoku-view.vala"
					_tmp95_ = sudoku_board_get_block_rows (_tmp94_);
#line 615 "../src/sudoku-view.vala"
					_tmp96_ = _tmp95_;
#line 615 "../src/sudoku-view.vala"
					i = _tmp92_ + _tmp96_;
#line 4910 "sudoku-view.c"
				}
#line 615 "../src/sudoku-view.vala"
				_tmp91_ = FALSE;
#line 615 "../src/sudoku-view.vala"
				_tmp97_ = i;
#line 615 "../src/sudoku-view.vala"
				_tmp98_ = self->game;
#line 615 "../src/sudoku-view.vala"
				_tmp99_ = _tmp98_->board;
#line 615 "../src/sudoku-view.vala"
				_tmp100_ = sudoku_board_get_cols (_tmp99_);
#line 615 "../src/sudoku-view.vala"
				_tmp101_ = _tmp100_;
#line 615 "../src/sudoku-view.vala"
				if (!(_tmp97_ <= _tmp101_)) {
#line 615 "../src/sudoku-view.vala"
					break;
#line 4928 "sudoku-view.c"
				}
#line 617 "../src/sudoku-view.vala"
				_tmp102_ = i;
#line 617 "../src/sudoku-view.vala"
				_tmp103_ = tile_length;
#line 617 "../src/sudoku-view.vala"
				cairo_move_to (c, (gdouble) 0, ((gint) (_tmp102_ * _tmp103_)) + 0.5);
#line 618 "../src/sudoku-view.vala"
				_tmp104_ = board_length;
#line 618 "../src/sudoku-view.vala"
				_tmp105_ = i;
#line 618 "../src/sudoku-view.vala"
				_tmp106_ = tile_length;
#line 618 "../src/sudoku-view.vala"
				cairo_line_to (c, (gdouble) _tmp104_, ((gint) (_tmp105_ * _tmp106_)) + 0.5);
#line 4944 "sudoku-view.c"
			}
		}
	}
#line 620 "../src/sudoku-view.vala"
	cairo_stroke (c);
#line 622 "../src/sudoku-view.vala"
	_tmp107_ = self->game;
#line 622 "../src/sudoku-view.vala"
	_tmp108_ = sudoku_game_get_paused (_tmp107_);
#line 622 "../src/sudoku-view.vala"
	_tmp109_ = _tmp108_;
#line 622 "../src/sudoku-view.vala"
	if (_tmp109_) {
#line 4958 "sudoku-view.c"
		gchar* text = NULL;
		gchar* _tmp110_;
		cairo_text_extents_t extents = {0};
		const gchar* _tmp111_;
		cairo_text_extents_t _tmp112_ = {0};
		gint _tmp113_;
		cairo_text_extents_t _tmp114_;
		gdouble _tmp115_;
		gint _tmp116_;
		cairo_text_extents_t _tmp117_;
		gdouble _tmp118_;
		const gchar* _tmp119_;
#line 624 "../src/sudoku-view.vala"
		cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
#line 625 "../src/sudoku-view.vala"
		cairo_paint (c);
#line 627 "../src/sudoku-view.vala"
		cairo_select_font_face (c, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 628 "../src/sudoku-view.vala"
		cairo_set_font_size (c, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
#line 631 "../src/sudoku-view.vala"
		_tmp110_ = g_strdup (_ ("Paused"));
#line 631 "../src/sudoku-view.vala"
		text = _tmp110_;
#line 633 "../src/sudoku-view.vala"
		_tmp111_ = text;
#line 633 "../src/sudoku-view.vala"
		cairo_text_extents (c, _tmp111_, &_tmp112_);
#line 633 "../src/sudoku-view.vala"
		extents = _tmp112_;
#line 634 "../src/sudoku-view.vala"
		_tmp113_ = board_length;
#line 634 "../src/sudoku-view.vala"
		_tmp114_ = extents;
#line 634 "../src/sudoku-view.vala"
		_tmp115_ = _tmp114_.width;
#line 634 "../src/sudoku-view.vala"
		_tmp116_ = board_length;
#line 634 "../src/sudoku-view.vala"
		_tmp117_ = extents;
#line 634 "../src/sudoku-view.vala"
		_tmp118_ = _tmp117_.height;
#line 634 "../src/sudoku-view.vala"
		cairo_move_to (c, (_tmp113_ / 2.0) - (_tmp115_ / 2.0), (_tmp116_ / 2.0) + (_tmp118_ / 2.0));
#line 635 "../src/sudoku-view.vala"
		cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 636 "../src/sudoku-view.vala"
		_tmp119_ = text;
#line 636 "../src/sudoku-view.vala"
		cairo_show_text (c, _tmp119_);
#line 622 "../src/sudoku-view.vala"
		_g_free0 (text);
#line 5011 "sudoku-view.c"
	}
#line 639 "../src/sudoku-view.vala"
	result = FALSE;
#line 639 "../src/sudoku-view.vala"
	return result;
#line 5017 "sudoku-view.c"
}


void
sudoku_view_clear (SudokuView* self)
{
#line 642 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 5026 "sudoku-view.c"
	{
		gint i = 0;
#line 644 "../src/sudoku-view.vala"
		i = 0;
#line 5031 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 644 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 644 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5038 "sudoku-view.c"
				gint _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 644 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5046 "sudoku-view.c"
					gint _tmp1_;
#line 644 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 644 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5052 "sudoku-view.c"
				}
#line 644 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 644 "../src/sudoku-view.vala"
				_tmp2_ = i;
#line 644 "../src/sudoku-view.vala"
				_tmp3_ = self->game;
#line 644 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_->board;
#line 644 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 644 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 644 "../src/sudoku-view.vala"
				if (!(_tmp2_ < _tmp6_)) {
#line 644 "../src/sudoku-view.vala"
					break;
#line 5070 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 645 "../src/sudoku-view.vala"
					j = 0;
#line 5076 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 645 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 645 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5083 "sudoku-view.c"
							gint _tmp9_;
							SudokuGame* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCellView** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							gint _tmp15_;
							gint _tmp16_;
							SudokuCellView* _tmp17_;
#line 645 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 5097 "sudoku-view.c"
								gint _tmp8_;
#line 645 "../src/sudoku-view.vala"
								_tmp8_ = j;
#line 645 "../src/sudoku-view.vala"
								j = _tmp8_ + 1;
#line 5103 "sudoku-view.c"
							}
#line 645 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 645 "../src/sudoku-view.vala"
							_tmp9_ = j;
#line 645 "../src/sudoku-view.vala"
							_tmp10_ = self->game;
#line 645 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_->board;
#line 645 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 645 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 645 "../src/sudoku-view.vala"
							if (!(_tmp9_ < _tmp13_)) {
#line 645 "../src/sudoku-view.vala"
								break;
#line 5121 "sudoku-view.c"
							}
#line 646 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 646 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 646 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 646 "../src/sudoku-view.vala"
							_tmp15_ = i;
#line 646 "../src/sudoku-view.vala"
							_tmp16_ = j;
#line 646 "../src/sudoku-view.vala"
							_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
#line 646 "../src/sudoku-view.vala"
							sudoku_cell_view_clear (_tmp17_);
#line 5137 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}


gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 652 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 652 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_show_warnings;
#line 652 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 652 "../src/sudoku-view.vala"
	return result;
#line 5160 "sudoku-view.c"
}


void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
#line 653 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 654 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 5172 "sudoku-view.c"
	{
		gint i = 0;
#line 655 "../src/sudoku-view.vala"
		i = 0;
#line 5177 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 655 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 655 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5184 "sudoku-view.c"
				gint _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 655 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5192 "sudoku-view.c"
					gint _tmp1_;
#line 655 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 655 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5198 "sudoku-view.c"
				}
#line 655 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 655 "../src/sudoku-view.vala"
				_tmp2_ = i;
#line 655 "../src/sudoku-view.vala"
				_tmp3_ = self->game;
#line 655 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_->board;
#line 655 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 655 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 655 "../src/sudoku-view.vala"
				if (!(_tmp2_ < _tmp6_)) {
#line 655 "../src/sudoku-view.vala"
					break;
#line 5216 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 656 "../src/sudoku-view.vala"
					j = 0;
#line 5222 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 656 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 656 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5229 "sudoku-view.c"
							gint _tmp9_;
							SudokuGame* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCellView** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							gint _tmp15_;
							gint _tmp16_;
							SudokuCellView* _tmp17_;
							gboolean _tmp18_;
#line 656 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 5244 "sudoku-view.c"
								gint _tmp8_;
#line 656 "../src/sudoku-view.vala"
								_tmp8_ = j;
#line 656 "../src/sudoku-view.vala"
								j = _tmp8_ + 1;
#line 5250 "sudoku-view.c"
							}
#line 656 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 656 "../src/sudoku-view.vala"
							_tmp9_ = j;
#line 656 "../src/sudoku-view.vala"
							_tmp10_ = self->game;
#line 656 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_->board;
#line 656 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 656 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 656 "../src/sudoku-view.vala"
							if (!(_tmp9_ < _tmp13_)) {
#line 656 "../src/sudoku-view.vala"
								break;
#line 5268 "sudoku-view.c"
							}
#line 657 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 657 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 657 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 657 "../src/sudoku-view.vala"
							_tmp15_ = i;
#line 657 "../src/sudoku-view.vala"
							_tmp16_ = j;
#line 657 "../src/sudoku-view.vala"
							_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
#line 657 "../src/sudoku-view.vala"
							_tmp18_ = self->priv->_show_warnings;
#line 657 "../src/sudoku-view.vala"
							sudoku_cell_view_set_show_warnings (_tmp17_, _tmp18_);
#line 5286 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 653 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 5295 "sudoku-view.c"
}


gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 664 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 664 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_show_possibilities;
#line 664 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 664 "../src/sudoku-view.vala"
	return result;
#line 5312 "sudoku-view.c"
}


void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 665 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 666 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 5324 "sudoku-view.c"
	{
		gint i = 0;
#line 667 "../src/sudoku-view.vala"
		i = 0;
#line 5329 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 667 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 667 "../src/sudoku-view.vala"
			while (TRUE) {
#line 5336 "sudoku-view.c"
				gint _tmp2_;
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 667 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 5344 "sudoku-view.c"
					gint _tmp1_;
#line 667 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 667 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 5350 "sudoku-view.c"
				}
#line 667 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 667 "../src/sudoku-view.vala"
				_tmp2_ = i;
#line 667 "../src/sudoku-view.vala"
				_tmp3_ = self->game;
#line 667 "../src/sudoku-view.vala"
				_tmp4_ = _tmp3_->board;
#line 667 "../src/sudoku-view.vala"
				_tmp5_ = sudoku_board_get_rows (_tmp4_);
#line 667 "../src/sudoku-view.vala"
				_tmp6_ = _tmp5_;
#line 667 "../src/sudoku-view.vala"
				if (!(_tmp2_ < _tmp6_)) {
#line 667 "../src/sudoku-view.vala"
					break;
#line 5368 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 668 "../src/sudoku-view.vala"
					j = 0;
#line 5374 "sudoku-view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 668 "../src/sudoku-view.vala"
						_tmp7_ = TRUE;
#line 668 "../src/sudoku-view.vala"
						while (TRUE) {
#line 5381 "sudoku-view.c"
							gint _tmp9_;
							SudokuGame* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCellView** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							gint _tmp15_;
							gint _tmp16_;
							SudokuCellView* _tmp17_;
#line 668 "../src/sudoku-view.vala"
							if (!_tmp7_) {
#line 5395 "sudoku-view.c"
								gint _tmp8_;
#line 668 "../src/sudoku-view.vala"
								_tmp8_ = j;
#line 668 "../src/sudoku-view.vala"
								j = _tmp8_ + 1;
#line 5401 "sudoku-view.c"
							}
#line 668 "../src/sudoku-view.vala"
							_tmp7_ = FALSE;
#line 668 "../src/sudoku-view.vala"
							_tmp9_ = j;
#line 668 "../src/sudoku-view.vala"
							_tmp10_ = self->game;
#line 668 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_->board;
#line 668 "../src/sudoku-view.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 668 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_;
#line 668 "../src/sudoku-view.vala"
							if (!(_tmp9_ < _tmp13_)) {
#line 668 "../src/sudoku-view.vala"
								break;
#line 5419 "sudoku-view.c"
							}
#line 669 "../src/sudoku-view.vala"
							_tmp14_ = self->priv->cells;
#line 669 "../src/sudoku-view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 669 "../src/sudoku-view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 669 "../src/sudoku-view.vala"
							_tmp15_ = i;
#line 669 "../src/sudoku-view.vala"
							_tmp16_ = j;
#line 669 "../src/sudoku-view.vala"
							_tmp17_ = _tmp14_[(_tmp15_ * _tmp14__length2) + _tmp16_];
#line 669 "../src/sudoku-view.vala"
							sudoku_cell_view_set_show_possibilities (_tmp17_, value);
#line 5435 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 665 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 5444 "sudoku-view.c"
}


gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 676 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 676 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->_highlighter;
#line 676 "../src/sudoku-view.vala"
	result = _tmp0_;
#line 676 "../src/sudoku-view.vala"
	return result;
#line 5461 "sudoku-view.c"
}


void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
#line 677 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 678 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 677 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 5475 "sudoku-view.c"
}


static void
sudoku_view_class_init (SudokuViewClass * klass)
{
#line 448 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 448 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 448 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 448 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 448 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 448 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 448 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 448 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5498 "sudoku-view.c"
}


static void
sudoku_view_instance_init (SudokuView * self)
{
#line 448 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 453 "../src/sudoku-view.vala"
	self->priv->previous_board_broken_state = FALSE;
#line 459 "../src/sudoku-view.vala"
	self->priv->selected_row = 0;
#line 460 "../src/sudoku-view.vala"
	self->priv->selected_col = 0;
#line 649 "../src/sudoku-view.vala"
	self->priv->_show_warnings = FALSE;
#line 661 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = FALSE;
#line 673 "../src/sudoku-view.vala"
	self->priv->_highlighter = FALSE;
#line 5519 "sudoku-view.c"
}


static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 448 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 450 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 451 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 455 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 456 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->drawing);
#line 457 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 448 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 5541 "sudoku-view.c"
}


GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__volatile = 0;
	if (g_once_init_enter (&sudoku_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
		GType sudoku_view_type_id;
		sudoku_view_type_id = g_type_register_static (gtk_aspect_frame_get_type (), "SudokuView", &g_define_type_info, 0);
		SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
		g_once_init_leave (&sudoku_view_type_id__volatile, sudoku_view_type_id);
	}
	return sudoku_view_type_id__volatile;
}


static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 448 "../src/sudoku-view.vala"
	switch (property_id) {
#line 448 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 448 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 448 "../src/sudoku-view.vala"
		break;
#line 448 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 448 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 448 "../src/sudoku-view.vala"
		break;
#line 448 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 448 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 448 "../src/sudoku-view.vala"
		break;
#line 5588 "sudoku-view.c"
		default:
#line 448 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 448 "../src/sudoku-view.vala"
		break;
#line 5594 "sudoku-view.c"
	}
}


static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 448 "../src/sudoku-view.vala"
	switch (property_id) {
#line 448 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 448 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 448 "../src/sudoku-view.vala"
		break;
#line 448 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 448 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 448 "../src/sudoku-view.vala"
		break;
#line 448 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 448 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 448 "../src/sudoku-view.vala"
		break;
#line 5627 "sudoku-view.c"
		default:
#line 448 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 448 "../src/sudoku-view.vala"
		break;
#line 5633 "sudoku-view.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



